# System Settings

## REQ-3.Device Management

### REQ-3.6
Ethernet interfaces could be configured.

#### REQ-3.6.1
The type of LAN1 is WAN and LAN2 is LAN.

#### REQ-3.6.2
Default route is set to LAN1 while cellular connection is down.
Once cellular connection is up, the default route will be replaced by the address given by cellular-operator.

#### REQ-3.6.3
LAN1 could be set to **static IP** (IP, netmask, gateway, DNS1, and DNS2) or **DHCP client**.

#### REQ-3.6.4
LAN2 could be set to **static IP** (IP and netmask) or **DHCP client**.

#### REQ-3.6.5
~~In *Cellular Router mode*, ~~**DHCP server** could be enabled and configured on interface with *LAN* type.
Either DHCP client or DHCP server could be configured, but not at the same time.


### REQ-3.7
Cellular interfaces should be configurable.

#### REQ-3.7.1
**APN** and **PIN code** is able to be configurable.

#### REQ-3.7.2
Reconnection mechanism must be supported.

#### REQ-3.7.3
**Keepalive**, **ping target** and **ping interval** should be configurable.
  - default target: 8.8.8.8
  - default interval: 1 minute

#### REQ-3.7.4
Cellular information such as **RSSI**, **LAC**, **cell ID** should be able to log **every minute** and the logs should be kept for **7 days**.
  - ~~information should be logged into syslog~~
  - ~~default disabled~~
  - ~~log could be downloaded~~

#### ~~REQ-3.7.5~~
~~Log for cellular connection information and keeplive/reconnection should be able to download~~

#### REQ-3.7.6
**Connection status**, **APN**, **Operator name**, **signal**, **ICC-ID**, ~~**phone number**~~ and station information of ~~, **BSIC**, **TCH**, and~~ **service type** (3G or 4G) should be shown if SIM inserted and unlocked.
  - BSID is only for GSM
  - TCH not supports

#### REQ-3.7.7
**IP**, **DNS**, and **default route** should be shown while connected.

#### REQ-3.7.8
Module information such as **IMEI** should be shown if available.

#### REQ-3.7.9
The **network traffic** (byte sent / rcvd) should be shown.


### REQ-3.8
DNS could be overridden by an **alternative primary and secondary DNS** instead of WAN's configuration.


## REQ-4 Cellular Router

### REQ-4.1
Port forwarding must be provided; support maximum **10** entries.

### REQ-4.2
Each entry of port forwarding should support **port range**, **protocol** of UDP, TCP or both and **IP address**.

### REQ-4.3
**NAT** enabled by default with WAN as outgoing interface.

### REQ-4.8
Provide **10** entries for **Static NAT** with WAN as outgoing interface.

### REQ-4.9
Each entry of static NAT should support **internal IP address**, **port range**, and **protocol** of UDP, TCP or both.


## Component Test

### Components
- sanji-bundle-ethernet
- sanji-bundle-cellular
- sanji-bundle-route
- sanji-bundle-dns
- sanji-bundle-dhcpd
- sanji-bundle-iptables

### Reference
[Sanji Generic API](http://docs.sanjigeneric.apiary.io/)

## Intgration Test

Each test case is started by Web UI.
