# Cellular

## Case 1. Insert SIM card

### Pre-Conditions
1. Prepare a valid _SIM_ card (with PIN code and APN)

### Steps
1. Insert _SIM_ card
2. Navigate to `Settings`.`Cellular`

### Expect
1. Get _Signal_ and _Operator Name_ with `Chunghwa Telecom`


## Case 2. Enable cellular connection

### Pre-Conditions
1. Prepare a valid _SIM_ card (with PIN code and APN)
2. Insert the _SIM_ card

### Steps
1. Navigate to `Settings`.`Cellular` and `Edit` with
    - `Enable`
    - _APN_: `internet`
2. Click `Save`

### Expect
1. Get _IP_, _netmask_, _DNS_, and _default gateway_ within 1 minutes
   ```
   $ ip a show
   ```
2. Default gateway changed to cellular's setting
   ```
   $ ip route
   ```
3. DNS changed to cellular's settings
   ```
   $ cat /etc/resolv.conf
   ```

### Post-Conditions
- Disable cellular

## Case 3. Disable cellular connection

### Pre-Conditions
1. Prepare a valid _SIM_ card (with PIN code and APN)
2. Enable cellular connection

### Steps
1. Navigate to `Settings`.`Cellular` and `Edit` with `Disable`
2. Click `Save`

### Expect
1. IP released
2. Default gateway changed to `192.168.31.254`
   ```
   $ ip route
   ```
3. DNS changed to eth0's setting
   ```
   # /etc/resolv.conf
   nameserver 192.168.50.36
   nameserver 192.168.50.33
   ```

