# DHCP Server

## Case 1. Enable DHCP Server on LAN2

### Pre-Conditions
1. Make sure or set LAN2 as [static IP](#static-ip-for-eth1-before-test)
2. Prepare another UC-8100-LX called device A

### Steps
1. Navigate to `Settings`.`Ethernet`.`eth1`
2. Click `Edit` and select `DHCP Server`
3. Set values by [DHCP server configuration](#dhcp-server-configuration-for-test)
4. Direct connect LAN1 of device A with LAN2 of testing device, set LAN1 of
   device A as DHCP client

### Expect
1. DHCP Server should be started
   ```
   $ sudo service isc-dhcp-server status
   Status of ISC DHCP server: dhcpd is running.
   ```
2. Config `/etc/dhcp/dhcpd.conf` should contain following settings:
   ```
   subnet 192.168.4.0 netmask 255.255.255.0 {
       range 192.168.4.200 192.168.4.250;
       default-lease-time 3600;
       max-lease-time 3600;
       option domain-name-servers 8.8.8.8,8.8.4.4;
       option routers 192.168.4.127;
   }
   ```
3. Device A should has following settings with LAN1:
    - _IP_: in the range of `192.168.4.200` ~ `192.168.4.250`, normally should be
      `192.168.4.200`
    - _Netmask_: `255.255.255.0`
    - _Default route_: `192.168.4.127`
    - _DNS_: `8.8.8.8` and `8.8.4.4`


## Test Data
#### Static IP for eth1 Before Test
- _IP Address Mode_: `Static IP`
- _IP_:  `192.168.4.127`
- _Netmask_: `255.255.255.0`

#### DHCP Server Configuration for Test
- _Start IP Address_: `192.168.4.200`
- _End IP Address_: `192.168.4.250`
- _Netmask_: `255.255.255.0`
- _Lease Time_: `3600`
- _Primary DNS_: `8.8.8.8`
- _Secondary DNS1_: `8.8.4.4`

