# DNS

## Case 1. Get current DNS settings

### Pre-Conditions
1. Make sure or set LAN1 as [static IP](#static-ip-for-eth0-before-test)
2. Let Cellular disabled

### Steps
1. Navigate to `Settings`.`DNS`

### Expect
1. DNS should be `192.168.50.36` and `192.168.50.33`
2. DNS file should be:
   ```
   # /etc/resolv.conf
   nameserver 192.168.50.36
   nameserver 192.168.50.33
   ```


## Case 2. DNS updated while default route changed

### Pre-Conditions
1. Prepare a valid _SIM_ card (with PIN code and APN)
2. Insert the _SIM_ card and reboot

### Steps
1. Navigate to `Settings`.`Cellular` and `Edit` with
    - `Enable`
    - _APN_: `internet`
2. Click `Save`
3. Refresh the page until `connected`
4. Navigate to `Settings`.`DNS`

### Expect
1. DNS should be changed to the values displayed on `Cellular` page


## Case 3. Using fixed DNS

### Pre-Conditions
1. Make sure or set LAN1 as [static IP](#static-ip-for-eth0-before-test)
2. Prepare a valid _SIM_ card (with PIN code and APN)
3. Insert the _SIM_ card and reboot
4. Enable cellular

### Steps
1. Navigate to `Settings`.`DNS`, `Edit` to click `Enable Fixed DNS` and set
   Primary DNS as `8.8.8.8`, DNS2 as `8.8.4.4`
2. Click `Save`

### Expect
1. DNS should be `8.8.8.8` and `8.8.4.4`.
2. DNS file should be:
   ```
   # /etc/resolv.conf
   nameserver 8.8.8.8
   nameserver 8.8.4.4
   ```

## Test Data
#### Static IP for eth0 Before Test
- _IP Address Mode_: `Static IP`
- _IP_:  `192.168.31.38`
- _Netmask_: `255.255.255.0`
- _Gateway_: `192.168.31.254`
- _DNS 1_: `192.168.50.36`
- _DNS 2_: `192.168.50.33`

