# IPTables

## Port Mapping

### Case 1: Mapping port from wan's 8000 to internal IP's 8000 port with tcp/udp/both protocol.

**Purpose**
Verify port mapping over tcp/udp/both should work correctly.

**Environment**
- UC-8100
- Two Debian-like machines
	- Machine A: connect to UC-8100's wan and setup statuc ip 192.168.3.100
	- Machine B: connect to UC-8100's lan and setup static ip to 192.168.4.100

**Steps**
1. Add an entry name `test`, Internal IP `192.168.4.100`, Protocol tcp/udp/both, Start Port `8000`, End Port `8000`
2. On Machine B execute command with `socat - tcp-listen:8000`, `socat - udp-listen:8000` (server part)
3. On Machine A execute command with `socat - tcp-connect:192.168.3.127:8000` (client part)

**Expect**
1. Both Machine A and B should be able to communicate with each other.
2. Command `netstat-nat` should be able to indicate the currently mapping entry. (`apt-get install netstat-nat`)

## Static NAT

### Case 2: Mapping port from internal IP's 8000 to wan's 8000 port with {tcp/udp/both} protocol.

**Purpose**
Verify Static NAT over tcp/udp/both should work correctly.

**Environment**
- UC-8100
- Two Debian-like machines
	- Machine A: connect to UC-8100's wan and setup statuc ip 192.168.3.100
	- Machine B: connect to UC-8100's lan and setup static ip to 192.168.4.100

**Steps**
1. Add an entry name `test`, Internal IP `192.168.4.100`, Protocol tcp/udp/both, Port `8000`
2. On Machine A execute command with `socat -d -d -d - udp-listen:192.168.3.127:8000` (server part)
3. On Machine B execute command with `socat - udp-connect:8000,sourceport=8000` (client part)

**Expect**
1. Both Machine A and B should be able to communicate with each other.
2. Check output of Machine A's socat log, there should be connection's source port and it should exactly match Machine B socat's sourceport as configured. 
