# Relay

## REQ-4 Cellular Router

**REQ-4.5**
Support cellular (client with **UDP** or **TCP**) to serial.

In this phase only following scenario is supported:
- cellular (client UDP/TCP) <-> [uc8100 server UDP/TCP] <-> serial

**REQ-4.6**
**Baud rate**, **parity**, **stopbits**, and **databits** of serial interface for _cellular to serial_ should be able to be configured.

**REQ-4.7**
Provide 2 sets of relay settings (cellular to ethernet / cellular to serial).

## Components
- sanji-bundle-relay

## Test Cases

### 1. sanji-bundle-relay

#### Purpose
- Test UDP/TCP <--> Serial connection.
- Test 2 sets of relay could work correctly.

#### Steps
1. Use loopback to connect Serial Port 1 & 2
2. Set Relay 1 as following settings:
    - Upstream: server, udp, port 55688
    - Downstream: serial, port 1, 8-n-1
3. Set Relay 2 as following settings:
    - Upstream: server, tcp, port 55689
    - Downstream: serial, port 2, 8-n-1
4. Use PComm, create two client tcp/udp connect to UC-8100

#### Expect
1. Two clients in PComm should be able to commuicate to each other.

#### Traceability
1. REQ-4.5
2. REQ-4.6
3. REQ-4.7
