# System Settings

## REQ-3.Device Management

### REQ-3.1
System Date/Time should be able to be configured.

#### REQ-3.1.1
System Date/time can be set **manually**.

#### REQ-3.1.2
System Date/time can be updated via a **NTP** client.

#### REQ-3.1.3
Date/time can be set into system **RTC**.

#### REQ-3.1.4
**Time Zone** should be able to update.


### REQ-3.2
System should be upgraded via a firmware file.

#### REQ-3.2.4
The *red diagnosis LED will off*, *yellow and green diagnosis LEDs will blink* while upgrading.

#### REQ-3.2.5
Firmware’s file name should be **UC-8100-LX-CG_V#.#_Build_YYMMDDhhmm.frm**.

#### REQ-3.2.7
System storage should keep at least 500MB for firmware upgrading.

#### REQ-3.2.8
A firmware includes many packages, only packages with higher version are updated.

### REQ-3.3
CG can be rebooted via CG's Web.

### REQ-3.4
CG settings can be imported/exported from/to a file.

#### REQ-3.4.1
Equipment template should be able to export by selection.

#### REQ-3.4.2
Equipment templates should support multiple import.

On template name conflict, users can either overwrite or ignore the conflicting template.

#### REQ-3.4.3
Each configuration in *Settings* page should be able to be imported individually.

#### REQ-3.4.4
Support import/export for modbus framework to export equipment templates, equipment settings, and log profile settings.
   - Equipment settings and log profile settings cannot be imported without equipment templates.

### REQ-3.9
Any system configuration should be restored to Factory Default after performing reset-to-factory.

### REQ-3.10
Logging system should be provided for diagnosis; which allows user to enable or disable.

### REQ-3.11
**System logs** should be able to download for diagnosis.

#### REQ-3.11.1
Each boot and reboot should be traceable from system logs.

#### REQ-3.11.2
Logs should be kept for **7 days**.


### REQ-3.12
Password for web account must able to be modified.

### REQ-3.13
SSH server should be able to be enabled or disabled; enabled by default.

### REQ-3.14
Mode for *Modbus Framework* or *Cellular Router* should be and only could be selectable once, at first boot.

### REQ-3.15
Web could be accessed via LAN by default; an option should be provided to enable WAN accessibility.

### REQ-3.16
Able to view disk usages of **secondary storages** (such as SD card and USB storage).

### REQ-3.17
Basic system information such as **software version**, **uptime**, and **disk usage** should be provided.

### REQ-3.18
**Hostname** should be able to modified.

### REQ-3.19
The **mode** of serial port 1 and 2 should be able to configured to **RS232**, **RS485-2W**, or **RS422/RS485-4W**.


## Component Test

### Components
- uc8100-cg-upgrade-utility
- sanji-bundle-status
- sanji-bundle-time
- sanji-bundle-reboot
- sanji-bundle-importexport
- sanji-bundle-serial
- sanji-bundle-service

### Reference
[Sanji Generic API](http://docs.sanjigeneric.apiary.io/)

## Intgration Test

Each test case is started by Web UI.
