# Import/Export

## Case 1. Export configuration

### Steps
1. Navigate to `Settings`.`System`
2. Click `Export Configuration`

### Expect
1. A configuration file `config.tar.gz` asked to save
2. `config.tar.gz` includes:
   ```
   usr/lib/sanji-1.0/
   	cellular/data/cellular.json
   	dns/data/dns.json
   	ethernet/data/ethernet.json
   	logprofile/data/logprofiles.json
   	modbus/data/
   		equipments.json
   		gateway.json
   		interfaces.json
   	route/data/route.json
   	status/data/status.json
   	time/data/time.json
   ```

## Case 2. Import configuration

### Pre-Conditions
1. Export configuration, make sure the settings before export
   ([Settings](#settings-before-export))
2. Modify some settings ([Settings](#settings-after-export))

### Steps
1. Navigate to `Settings`.`System`
2. Click `Import Configuration`
3. `Choose File` for the exported `config.tar.gz`
4. Click `Upload`

### Expect
1. System reboot after imported
2. Settings should be as [Settings before Export](#settings-before-export)

## Case 3. Import configuration by selected scope

### Pre-Conditions
1. Export configuration, make sure the settings before export
   ([Settings](#settings-before-export))
2. Modify some settings ([Settings](#settings-after-export))

### Steps
1. Navigate to `Settings`.`System`
2. Click `Import Configuration`
3. Check `Time`'s checkbox and `Choose File` for the exported `config.tar.gz`
4. Click `Upload`

### Expect
1. System reboot after imported
2. `Time` settings should be as [Settings before Export](#settings-before-export). Other settings should not be modified.

## Test Data
#### Settings before Export
- _Host Name_: `Moxa`
- _Ethernet.eth0.DNS2_: ``
- _Ethernet.eth1.IP_: `192.168.4.127`
- _Time.Synchronization_: `Manual`
- _Time.Time Server_: `pool.ntp.org`

#### Settings after Export
- _Host Name_: `test`
- _Ethernet.eth0.DNS2_: `8.8.8.8`
- _Ethernet.eth1.IP_: `192.168.5.127`
- _Time.Synchronization_: `Auto`
- _Time.Time Server_: `192.168.31.254`

