# Utilities for Development

Before we start using `libmxidaf` library, we check two console utilities first, which can aid your development.

## mxtagimport

`mxtagimport` imports Tags into *Data Acquisition Framework*.
For example,

```
$ mxtagimport --equipment my_test_equipment --tag my_test_tag --type float --value 3 --unit meters
```

imports a Tag using system time as timestamp.

Use `mxtagimport --help` to show other supported options.

You can check `mxtaghistory` to verify if your tag has been successfully imported.

## mxtaghistory

`mxtaghistory` dumps Tags that are cached in *Data Acquisition Framework*.
For example, to dump last 3 Tags of each Stream:

```
$ mxtaghistory
"equipment","tag","at","value","unit"
"my_test_equipment","my_test_tag","2016-03-16T17:13:16.019Z","3","meters"
```

Use `mxtaghistory --help` to show other supported options.

Note: If the total size of cached Tags is greater than 10MB, the oldest Tag will be removed from *Data Acquisition Framework*.
