# Access Modbus-RTU Slaves

*ThingsPro Modbus Framework* comes with `mxmodbusgateway` daemon acting as a *Modbus Gateway*.
If you want to run a program that accesses Modbus RTU slaves with *ThingsPro Modbus Framework* running on same platform,
you should access them through `mxmodbusgateway` using *Modbus/TCP* protocol,
as shown in the figure below.

![Overview][overview]

## TCP Port and Serial Port Mapping

TCP server ports used by `mxmodbusgateway` is preconfigured, but may vary on different platforms.
You can examine `/etc/mxmodbusgateway/configuration` and look for `port-list.tcp.service` in the configuration.

## Supported Commands

`mxmodbusgateway` supports Modbus commands below:

| Command                  | Code   |
|:------------------------ | ------:|
| Read Coils               | `0x01` |
| Read Discrete Inputs     | `0x02` |
| Read Holding Registers   | `0x03` |
| Read Input Registers     | `0x04` |
| Write Single Coil        | `0x05` |
| Write Single Register    | `0x06` |
| Write Multiple Coils     | `0x0F` |
| WRite Multiple Registers | `0x10` | 


[overview]: images/access-modbus-rtu-slaves/overview.png "Overview"
