## In/Out Interfaces

### Man Page
```
NAME
    mxmodbusclient

SYNOPSIS
    mxmodbusclient [-e PATH|--equipment-template PATH] [other options]

DESCRIPTION
    -e EQUIPMENT_TEMPLATE_PATH
    --equipment-template EQUIPMENT_TEMPLATE_PATH
        Path to Equipment Template configuration file.

        Must be given.

    --dry-run
        Check Equipment Template validity only.

    -h HOST
    --host HOST
        Default 127.0.0.1.

    -p PORT
    --port PORT
        Default 502.

    -t TIMEOUT_MS
    --timeout-ms TIMEOUT_MS
        Timeout for each MODBUS command.

        Criteria 100 <= TIMEOUT_MS <= 60000.

        Default 3000.(3 seconds)

    -d DEVICE_ID
    --device-id DEVICE_ID
        Default 0x00.

EQUIPMENT TEMPLATE
    In the format same as mxmodbusmaster.

OUTPUT FORMAT
    Example:
        $ mxmodbusclient -e /path/to/equipment/template
        elapsed-ms: 48
        di0: 1
        di1: 0
        ai0: 123.456
        ai1: -123.456
        ai2: error
        ai3: error

EXIT STATUS
    0
        Success.
    1
        Unknown error.
    2
        Illegal argument.
    3
        Illegal Equipment Template.
    4
        I/O Error.
    5
        Modbus error.
```
