## Data Design

### Configuration

* `port-list`: Required, object-list.
    * `tcp`: Required, object.
        * `host`: Required, string.
        * `service`: Required, integer, criteria `1 <= value <= 65535`.
    * `rtu`: Required, object.
        * `path`: Required, string. Serial device path.
        * `serial-config`: Required, string, format `<baudrate>-8-<parity>-<stop-bits>`.
            * Allowed serial baudrate: `9600`, `19200`, `38400`, `57600`, `115200`.
            * Allowed serial parity: `n`, `e`, `o`.
            * Allowed serial stop-bits: `1`, `2`.
        * `interframe-delay-ms`: Required, integer, criteria `value >= 0`.
        * `interchar-timeout-ms`: Required, integer, criteria `value > 1`.
        * `request-timeout-ms`: Required, integer, criteria `value >= 10`.

Sample:

```
# /etc/mxmodbusgateway/configuration
port-list = (
    {
        tcp = {
            host = "127.0.0.1"
            service = 502
        }
        rtu = {
            path = "/dev/ttyM0"
            serial-config = "9600-8-n-1"
            interframe-delay-ms = 300
            interchar-timeout-ms = 100
            request-timeout-ms = 500
        }
    },
    {
        tcp = {
            host = "0.0.0.0"
            service = 1502
        }
        rtu = {
            path = "/dev/ttyM1"
            serial-config = "19200-8-n-1"
            interframe-delay-ms = 200
            interchar-timeout-ms = 100
            request-timeout-ms = 300
        }
    }
)
```
