## Test Spec

### Case 1

- Test **5** Modbus slave device.
- Scan interval is **1 second**.
- Test **20** tags for each equipment.

#### Steps

1. Setup test environment.
```
./mxmodbusmaster-test-setup.sh
```
2. **Check** all tags and values by eyes.
```
./mxmodbusmaster-test.sh
```
3. Cleanup test environment.
```
./mxmodbusmaster-test-teardown.sh
```

#### Expect

1. Service `mxmodbusmaster` SHOULD run in the background.
2. `subscriber` SHOULD receive tag data continuously in protocol-buffer format with the correct interval.
    - Topic: `/equs/EQUIPMENT/tags/TAG`
        - EQUIPMENT: eq1, eq2, eq3, eq4, eq5.
        - TAG: rc, rc2, rdi, rdi2, rig, int16, uint32, int32, uint64, int64, float32, float64, sting, DCBA, rhr, border, scaling, scaling2.
    - Message:
        - Value: 0, 1, 1, 0, 65535, -32768, 4294967295, -1, 18446744073709551615, -1, 3.14(approx.), 3.14(approx), "ModbusEmu", 305419896, 0, 305419896, 4.554, -1.0
    - Time Interval: timestamp(`at`) of two sequential Tags SHOULE be around **1 second**.
