# Architecture


_<font color="gray">
In this chapter, the following views may use to present the architecture design.
</font>_

## _<font color="gray"> Component Views </font>_

_<font color="gray">
&lt;Using **subsystems** or **classes** to represent elements and relationships.&gt;
</font>_


## _<font color="gray"> Process Views </font>_

_<font color="gray">
&lt;Using components to represent elements and relationships. Documenting behavior of elements if necessary. The use case diagrams, use case descriptions, **sequience diagrams**, and **state transition diagrams** can be used for documenting the behavior.&gt;
</font>_

### Enable OpenVPN
![Enable OpenVPN](images/process-view-enable-openvpn.png)

### Disable OpenVPN
![Disable OpenVPN](images/process-view-disable-openvpn.png)

### Download OVPN File
![Download OVPN File](images/sequence-download-ovpn.png)

### Upload OVPN File
![Upload OVPN File](images/sequence-upload-ovpn.png)


## _<font color="gray"> Deployment Views </font>_

_<font color="gray">
&lt;The view depicts the system from a system engineer's point of view. It is concerned with the topology of software components on the physical layer, as well as the physical connections between these components. This view is also known as the deployment view. UML Diagrams used to represent physical view include the **Deployment diagram**.&gt;
</font>_

![Deployment View](images/deployment-view.png)


## _<font color="gray"> Implementation Views </font>_

_<font color="gray">
&lt;UML provides a number of built-in facilities to aid in showing an install view, including the &lt;&lt;artifact&gt;&gt; stereotype to denote a file (configuration item) and the &lt;&lt;manifest&gt;&gt; artifact to indicate containment.&gt;
</font>_

### Bundle Component
![Implementation View](images/implementation-view-bundle.png)

### Bundle interface
![Implementation View](images/implementation-view-interface.png)
