# Integration Test Spec

_<font color="gray">
&lt;Specify test cases for software integration test(which is performed by software integrators).&gt;
</font>_


## Result Table

| Test Procedure / Test Case | Test Result | Test Date | Tester |
|:-------------------------- |:-----------:|:---------:|:------:|
| Enable OpenVPN client service | PASS | 2016/03/14 | Donald Hsu |
| Disable OpenVPN client service | PASS | 2016/03/14 | Donald Hsu |
| Download ovpn config file | PASS | 2016/03/14 | Donald Hsu |
| Upload ovpn config file | PASS | 2016/03/14 | Donald Hsu |
| Delete ovpn config file | PASS | 2016/03/14 | Donald Hsu |
| Default Route setting | PASS | 2016/03/14 | Donald Hsu |
| OpenVPN gateway function | PASS | 2016/03/14 | Donald Hsu |
| OpenVPN over cellular | PASS | 2016/03/14 | Donald Hsu |


## Test Case

### Environment
- OpenVPN server device
- OpenVPN client device


### Enable OpenVPN client service

#### Purpose
Check OpenVPN service can establish connection by using web.

#### Steps
1. Login to OpenVPN web configure page.
2. Click `Edit` to set OpenVPN.
3. Click the `Enable` checkbox to checked it.
4. Click `Save` to apply the setting.
5. SSH into device, ping to OpenVPN server

#### Expect
1. Ping to server need success.

#### Traceability
1. REQ-1


### Disable OpenVPN client service

#### Purpose
Check OpenVPN service can disconnect by using web.

#### Steps
1. Login to OpenVPN web configure page.
2. Click `Edit` to set OpenVPN
3. Click the `Enable` checkbox to un-checked it.
4. Click `Save` to apply the setting.
5. SSH into device, ping to OpenVPN server

#### Expect
1. Ping to server need success.

#### Traceability
1. REQ-1


### Download ovpn config file

#### Purpose
Download ovpn config file from CG.

#### Steps
1. Prepare an environment which the ovpn file was already uploaded.
2. Login to OpenVPN web configure page.
3. Click `Edit` to set OpenVPN.
4. Click `Download` to download ovpn config file.

#### Expect
1. Download the `client.ovpn` file from CG.

#### Traceability
1. REQ-1.1


### Upload ovpn config file

#### Purpose
Upload ovpn config file to CG

#### Steps
1. Login to OpenVPN web configure page.
2. Click `Edit` to set OpenVPN.
3. Click `Selet File` to upload ovpn config file.

#### Expect
1. The upload progress success.
2. The button `Delete` `Download` appeared.

#### Tracebility
1. REQ-1.1


### Delete ovpn config file

#### Purpose
Delete ovpn config file in CG

#### Steps
1. Prepare an environment which the ovpn file was already uploaded.
2. Login to OpenVPN web configure page.
3. Click `Edit` to set OpenVPN.
4. Click `Delete` to delete ovpn config file in CG.

#### Expect
1. The ovpn file delete in CG.
2. The button `Delete` `Download` disappeared.

#### Traceability
1. REQ-1.1


### Default Route setting

#### Purpose
Update default route setting from ovpn file.

#### Steps
1. Setup the test environment. ![env](images/test-arch-default-route-before-openvpn.png)
    - The communication between `UC-8100-LX-CG` and `Target` is not exist.
    - Use `ping` command to check.
2. Build up OpenVPN connection from `UC-8100-LX-CG` to `OpenVPN Server`. ![env](images/test-arch-default-route-after-openvpn.png)
    - The communication between `UC-8100-LX-CG` and `Target` is established.
    - Use `ping` command to check the communication.

#### Expect
1. Ping to target in step1 need fail.
2. Ping to target in step2 need success.

#### Traceability
1. REQ-1


### OpenVPN gateway function

#### Purpose
Device behind CG can access through OpenVPN connection.

#### Steps
1. Setup the test environment.
    - Use `ping` command to check.

#### Expect
1. Ping to external device need success.

#### Traceability
1. REQ-1.2


### OpenVPN over cellular

#### Purpose
OpenVPN connection can be established when using cellular.

#### Steps
1. Prepare cellular connection.
2. Enable OpenVPN connection.
3. Use `ping` command to check.

#### Expect
1. Ping to external device need success.

#### Tracebility
1.REQ-1
