# Test Spec

## Result Table

| Test Procedure / Test Case | Test Result | Test Date | Tester |
|:-------------------------- |:-----------:|:---------:|:------:|
| Enable OpenVPN client service | PASS | 2016/03/14 | Donald Hsu |
| Disable OpenVPN slient service | PASS | 2016/03/14 | Donald Hsu |
| Download ovpn config file | PASS | 2016/03/14 | Donald Hsu |
| Upload ovpn config file | PASS | 2016/03/14 | Donald Hsu |
| Delete ovpn config file | PASS | 2016/03/14 | Donald Hsu |


## Test Case

### Environment
- OpenVPN server
- OpenVPN client
- sanji-bundle-openvpn


### Enable OpenVPN client service

#### Purpose
Check `sanji-bundle-openvpn` can establish a VPN connection.

#### Steps
1. Prepare a OpenVPN configuration `client.ovpn`.
2. Prepare a bundle configure file `config.json`
  - set `enable` to `true`
3. Execute `sanji-bundle-openvpn`
4. ping with OpenVPN server

#### Expect
1. Ping to server need success.

#### Traceability
1. REQ-1


### Disable OpenVPN client service

#### Purpose
Check `sanji-bundle-openvpn` can shutdown a VPN connection.

#### Steps
1. Prepare a connected OpenVPN service.
  - ping to server is success
2. Prepare a bundle configure file `config.json`
  - set `enable` to `false`
3. Execute `sanji-bundle-openvpn`
4. ping with OpenVPN server

#### Expect
1. Ping to server need fail.

#### Traceability
1. REQ-1


### Download ovpn config file

#### Steps
1. Prepare `client.ovpn`
2. Prepare a file server.
3. Set `openvpn.json` with `ovpnFileExist = true`
4. Use `POST` method to upload `client.ovpn` file to file server for user to download.

#### Expect
1. The response of `POST` method with a URL of `client.ovpn` in file server.
2. Use `GET` method to file server to download `client.ovpn` and check the content is equal to original.

#### Traceability
1. REQ-1.1


### Upload ovpn config file

#### Steps
1. Prepare a file server with `cilent.ovpn`, and it's URL.
2. Use `PUT` method to transfer URL for ovpn upload.

#### Expect
1. Check the content of `client.ovpn` is the same as the content in file server.

#### Traceability
1. REQ-1.1


### Delete ovpn config file

#### Steps
1. Prepare `client.ovpn`
2. Set `openvpn.json` with `ovpnFileExist = true`
3. Use `DELETE` method to delete ovpn file.

#### Expect
1. Check `ovpn.json` is not exist.

#### Traceability
1. REQ-1.1
