# Constraints and Resources

## Design and Implementation Constraints
_<font color="gray">
&lt;Describe any items or issues that will limit the options available to the developers. These might include: corporate or regulatory policies; hardware limitations (timing requirements, memory requirements); interfaces to other applications; specific technologies, tools, and databases to be used; parallel operations; language requirements; communications protocols; security considerations; design conventions or programming standards (for example, if the customer’s organization will be responsible for maintaining the delivered software).&gt;
</font>_

_<font color="gray">
&lt;Any relevant assumptions, limitations, or constraints. This should include constraints on timing, storage, or component state, and might include rules for interacting with this component (encompassing preconditions, postconditions, invariants, other constraints on input or output values and local or global values, data formats and data access, synchronization, exceptions, etc.)&gt;
</font>_

- OpenVPN Server is configured and maintained by customer.
- OpenVPN Client’s configuration file is provided by customer.
- If OpenVPN tunnel established, system used OpenVPN gateway as default route setting, whether `redirect-gateway` setting is configured or not.
- `script-security` setting in ovpn configuration file may not work, it will be overrided to `2` to execute link up/down scripts.
- `up` setting in ovpn configuration file may not work, it will be overrided.
- `down` setting in ovpn configuration file may not work, it will be overrided.


## Resources
_<font color="gray">
&lt;A description of any and all resources that are managed, affected, or needed by this entity. Resources are entities external to the design such as memory, processors, printers, databases, or a software library. This should include a discussion of any possible race conditions and/or deadlock situations, and how they might be resolved.&gt;
</font>_
