# User Requirements

## User Story

_<font color="gray">
&lt;As a [role], I want [goal/desire] so that [benefit].&gt;
</font>_


### Case 1
1. Customer’s end computer in UC-8100 local LAN, communicates with OpenVPN Server by UC-8100 NAT.

![NAT](images/OpenVPN_Use_Case_NAT.png)

### Case 2
1. Administrator communicates with customer’s end computer which is in UC-8100 local LAN, by Port Forward setting in UC-8100.

![PortForward](images/OpenVPN_Use_Case_PortForward.png)


## Use Case

_<font color="gray">
&lt;The description of an architecture is illustrated using a small set of use cases, or scenarios which become a fifth view. The scenarios describe sequences of interactions between objects, and between processes. They are used to identify architectural elements and to illustrate and validate the architecture design. They also serve as a starting point for tests of an architecture prototype. This view is also known as **use case view**.&gt;
</font>_

![Use Case](images/use-case-view.png)

### Enable/Disable OpenVPN client service.
1. `Edit` the setting of OpenVPN.
2. Click the `Enable OpenVPN service` checkbox.
3. Click `Save` to apply the setting.

### Download sample OpenVPN configuration file.
1. `Edit` the setting of OpenVPN.
2. Click `Download Sample Configuration File` button.
3. Starting to download `sample.ovpn`.

### Upload OpenVPN configuration file.
1. `Edit` the setting of OpenVPN.
2. Click `Upload Configuration File` button.
3. Select the `*.ovpn` file, then press `OK` to upload.
4. Store `client.ovpn` in CG.

### Download last uploaded OpenVPN configuration file.
1. `Edit` the setting of OpenVPN.
2. Click `Download Configuration File` button.
  - If it didn't upload yet, the button does not appear.
3. Starting to download `client.ovpn`.

### Delete last uploaded OpenVPN configuration file.
1. `Edit` the setting of OpenVPN.
2. Click `Delete Configuration File` button.
  - If it didn't upload yet, the button does not appear.
3. Delete `client.ovpn` from CG.

### Display connection state.
1. Open OpenVPN service menu.
2. If OpenVPN service enable and connection established, then show `connected`
3. If OpenVPN service disable or connection not establish, then show `disconnected`

### Display local IP and remote IP.
1. Open OpenVPN service menu.
2. If connection esatablished, show the current local IP and remote IP of VPN network.
3. If connection not establish, show `N/A` of both local IP and remote IP.
