#ifndef _MXHTAG_ERROR_HPP_
#define _MXHTAG_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxhtag
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxhtag::Error";
        return WHAT;
    }
};

struct VersionError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxhtag::VersionError";
        return WHAT;
    }
};

struct LockError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxhtag::LockError";
        return WHAT;
    }
};

struct OpenError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxhtag::OpenError";
        return WHAT;
    }
};

struct DiskFullError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxhtag::DiskFullError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_err_msg, std::string>
    EInfoMsg;

}

#endif
