#ifndef _MXSQLITE3_CONNECTION_HPP_
#define _MXSQLITE3_CONNECTION_HPP_

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <mxsqlite3/Statement.hpp>

namespace mxsqlite3
{

class Connection // interface
    : private boost::noncopyable
{
protected:
    Connection();

public:
    virtual ~Connection();

    boost::shared_ptr<mxsqlite3::Statement>
        create_statement(const std::string &sql_expr);

private:
    virtual boost::shared_ptr<mxsqlite3::Statement>
        do_create_statement(const std::string &sql_expr) = 0;
};

Connection &
    operator <<(Connection &,
                const std::string &sql);

}

#endif
