#ifndef _MXSQLITE3_CONNECTION_IMPL_HPP_
#define _MXSQLITE3_CONNECTION_IMPL_HPP_

#include <boost/scoped_ptr.hpp>

#include <sqlite3.h>

#include <mxsqlite3/Connection.hpp>
#include <mxsqlite3/error.hpp>

namespace mxsqlite3
{

class ConnectionImpl
    : public mxsqlite3::Connection
{
public:
    explicit ConnectionImpl(
        sqlite3 *handle,
        int retry_timeout_ms,
        int retry_wait_ms);
    virtual ~ConnectionImpl();

private:
    virtual boost::shared_ptr<mxsqlite3::Statement>
        do_create_statement(const std::string &sql);    // throws mxsqlite3::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
