#ifndef _MXSQLITE3_SQLITE3_HPP_
#define _MXSQLITE3_SQLITE3_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxsqlite3/error.hpp>
#include <mxsqlite3/Connection.hpp>

namespace mxsqlite3
{

class Sqlite3
    : private boost::noncopyable
{
public:
    static const Sqlite3 &
        instance();

private:
    Sqlite3();
    ~Sqlite3();

public:
    boost::shared_ptr<mxsqlite3::Connection>
        connect(
            const boost::filesystem::path &,
            int retry_timeout_ms = 10 * 1000,
            int retry_wait_ms = 10,
            bool create_not_exist = false) const; // throws mxsqlite3::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
