#ifndef _MXSQLITE3_STATEMENT_IMPL_HPP_
#define _MXSQLITE3_STATEMENT_IMPL_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxsqlite3/error.hpp>
#include <mxsqlite3/Statement.hpp>

#include <sqlite3.h>

namespace mxsqlite3
{

class StatementImpl
    : public mxsqlite3::Statement
{
public:
    StatementImpl(
        sqlite3_stmt *,
        sqlite3 *,
        int retry_timeout_ms,
        int retry_wait_ms);
    virtual ~StatementImpl();

private:
    virtual void
        do_reset();

    virtual void
        do_bind(std::size_t index);
    virtual void
        do_bind(
            std::size_t index,
            int64_t);
    virtual void
        do_bind(
            std::size_t index,
            double);
    virtual void
        do_bind(
            std::size_t index,
            const std::string &);

    virtual boost::optional<std::vector<mxsqlite3::Value> >
        do_execute();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
