#ifndef _MXSQLITE3_VALUE_HPP_
#define _MXSQLITE3_VALUE_HPP_

#include <string>

#include <boost/cstdint.hpp>
#include <boost/shared_ptr.hpp>

namespace mxsqlite3
{

class Value
{
public:
    Value();    // null
    explicit Value(int64_t);
    explicit Value(double);
    explicit Value(const std::string &);
    //Value(const Value &);

    bool
        is_null() const;
    bool
        is_int() const;
    bool
        is_double() const;
    bool
        is_string() const;

    int64_t
        as_int() const;
    double
        as_double() const;
    const std::string &
        as_string() const;

    //Value &
    //  operator =(const Value &);

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

bool
    operator ==(
        const Value &lhs,
        const Value &rhs);

}

#endif
