#ifndef _MXSQLITE3_ERROR_HPP_
#define _MXSQLITE3_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxsqlite3
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxsqlite3::Error";
        return WHAT;
    }
};

typedef
    boost::error_info<struct ErrMsg, std::string>
    ErrMsgInfo;

typedef
    boost::error_info<struct Sqlite3ErrCode, int>
    Sqlite3ErrCodeInfo;

typedef
    boost::error_info<struct Sqlite3ExtErrCode, int>
    Sqlite3ExtErrCodeInfo;

typedef
    boost::error_info<struct Sqlite3ErrMsg, std::string>
    Sqlite3ErrMsgInfo;

}

#endif
