#include <mxsqlite3/Transaction.hpp>

#include <mxutil/log.hpp>

namespace mxsqlite3
{

struct Transaction::Impl
{
    Impl(
        Connection &conn_)
        : conn(&conn_)
    {
    }

    Connection *    conn;
};

Transaction::Transaction(
    Connection &conn)
    : pimpl(new Impl(
        conn))
{
    BOOST_VERIFY(pimpl->conn);

    *pimpl->conn << "BEGIN TRANSACTION";
}

Transaction::~Transaction()
{
    if (pimpl->conn)
    {
        try
        {
            *pimpl->conn << "ROLLBACK TRANSACTION";
        }
        catch(Error &e)
        {
            MXLOG_WARN(diagnostic_information(e));
        }

        pimpl->conn = NULL;
    }
}

void
    Transaction::commit()
{
    BOOST_VERIFY(pimpl->conn);

    *pimpl->conn << "END TRANSACTION";

    pimpl->conn = NULL;
}

}
