#include <boost/test/unit_test.hpp>

#include <mxsqlite3/Sqlite3.hpp>

namespace mxsqlite3
{

using boost::shared_ptr;

using std::string;

namespace
{

struct TestFixture
{
    TestFixture()
        : path("/dev/shm/test.sqlite3")
    {
        if (0 != unlink(path.c_str()))
        {
            // do nothing
        }
    }

    ~TestFixture()
    {
        if (0 != unlink(path.c_str()))
        {
            // do nothing
        }
    }

    const string    path;
};

}

BOOST_FIXTURE_TEST_CASE(test_Sqlite3_connect_ShouldPass, TestFixture)
{
    // arrange

    // act
    const shared_ptr<Connection> result = Sqlite3::instance().connect(
        path,
        10 * 1000,
        10,
        true);

    // assert
    BOOST_CHECK(result != 0);
}

}
