#ifndef _MXIDAF_IMPL_SERVICE_CONTEXT_HPP_
#define _MXIDAF_IMPL_SERVICE_CONTEXT_HPP_

#include <string>

#include <mxidafpp/Service.hpp>

#include <mxidaf/Service.h>

namespace mxidaf
{
namespace impl
{

class ServiceContext
{
public:
    ServiceContext()
        : service_(mxidafpp::Service::instance())
        , error_(MXIDAF_ERROR_NONE)
        , error_msg_()
    {
    }

    mxidafpp::Service &
        service() const
    {
        return service_;
    }

    mxidaf_Error
        error() const
    {
        return error_;
    }

    const std::string &
        error_msg() const
    {
        return error_msg_;
    }

    void
        set_error(
            mxidaf_Error error,
            const std::string &error_msg)
    {
        error_ = error;
        error_msg_ = error_msg;
    }

private:
    mxidafpp::Service &    service_;
    mxidaf_Error           error_;
    std::string             error_msg_;
};

}
}

#endif
