#include <mxidaf/String.h>

#include <cassert>
#include <string>

using std::string;

extern "C" mxidaf_String *
    mxidaf_String_new(
        const char *s)
{
    try
    {
        string *inst = new string(s);

        return (mxidaf_String *)inst;
    }
    catch(...)
    {
        // TODO
        return NULL;
    }
}

extern "C" void
    mxidaf_String_delete(
        mxidaf_String *self)
{
    if (NULL == self)
        return;

    string *inst = (string *)self;

    delete inst;
}

extern "C" const char *
    mxidaf_String_str(
        const mxidaf_String *self)
{
    assert(self);

    const string *inst = (const string *)self;

    return inst->c_str();
}

extern "C" mxidaf_String *
    mxidaf_String_clone(
        const mxidaf_String *from)
{
    assert(from);

    const string *from_inst = (const string *)from;

    try
    {
        string *to_inst = new string(*from_inst);

        return (mxidaf_String *)to_inst;
    }
    catch(...)
    {
        // TODO
        return NULL;
    }
}
