#include <mxidaf/Value.h>

#include <assert.h>
#include <stdlib.h>

#include <mxidafpp/Value.hpp>

using mxidafpp::Value;

extern "C" mxidaf_Value *
    mxidaf_Value_new_int(
        int64_t i)
{
    try
    {
        Value *inst = new Value(i);

        return (mxidaf_Value *)inst;
    }
    catch(...)
    {
        // TODO

        return NULL;
    }
}

extern "C" mxidaf_Value *
    mxidaf_Value_new_uint(
        uint64_t u)
{
    try
    {
        Value *inst = new Value(u);

        return (mxidaf_Value *)inst;
    }
    catch(...)
    {
        // TODO

        return NULL;
    }
}

extern "C" mxidaf_Value *
    mxidaf_Value_new_float(
        double f)
{
    try
    {
        Value *inst = new Value(f);

        return (mxidaf_Value *)inst;
    }
    catch(...)
    {
        // TODO

        return NULL;
    }
}

extern "C" mxidaf_Value *
    mxidaf_Value_new_string(
        const char *s)
{
    try
    {
        Value *inst = new Value(s);

        return (mxidaf_Value *)inst;
    }
    catch(...)
    {
        // TODO

        return NULL;
    }
}

extern "C" void
    mxidaf_Value_delete(
        mxidaf_Value *self)
{
    if (NULL == self)
        return;

    Value *inst = (Value *)self;

    delete inst;
}

extern "C" int
    mxidaf_Value_is_int(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->is_int();
}

extern "C" int
    mxidaf_Value_is_uint(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->is_uint();
}

extern "C" int
    mxidaf_Value_is_float(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->is_float();
}

extern "C" int
    mxidaf_Value_is_string(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->is_string();
}

extern "C" int64_t
    mxidaf_Value_as_int(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->as_int();
}

extern "C" uint64_t
    mxidaf_Value_as_uint(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->as_uint();
}

extern "C" double
    mxidaf_Value_as_float(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->as_float();
}

extern "C" const char *
    mxidaf_Value_as_string(
        const mxidaf_Value *self)
{
    assert(self);

    const Value *inst = (const Value *)self;

    return inst->as_string().c_str();
}

extern "C" mxidaf_Value *
    mxidaf_Value_clone(
        const mxidaf_Value *from)
{
    assert(from);

    Value *from_inst = (Value *)from;

    try
    {
        Value *to_inst = new Value(*from_inst);

        return (mxidaf_Value *)to_inst;
    }
    catch(...)
    {
        // TODO

        return NULL;
    }
}
