#include <boost/test/unit_test.hpp>

#include <mxidaf/impl/Tag.hpp>

#include <string>

#include <boost/scope_exit.hpp>

using boost::posix_time::ptime;
using boost::posix_time::time_from_string;

using std::string;

namespace
{

struct TestFixture
{
};

}

namespace mxidaf
{
namespace impl
{

BOOST_FIXTURE_TEST_CASE(test_Tag_conversion_ShouldPass, TestFixture)
{
    // arrange
    const mxidafpp::Tag from(
        mxidafpp::Value(static_cast<int64_t>(-1234567890ll)),
        mxidafpp::Time(2016, 2, 15, 17, 53, 5, 123),
        "test-unit");

    // act
    mxidaf_Tag *to = mxidaf_from_mxidafpp(
        from);

    BOOST_SCOPE_EXIT((&to))
    {
        mxidaf_Tag_delete(to);
    }
    BOOST_SCOPE_EXIT_END

    mxidafpp::Tag back = mxidafpp_from_mxidaf(
        to);

    // assert
    BOOST_CHECK(from == back);
}

}
}
