#include <boost/test/unit_test.hpp>

#include <mxidaf/impl/Value.hpp>

#include <boost/scope_exit.hpp>

using mxidafpp::Value;

namespace
{

struct TestFixture
{
};

}

namespace mxidaf
{
namespace impl
{

BOOST_FIXTURE_TEST_CASE(test_Value_conversion_ShouldPass, TestFixture)
{
    // arrange
    const Value value("test-value");

    // act
    mxidaf_Value *to = mxidaf_from_mxidafpp(value);

    BOOST_SCOPE_EXIT((&to))
    {
        if (to)
            mxidaf_Value_delete(to);

        to = NULL;
    }
    BOOST_SCOPE_EXIT_END

    const Value back = mxidafpp_from_mxidaf(to);

    // assert
    BOOST_CHECK(value == back);
}

}
}
