#include <boost/test/unit_test.hpp>

#include <mxidaf/String.h>

#include <string>

#include <boost/scope_exit.hpp>

using std::string;

namespace
{

struct TestFixture
{
};

}

BOOST_FIXTURE_TEST_CASE(test_mxidaf_String_new_ShouldPass, TestFixture)
{
    // arrange

    // act
    mxidaf_String *v = mxidaf_String_new(
        "hello world");

    BOOST_SCOPE_EXIT((&v))
    {
        mxidaf_String_delete(v);
    }
    BOOST_SCOPE_EXIT_END

    // assert
    BOOST_CHECK(string("hello world") == mxidaf_String_str(v));
}

BOOST_FIXTURE_TEST_CASE(test_mxidaf_String_clone_ShouldPass, TestFixture)
{
    // arrange
    mxidaf_String *from = mxidaf_String_new(
        "hello there");

    BOOST_SCOPE_EXIT((&from))
    {
        mxidaf_String_delete(from);
    }
    BOOST_SCOPE_EXIT_END

    // act
    mxidaf_String *to = mxidaf_String_clone(
        from);

    BOOST_SCOPE_EXIT((&to))
    {
        mxidaf_String_delete(to);
    }
    BOOST_SCOPE_EXIT_END

    // assert
    BOOST_REQUIRE(to);
    BOOST_CHECK(from != to);
    BOOST_CHECK(string("hello there") == mxidaf_String_str(to));
}
