from libmxidaf_py import Service, Tag, Time, Value

def last_value_of_stream(
        stream):
    tag_list = stream.get_last_tag_list(1)

    return tag_list[0].value().as_float()


cache = Service.instance().get_cache()

voltage_stream = cache.get_equipment(
    "electrical-probe").get_stream(
    "voltage")
current_stream = cache.get_equipment(
    "electrical-probe").get_stream(
    "current")

watt_tag = Tag(
    Value(
        last_value_of_stream(voltage_stream) *
        last_value_of_stream(current_stream)),
    Time.now(),
    "w")

tag_importer = Service.instance().get_tag_importer()

tag_importer.import_tags(
    "electrical-probe",
    "power",
    [watt_tag])
