#ifndef _MXIDAFPP_CACHE_HPP_
#define _MXIDAFPP_CACHE_HPP_

#include <string>
#include <vector>

#include <boost/shared_ptr.hpp>

#include <mxidafpp/Equipment.hpp>
#include <mxidafpp/error.hpp>
#include <mxidafpp/fwd.hpp>

namespace mxidafpp
{

class Cache
{
public:
    explicit Cache(boost::shared_ptr<mxidafpp::impl::CacheImpl>);
    //Cache(const Cache &);
    ~Cache();

    //Cache &
    //  operator =(const Cache &);

    const std::vector<mxidafpp::Equipment>
        get_equipment_list() const;         // throws mxidafpp::Error

    const mxidafpp::Equipment
        get_equipment(
            const std::string &name) const; // throws mxidafpp::NotFoundError, mxidafpp::Error

private:
    boost::shared_ptr<mxidafpp::impl::CacheImpl> impl_;
};

}

#endif
