#ifndef _MXIDAFPP_EQUIPMENT_HPP_
#define _MXIDAFPP_EQUIPMENT_HPP_

#include <string>
#include <vector>

#include <boost/shared_ptr.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/fwd.hpp>
#include <mxidafpp/Stream.hpp>

namespace mxidafpp
{

class Equipment // value, no-cmp
{
public:
    explicit Equipment(
        boost::shared_ptr<mxidafpp::impl::EquipmentImpl>);
    //Equipment(const Equipment &);
    ~Equipment();

    //Equipment &
    //  operator =(const Equipment &);

    bool
        operator ==(
            const Equipment &) const;
    bool
        operator !=(
            const Equipment &) const;

    const std::string &
        name() const;

    const std::vector<mxidafpp::Stream>
        get_stream_list() const;            // throws mxidafpp::Error

    const mxidafpp::Stream
        get_stream(
            const std::string &name) const; // throws mxidafpp::NotFoundError, mxidafpp::Error

private:
    boost::shared_ptr<mxidafpp::impl::EquipmentImpl> impl_;
};

}

#endif
