#ifndef _MXIDAFPP_SERVICE_HPP_
#define _MXIDAFPP_SERVICE_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/Cache.hpp>
#include <mxidafpp/TagImporter.hpp>

namespace mxidafpp
{

class Service
    : private boost::noncopyable
{
public:
    static Service &
        instance();

private:
    Service();
    ~Service();

public:
    const mxidafpp::Cache
        get_cache();                            // throws mxidafpp::Error

    const mxidafpp::Cache
        get_cache(
            const boost::filesystem::path &);   // throws mxidafpp::Error

    const mxidafpp::TagImporter
        get_tag_importer();                     // throws mxidafpp::Error

    const mxidafpp::TagImporter
        get_tag_importer(
            const std::string &broker_host,
            int broker_port);                   // throws mxidafpp::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
