#ifndef _MXIDAFPP_STREAM_HPP_
#define _MXIDAFPP_STREAM_HPP_

#include <vector>

#include <boost/shared_ptr.hpp>

#include <mxidafpp/Tag.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/fwd.hpp>

namespace mxidafpp
{

class Stream // value, no-cmp
{
public:
    explicit Stream(boost::shared_ptr<mxidafpp::impl::StreamImpl>);
    //Stream(const Stream &);
    ~Stream();

    //Stream &
    //  operator =(const Stream &);

    bool
        operator ==(
            const Stream &) const;
    bool
        operator !=(
            const Stream &) const;

    const std::string &
        equipment_name() const;

    const std::string &
        tag_name() const;

    const std::vector<mxidafpp::Tag>
        get_last_tag_list(std::size_t = 0) const;  // throws mxidafpp::Error

private:
    boost::shared_ptr<mxidafpp::impl::StreamImpl>  impl_;
};

}

#endif
