#ifndef _MXIDAFPP_TAG_HPP_
#define _MXIDAFPP_TAG_HPP_

#include <string>

#include <mxidafpp/error.hpp>
#include <mxidafpp/Time.hpp>
#include <mxidafpp/Value.hpp>

namespace mxidafpp
{

class Tag // value, no-cmp
{
public:
    Tag(
        const mxidafpp::Value &,
        const mxidafpp::Time &at = mxidafpp::Time::now(),
        const std::string &unit = "");  // throws mxidafpp::ArgumentError
    //Tag(const Tag &);
    ~Tag();

    //Tag &
    //  operator = (const Tag &);

    const mxidafpp::Time &
        at() const;
    const mxidafpp::Value &
        value() const;
    const std::string &
        unit() const;

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

bool
    operator ==(
        const Tag &,
        const Tag &);
bool
    operator !=(
        const Tag &,
        const Tag &);

}

#endif
