#ifndef _MXIDAFPP_TAG_IMPORTER_HPP_
#define _MXIDAFPP_TAG_IMPORTER_HPP_

#include <vector>

#include <boost/shared_ptr.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/fwd.hpp>
#include <mxidafpp/Tag.hpp>

namespace mxidafpp
{

class TagImporter
{
public:
    explicit TagImporter(
        boost::shared_ptr<mxidafpp::impl::TagImporterImpl>);

    ~TagImporter();

    void
        import(
            const std::string &equipment_name,
            const std::string &tag_name,
            const std::vector<mxidafpp::Tag> &tag_list);    // throws mxidafpp::Error

private:
    boost::shared_ptr<mxidafpp::impl::TagImporterImpl>  impl_;
};

}

#endif
