#ifndef _MXIDAFPP_TIME_HPP_
#define _MXIDAFPP_TIME_HPP_

#include <iosfwd>

#include <boost/date_time/posix_time/posix_time.hpp>

#include <boost/shared_ptr.hpp>

namespace mxidafpp
{

class Time // value
{
public:
    static const Time
        now();

public:
    Time(
        int year,
        int month,
        int day,
        int hour,
        int minute,
        int second,
        int millisec);
    explicit Time(
        const boost::posix_time::ptime &);
    //Time(const Time &);
    ~Time();

    //Time &
    //    operator =(
    //        const Time &);

    int
        year() const;
    int
        month() const;
    int
        day() const;
    int
        hour() const;
    int
        minute() const;
    int
        second() const;
    int
        millisec() const;

    int
        compare(
            const Time &) const;

    const boost::posix_time::ptime
        to_ptime() const;

    const std::string
        to_string() const;

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

std::ostream &
    operator <<(
        std::ostream &,
        const Time &rhs);

bool
    operator ==(
        const Time &lhs,
        const Time &rhs);
bool
    operator !=(
        const Time &lhs,
        const Time &rhs);
bool
    operator < (
        const Time &lhs,
        const Time &rhs);
bool
    operator <=(
        const Time &lhs,
        const Time &rhs);
bool
    operator > (
        const Time &lhs,
        const Time &rhs);
bool
    operator >=(
        const Time &lhs,
        const Time &rhs);

}

#endif
