#ifndef _MXIDAFPP_ERROR_HPP_
#define _MXIDAFPP_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxidafpp
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxidafpp::Error";
        return WHAT;
    }
};

struct ArgumentError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxidafpp::ArgumentError";
        return WHAT;
    }
};

struct DatabaseError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxidafpp::DatabaseError";
        return WHAT;
    }
};

struct NotFoundError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxidafpp::NotFoundError";
        return WHAT;
    }
};

struct VersionError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxidafpp::VersionError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_msg, std::string>
    ErrMsg;

typedef
    boost::error_info<struct tag_internal_msg, std::string>
    ErrInternalMsg;

}

#endif
