#ifndef _MXIDAFPP_IMPL_CACHE_IMPL_HPP_
#define _MXIDAFPP_IMPL_CACHE_IMPL_HPP_

#include <string>

#include <boost/noncopyable.hpp>

#include <mxhtag/Database.hpp>

#include <mxidafpp/Equipment.hpp>
#include <mxidafpp/error.hpp>

namespace mxidafpp
{
namespace impl
{

class CacheImpl
    : private boost::noncopyable
{
public:
    explicit CacheImpl(
        boost::shared_ptr<mxhtag::Database>);
    ~CacheImpl();

    const std::vector<mxidafpp::Equipment>
        get_equipment_list();                   // throws mxidafpp::DatabaseError

    const mxidafpp::Equipment
        get_equipment(
            const std::string &name);           // throws mxidafpp::DatabaseError, mxidafpp::NotFoundError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
