#ifndef _MXIDAFPP_IMPL_EQUIPMENT_IMPL_HPP_
#define _MXIDAFPP_IMPL_EQUIPMENT_IMPL_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxhtag/Database.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/Stream.hpp>

namespace mxidafpp
{
namespace impl
{

class EquipmentImpl
    : private boost::noncopyable
{
public:
    explicit EquipmentImpl(
        boost::shared_ptr<mxhtag::Database>,
        const std::string &name);
    ~EquipmentImpl();

    const std::string &
        name() const;

    bool
        equal(
            const EquipmentImpl &) const;

    const std::vector<mxidafpp::Stream>
        get_stream_list();                  // throws mxidafpp::Error

    const mxidafpp::Stream
        get_stream(
            const std::string &name);       // throws mxidafpp::NotFoundError, mxidafpp::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
