#ifndef _MXIDAFPP_IMPL_STREAM_IMPL_HPP_
#define _MXIDAFPP_IMPL_STREAM_IMPL_HPP_

#include <string>

#include <boost/noncopyable.hpp>

#include <mxhtag/Database.hpp>

#include <mxidafpp/Tag.hpp>

#include <mxidafpp/error.hpp>

namespace mxidafpp
{
namespace impl
{

class StreamImpl
    : private boost::noncopyable
{
public:
    StreamImpl(
        boost::shared_ptr<mxhtag::Database>,
        const std::string &equ_name,
        const std::string &tag_name);
    ~StreamImpl();

    const std::string &
        equipment_name() const;
    const std::string &
        tag_name() const;

    bool
        equal(
            const StreamImpl &) const;

    const std::vector<mxidafpp::Tag>
        get_last_tag_list(std::size_t count);   // count == 0: return all Tags
                                                // throws mxidafpp::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
