#ifndef _MXIDAFPP_IMPL_TAG_IMPORTER_IMPL_HPP_
#define _MXIDAFPP_IMPL_TAG_IMPORTER_IMPL_HPP_

#include <vector>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxidafpp/error.hpp>
#include <mxidafpp/Tag.hpp>

namespace mxidafpp
{
namespace impl
{

class TagImporterImpl
    : private boost::noncopyable
{
public:
    TagImporterImpl(
        const std::string &host,
        int port);
    ~TagImporterImpl();

    void
        import(
            const std::string &equipment_name,
            const std::string &tag_name,
            const std::vector<mxidafpp::Tag> &tag_list);    // throws mxidafpp::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
