#include <mxidafpp/Equipment.hpp>
#include <mxidafpp/impl/EquipmentImpl.hpp>

using boost::shared_ptr;

using mxidafpp::impl::EquipmentImpl;

using std::string;
using std::vector;

namespace mxidafpp
{

Equipment::Equipment(
    shared_ptr<EquipmentImpl> impl)
    : impl_(impl)
{
}

Equipment::~Equipment()
{
}

bool
    Equipment::operator ==(
        const Equipment &rhs) const
{
    return impl_->equal(*rhs.impl_);
}

bool
    Equipment::operator !=(
        const Equipment &rhs) const
{
    return !(*this == rhs);
}

const string &
    Equipment::name() const
{
    return impl_->name();
}

const vector<Stream>
    Equipment::get_stream_list() const
{
    return impl_->get_stream_list();
}

const Stream
    Equipment::get_stream(
        const string &name) const
{
    return impl_->get_stream(name);
}

}
