#include <mxidafpp/Stream.hpp>

#include <mxidafpp/impl/StreamImpl.hpp>

using boost::shared_ptr;

using mxidafpp::impl::StreamImpl;

using mxidafpp::Tag;

using std::string;
using std::vector;

namespace mxidafpp
{

Stream::Stream(
    shared_ptr<StreamImpl> impl)
    : impl_(impl)
{
}

Stream::~Stream()
{
}

bool
    Stream::operator ==(
        const Stream &rhs) const
{
    return impl_->equal(*rhs.impl_);
}

bool
    Stream::operator !=(
        const Stream &rhs) const
{
    return !(*this == rhs);
}

const string &
    Stream::equipment_name() const
{
    return impl_->equipment_name();
}

const string &
    Stream::tag_name() const
{
    return impl_->tag_name();
}

const vector<Tag>
    Stream::get_last_tag_list(size_t count) const
{
    return impl_->get_last_tag_list(count);
}

}
