#include <mxidafpp/impl/Value.hpp>

#include <boost/assert.hpp>

namespace mxidafpp
{
namespace impl
{

const mxidafpp::Value
    mxidafpp_from_mxtag(const mxtag::Value &v)
{
    if (v.is_int())
        return mxidafpp::Value(v.as_int());
    else if (v.is_uint())
        return mxidafpp::Value(v.as_uint());
    else if (v.is_float())
        return mxidafpp::Value(v.as_float());
    else if (v.is_string())
        return mxidafpp::Value(v.as_string());
    else
        BOOST_VERIFY(!"unexpected value type");
}

const mxtag::Value
    mxtag_from_mxidafpp(const mxidafpp::Value &v)
{
    if (v.is_int())
        return mxtag::Value(v.as_int());
    else if (v.is_uint())
        return mxtag::Value(v.as_uint());
    else if (v.is_float())
        return mxtag::Value(v.as_float());
    else if (v.is_string())
        return mxtag::Value(v.as_string());
    else
        BOOST_VERIFY(!"unexpected value type");
}

}
}
