#include <mxidafpp/impl/utility.hpp>

using boost::gregorian::date;
using boost::posix_time::milliseconds;
using boost::posix_time::ptime;
using boost::posix_time::time_duration;

namespace mxidafpp
{
namespace impl
{

const ptime
    precision_to_millisec(
        const ptime &pt)
{
    const date d = pt.date();
    const time_duration t = pt.time_of_day();

    return ptime(
        d,
        time_duration(
            t.hours(),
            t.minutes(),
            t.seconds()) + milliseconds(t.total_milliseconds() % 1000)
    );
}

}
}
