#include <iostream>

#include <boost/lexical_cast.hpp>

#include <mxidafpp/Service.hpp>

using boost::lexical_cast;

using mxidafpp::Service;
using mxidafpp::Tag;
using mxidafpp::TagImporter;
using mxidafpp::Value;

using std::cerr;
using std::endl;
using std::string;
using std::vector;

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 3)
    {
        cerr << "usage: <host> <port>" << endl;
        return 1;
    }

    const string host = argv[1];
    const int port = lexical_cast<int>(argv[2]);

    TagImporter importer = Service::instance().get_tag_importer(
        host,
        port);

    while(true)
    {
        try
        {
            importer.import(
                "equipment1",
                "e1tag2",
                vector<Tag>(1, Tag(Value(
                    "test-value")))
            );

            break;
        }
        catch(mxidafpp::Error &e)
        {
            sleep(1);

            continue;
        }
    }

    return 0;
}
