#include <boost/test/unit_test.hpp>

#include <mxidafpp/impl/Tag.hpp>

using boost::posix_time::time_from_string;

namespace
{

struct TestFixture
{
};

}

namespace mxidafpp
{
namespace impl
{

BOOST_FIXTURE_TEST_CASE(test_Tag_conversion_ShouldPass, TestFixture)
{
    // arrange
    const mxtag::Tag mxtag_tag(
        "equipment-name",
        "tag-name",
        time_from_string("2016-03-22 09:21:10"),
        mxtag::Value("some-value"),
        "some-unit");

    // act
    const mxidafpp::Tag tag = mxidafpp_from_mxtag(mxtag_tag);
    const mxtag::Tag product = mxtag_from_mxidafpp(
        tag,
        "equipment-name",
        "tag-name");

    BOOST_CHECK(mxtag_tag == product);
}

}
}
