#include <boost/test/unit_test.hpp>

#include <mxidafpp/impl/Value.hpp>

namespace
{

struct TestFixture
{
};

}

namespace mxidafpp
{
namespace impl
{

BOOST_FIXTURE_TEST_CASE(test_Value_conversion_WithInt_ShouldPass, TestFixture)
{
    // arrange
    const mxtag::Value mxtag_value(static_cast<int64_t>(-1234567));

    // act
    const mxidafpp::Value value = mxidafpp_from_mxtag(mxtag_value);
    const mxtag::Value product = mxtag_from_mxidafpp(value);

    // assert
    BOOST_CHECK(mxtag_value == product);
}

BOOST_FIXTURE_TEST_CASE(test_Value_conversion_WithUInt_ShouldPass, TestFixture)
{
    // arrange
    const mxtag::Value mxtag_value(static_cast<uint64_t>(1234567));

    // act
    const mxidafpp::Value value = mxidafpp_from_mxtag(mxtag_value);
    const mxtag::Value product = mxtag_from_mxidafpp(value);

    // assert
    BOOST_CHECK(mxtag_value == product);
}

BOOST_FIXTURE_TEST_CASE(test_Value_conversion_WithFloat_ShouldPass, TestFixture)
{
    // arrange
    const mxtag::Value mxtag_value(3.14);

    // act
    const mxidafpp::Value value = mxidafpp_from_mxtag(mxtag_value);
    const mxtag::Value product = mxtag_from_mxidafpp(value);

    // assert
    BOOST_CHECK(mxtag_value == product);
}

BOOST_FIXTURE_TEST_CASE(test_Value_conversion_WithString_ShouldPass, TestFixture)
{
    // arrange
    const mxtag::Value mxtag_value("some-value");

    // act
    const mxidafpp::Value value = mxidafpp_from_mxtag(mxtag_value);
    const mxtag::Value product = mxtag_from_mxidafpp(value);

    // assert
    BOOST_CHECK(mxtag_value == product);
}

}
}
