#include <boost/test/unit_test.hpp>

#include <mxidafpp/Service.hpp>

#include "DatabaseFixture.hpp"

namespace
{

struct TestFixture
    : public DatabaseFixture
{
};

}

namespace mxidafpp
{

BOOST_FIXTURE_TEST_CASE(test_Service_get_cache_ShouldPass, TestFixture)
{
    // arrange

    // act
    const Cache c = Service::instance().get_cache();

    // assert
}

BOOST_FIXTURE_TEST_CASE(test_Service_get_cache_WhenDbNotExist_ShouldRaiseNotFoundError, TestFixture)
{
    // arrange
    if (0 != unlink("/dev/shm/mxhtag.sqlite3"))
    {
        // ignored
    }

    // act & assert
    BOOST_CHECK_THROW(Service::instance().get_cache(), NotFoundError);
}

BOOST_FIXTURE_TEST_CASE(test_Service_get_cache_WithPath_ShouldPass, TestFixture)
{
    // arrange

    // act
    const Cache c = Service::instance().get_cache("/dev/shm/mxhtag.sqlite3");

    // assert
}

BOOST_FIXTURE_TEST_CASE(test_Service_get_cache_WithNotExistPath_ShouldRaiseNotFoundError, TestFixture)
{
    // arrange
    if (0 != unlink("/dev/shm/mxhtag.sqlite3"))
    {
        // ignored
    }

    // act & assert
    BOOST_CHECK_THROW(Service::instance().get_cache("/dev/shm/mxhtag.sqlite3"), NotFoundError);
}

}
