#include <boost/test/unit_test.hpp>

#include <mxidafpp/Value.hpp>

#include <sstream>

using std::stringstream;

namespace
{

struct TestFixture
{
};

}

namespace mxidafpp
{

BOOST_FIXTURE_TEST_CASE(test_Value_operator_eq_ShouldPass, TestFixture)
{
    // arrange
    const Value lhs("some-value");
    const Value rhs("some-value");

    // act
    const bool should_be_true = lhs == rhs;

    // assert
    BOOST_CHECK(should_be_true);
}

BOOST_FIXTURE_TEST_CASE(test_Value_operator_ne_ShouldPass, TestFixture)
{
    // arrange
    const Value lhs("some-value");
    const Value rhs("some-other-value");

    // act
    const bool should_be_true = lhs != rhs;

    // assert
    BOOST_CHECK(should_be_true);
}

BOOST_FIXTURE_TEST_CASE(test_Value_operator_putto_ShouldPass, TestFixture)
{
    // arrange
    const Value rhs("some-value");

    stringstream ss;

    // act
    ss << rhs;

    // assert
    BOOST_CHECK_EQUAL("some-value", ss.str());
}

}
