#include <iostream>

#include <boost/foreach.hpp>
#include <boost/lexical_cast.hpp>

#include <mxidafpp/Service.hpp>

using boost::lexical_cast;

using mxidafpp::Cache;
using mxidafpp::Equipment;
using mxidafpp::Service;
using mxidafpp::Stream;
using mxidafpp::Tag;

using std::cout;
using std::cerr;
using std::endl;
using std::string;
using std::vector;

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 3)
    {
        cerr << "usage: <path> <iteration>" << endl;
        return 1;
    }

    const string path = argv[1];
    const int iteration = lexical_cast<int>(argv[2]);

    for(int ax = 0; ax < iteration; ++ax)
    {
        Cache cache = Service::instance().get_cache();

        vector<Equipment> equipment_list = cache.get_equipment_list();
        BOOST_FOREACH(Equipment &equipment, equipment_list)
        {
            vector<Stream> stream_list = equipment.get_stream_list();
            BOOST_FOREACH(Stream &stream, stream_list)
            {
                const vector<Tag> tag_list = stream.get_last_tag_list();

                BOOST_FOREACH(const Tag &tag, tag_list)
                {
                    cout << tag.at() << ":" << tag.value() << ":" << tag.unit() << endl;
                }
            }
        }
    }

    return 0;
}
