#ifndef _MXMODBUS_ERROR_HPP_
#define _MXMODBUS_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

#include <mxmodbus/types.hpp>
#include <mxmodbus/exception.hpp>

namespace mxmodbus
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbus::Error";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_msg, std::string>
    EInfoMsg;

struct ProtocolError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbus::ProtocolError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_device, mxmodbus::device_t>
    EInfoDevice;

typedef
    boost::error_info<struct tag_address, mxmodbus::address_t>
    EInfoAddress;

typedef
    boost::error_info<struct tag_quantity, std::size_t>
    EInfoQuantity;

typedef
    boost::error_info<struct tag_exception, mxmodbus::exception_t>
    EInfoException;

}

#endif
