#include <mxmodbus/priv/utility.hpp>

#include <boost/foreach.hpp>

#include <modbus/modbus.h>

using std::vector;

namespace mxmodbus
{
namespace priv
{

const vector<bool>
    bool_vector_from_uint8_vector(const vector<uint8_t> &buf)
{
    vector<bool> rtn;
    BOOST_FOREACH(uint8_t b, buf)
    {
        rtn.push_back(b == 0x01);
    }

    return rtn;
}

const vector<uint8_t>
    uint8_vector_from_bool_vector(const vector<bool> &buf)
{
    vector<uint8_t> rtn;
    BOOST_FOREACH(bool b, buf)
    {
        rtn.push_back(b ? 0x01 : 0x00);
    }

    return rtn;
}

void
    append_exception_info(ProtocolError &e)
{
    if (errno >= EMBXILFUN &&
        errno <= EMBXGTAR)
    {
        e << EInfoException(errno - MODBUS_ENOBASE);
    }
}

}
}
