#ifndef _MXMQTT_MESSAGE_HPP_
#define _MXMQTT_MESSAGE_HPP_

#include <string>
#include <vector>

#include <boost/cstdint.hpp>

#include <boost/shared_ptr.hpp>

namespace mxmqtt
{

class Message // value, no-cmp
{
public:
    Message(
        const std::string &topic,
        const std::vector<uint8_t> &payload,
        int qos,
        bool retain);
    //Message(const Message &);
    ~Message();

    const std::string &
        topic() const;
    const std::vector<uint8_t> &
        payload() const;
    int
        qos() const;
    bool
        retain() const;

    //const Message &
    //  operator =(const Message &);

    bool
        operator ==(const Message &) const;
    bool
        operator !=(const Message &) const;

public:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}

#endif
