#ifndef _MXMQTT_ERROR_HPP_
#define _MXMQTT_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxmqtt
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmqtt::Error";
        return WHAT;
    }
};

struct MosquittoError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmqtt::MosquittoError";
        return WHAT;
    }
};

struct IllegalStateError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmqtt::IllegalStateError";
        return WHAT;
    }
};

struct NotConnectedError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmqtt::NotConnectedError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_mosquitto_err_code, int>
    MosquittoErrCode;

typedef
    boost::error_info<struct tag_err_msg, std::string>
    ErrMsg;

}

#endif
