#include <iostream>

#include <boost/lexical_cast.hpp>
#include <boost/range.hpp>

#include <mxmqtt/Client.hpp>

using boost::lexical_cast;
using boost::size;

using mxmqtt::Message;
using mxmqtt::Client;

using std::cerr;
using std::cout;
using std::endl;
using std::string;
using std::vector;

void
    process_message(const Message &msg)
{
    cout << "topic = " << msg.topic()
        << ", payload = " << string(msg.payload().begin(), msg.payload().end()) << endl;
}

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 3)
    {
        cerr << "usage: <host> <port>" << endl;
        return 1;
    }

    const string host = argv[1];
    const int port = lexical_cast<int>(argv[2]);

    const string topic_list[] = {
        "/#"
    };

    Client client(
        host,
        port,
        "subscriber",
        &process_message,
        vector<string>(topic_list, topic_list + size(topic_list)),
        true);

    for(int ax = 0; ax < 600; ++ax)
    {
        usleep(100 * 1000);
        client.loop(0);
    }

    return 0;
}
