#include <iostream>
#include <string>

#include <boost/lexical_cast.hpp>
#include <boost/range.hpp>

#include <mxmqtt/Worker.hpp>

using boost::lexical_cast;
using boost::size;

using mxmqtt::Message;
using mxmqtt::Worker;

using std::cerr;
using std::endl;
using std::string;
using std::vector;

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 4)
    {
        cerr << "usage: <ip> <port> <msg-count>" << endl;
        return 1;
    }

    const string ip = argv[1];
    const int port = lexical_cast<int>(argv[2]);
    const int msg_count = lexical_cast<int>(argv[3]);

    Worker worker(
        ip,
        port,
        "worker-publish");

    const char PAYLOAD[] = "this is payload";
    for(int ax = 0; ax < msg_count; ++ax)
        worker.publish(Message(
            "/this/is/topic",
            vector<uint8_t>(&PAYLOAD[0], &PAYLOAD[0] + size(PAYLOAD)),
            2,
            false));

    return 0;
}
