#ifndef _MXTAG_TAG_HPP_
#define _MXTAG_TAG_HPP_

#include <string>

#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/shared_ptr.hpp>

#include <mxtag/error.hpp>
#include <mxtag/Value.hpp>

namespace mxtag
{

class Tag // value, no-cmp, immutable
{
public:
    Tag(
        const std::string &equipment,
        const std::string &tag,
        const boost::posix_time::ptime &,
        const mxtag::Value &,
        const std::string &unit = "");  // throws mxtag::ArgumentError

    //Tag(const Tag &);

    ~Tag();

    const std::string &
        equipment() const;
    const std::string &
        tag() const;
    const boost::posix_time::ptime &
        at() const;
    const mxtag::Value &
        value() const;
    const std::string &
        unit() const;

    //Tag &
    //    operator =(const Tag &);

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

bool
    operator ==(
        const Tag &lhs,
        const Tag &rhs);

bool
    operator !=(
        const Tag &lhs,
        const Tag &rhs);

}

#endif
