#ifndef _MXTAG_ERROR_HPP_
#define _MXTAG_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxtag
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxtag::Error";
        return WHAT;
    }
};

struct ArgumentError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxtag::ArgumentError";
        return WHAT;
    }
};

struct Eof
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxtag::Eof";
        return WHAT;
    }
};

struct ParseError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxtag::ParseError";
        return WHAT;
    }
};

struct SystemError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxtag::SystemError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_err_msg, std::string>
    EInfoMsg;

}

#endif

