#ifndef _MXTAG_ENVELOPED_ISTREAM_HPP_
#define _MXTAG_ENVELOPED_ISTREAM_HPP_

#include <iosfwd>
#include <vector>

#include <boost/cstdint.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxtag/error.hpp>

namespace mxtag
{
namespace log
{

class EnvelopedIStream
    : private boost::noncopyable
{
public:
    explicit EnvelopedIStream(std::istream &);
    ~EnvelopedIStream();

    const std::vector<uint8_t>
        read(); // throws mxtag::Eof, mxtag::ParseError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

EnvelopedIStream &
    operator >>(
        EnvelopedIStream &,
        std::vector<uint8_t> &);    // throws mxtag::Eof, mxtag::ParseError

}
}

#endif
