#ifndef _MXTAG_LOG_ENVELOPED_OSTREAM_HPP_
#define _MXTAG_LOG_ENVELOPED_OSTREAM_HPP_

#include <iosfwd>
#include <vector>

#include <boost/cstdint.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxtag/error.hpp>

namespace mxtag
{
namespace log
{

class EnvelopedOStream
    : private boost::noncopyable
{
public:
    EnvelopedOStream(
        std::ostream &,
        std::size_t buffer_size = 0);
    ~EnvelopedOStream();

    std::size_t
        bytes_written() const;
    void
        write(const std::vector<uint8_t> &);    // throws mxtag::SystemError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

EnvelopedOStream &
    operator <<(
        EnvelopedOStream &,
        const std::vector<uint8_t> &);

}
}

#endif
