#ifndef _MXTAG_LOG_PROTOBUF_SERIALIZER_HPP_
#define _MXTAG_LOG_PROTOBUF_SERIALIZER_HPP_

#include <mxtag/log/Serializer.hpp>

namespace mxtag
{
namespace log
{

class ProtobufSerializer
    : public mxtag::log::Serializer
{
public:
    ProtobufSerializer();
    virtual ~ProtobufSerializer();

private:
    virtual const std::vector<uint8_t>
        do_from_tag(const mxtag::Tag &) const;
    virtual const mxtag::Tag
        do_to_tag(const std::vector<uint8_t> &) const;
    virtual const std::vector<uint8_t>
        do_from_tag_list(const std::map<std::string, std::set<std::string> > &) const;
    virtual const std::map<std::string, std::set<std::string> >
        do_to_tag_list(const std::vector<uint8_t> &) const;
};

}
}

#endif
