#ifndef _MXTAG_MQTT_PROTOBUF_SERIALIZER_HPP_
#define _MXTAG_MQTT_PROTOBUF_SERIALIZER_HPP_

#include <mxtag/mqtt/Serializer.hpp>

namespace mxtag
{
namespace mqtt
{

class ProtobufSerializer
    : public mxtag::mqtt::Serializer
{
public:
    ProtobufSerializer();
    virtual ~ProtobufSerializer();

private:
    virtual const std::pair<std::string, std::vector<uint8_t> > // pair<topic, payload>
        do_from_tag(const mxtag::Tag &) const;

    virtual const mxtag::Tag
        do_to_tag(
            const std::string &topic,
            const std::vector<uint8_t> &payload) const; // throws mxtag::ParseError
};

}
}

#endif
