#ifndef _MXTAG_MQTT_SERIALIZER_HPP_
#define _MXTAG_MQTT_SERIALIZER_HPP_

#include <string>
#include <utility>
#include <vector>

#include <boost/cstdint.hpp>
#include <boost/noncopyable.hpp>

#include <mxtag/error.hpp>
#include <mxtag/Tag.hpp>

namespace mxtag
{
namespace mqtt
{

class Serializer
    : private boost::noncopyable
{
protected:
    Serializer();

public:
    virtual ~Serializer();

    const std::pair<std::string, std::vector<uint8_t> > // pair<topic, payload>
        from_tag(const mxtag::Tag &) const;

    const mxtag::Tag
        to_tag(
            const std::string &topic,
            const std::vector<uint8_t> &payload) const; // throws mxtag::ParseError

private:
    virtual const std::pair<std::string, std::vector<uint8_t> > // pair<topic, payload>
        do_from_tag(const mxtag::Tag &) const = 0;

    virtual const mxtag::Tag
        do_to_tag(
            const std::string &topic,
            const std::vector<uint8_t> &payload) const = 0; // throws mxtag::ParseError
};

}
}

#endif
