#ifndef _MXTAG_MQTT_TAG_SUBSCRIBER_HPP_
#define _MXTAG_MQTT_TAG_SUBSCRIBER_HPP_

#include <map>
#include <set>
#include <string>

#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/function.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxtag/Tag.hpp>

namespace mxtag
{
namespace mqtt
{

class TagSubscriber
    : private boost::noncopyable
{
public:
    typedef
        boost::function<
            void
                (const mxtag::Tag &)
        >
        ProcessTagCallback;

public:
    TagSubscriber(
        const std::string &host,
        int port,
        const std::string &client_id,
        bool clean_session,
        const std::map<std::string, std::set<std::string> > &eq_tag_list,   // map<equipment, set<tag> >
        const ProcessTagCallback &);
    virtual ~TagSubscriber();

    void
        loop(int timeoutMS = 100);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
