#ifndef _MXTAG_PRIV_CONVERSION_HPP_
#define _MXTAG_PRIV_CONVERSION_HPP_

#include <boost/cstdint.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

#include <tag.pb.h>

#include <mxtag/error.hpp>
#include <mxtag/Value.hpp>

namespace mxtag
{
namespace priv
{

uint64_t
    at_ms_from_ptime(const boost::posix_time::ptime &);
const boost::posix_time::ptime
    ptime_from_at_ms(uint64_t);

void
    value_to_pb_value(
        const mxtag::Value &,
        mxtag::pb::Value &);

const mxtag::Value
    value_from_pb_value(
        const mxtag::pb::Value &);   // throws mxtag::ParseError

}
}

#endif
