#include <mxtag/log/Serializer.hpp>

#include <mxutil/log.hpp>

using std::map;
using std::set;
using std::string;
using std::vector;

namespace mxtag
{
namespace log
{

Serializer::Serializer()
{
}

Serializer::~Serializer()
{
}

const vector<uint8_t>
    Serializer::from_tag(const Tag &t) const
{
    try
    {
        return this->do_from_tag(t);
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

const Tag
    Serializer::to_tag(const vector<uint8_t> &v) const
{
    try
    {
        return this->do_to_tag(v);
    }
    catch(ParseError &)
    {
        throw;
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

const vector<uint8_t>
    Serializer::from_tag_list(const map<string, set<string> > &tag_list) const
{
    try
    {
        return this->do_from_tag_list(tag_list);
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

const map<string, set<string> >
    Serializer::to_tag_list(const vector<uint8_t> &v) const
{
    try
    {
        return this->do_to_tag_list(v);
    }
    catch(ParseError &)
    {
        throw;
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

}
}
