#include <mxtag/mqtt/Serializer.hpp>

#include <mxutil/log.hpp>

using std::pair;
using std::string;
using std::vector;

namespace mxtag
{
namespace mqtt
{

Serializer::Serializer()
{
}

Serializer::~Serializer()
{
}

const pair<string, vector<uint8_t> >
    Serializer::from_tag(const Tag &t) const
{
    try
    {
        return this->do_from_tag(t);
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

const Tag
    Serializer::to_tag(
        const string &topic,
        const vector<uint8_t> &payload) const
{
    try
    {
        return this->do_to_tag(topic, payload);
    }
    catch(ParseError &)
    {
        throw;
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

}
}
