#include <mxtag/priv/mqtt.hpp>

#include <boost/regex.hpp>

using boost::regex;
using boost::smatch;

using std::string;

namespace mxtag
{
namespace priv
{

bool
    parse_topic(
        const string &topic,
        string &equipment_id,
        string &tag_id)
{
    static const regex e(
        "^/equs/([\\w\\d](?:[\\w\\d\\- ]*[\\w\\d])*)/tags/([\\w\\d](?:[\\w\\d\\- ]*[\\w\\d])*)$"
    );

    smatch what;
    if (!regex_match(
            topic,
            what,
            e))
    {
        return false;
    }

    equipment_id = what[1].str();
    tag_id = what[2].str();

    return true;
}

}
}
