#include <mxtag/tag_form.hpp>

#include <iomanip>
#include <sstream>

using boost::posix_time::ptime;

using std::setfill;
using std::setw;
using std::string;
using std::stringstream;

namespace mxtag
{

const string
    form_iso8601_time(const ptime &time)
{
    stringstream at;
    at  << setw(4)
        << time.date().year() << "-"
        << setw(2) << setfill('0')
        << static_cast<int>(time.date().month()) << "-"
        << setw(2) << setfill('0')
        << time.date().day() << "T"
        << setw(2) << setfill('0')
        << time.time_of_day().hours() << ":"
        << setw(2) << setfill('0')
        << time.time_of_day().minutes() << ":"
        << setw(2) << setfill('0')
        << time.time_of_day().seconds()
        << '.' << setw(3) << setfill('0') << time.time_of_day().total_milliseconds() % 1000
        << "Z";

    return at.str();
}

}
