#include <mxtag/tag_parse.hpp>

#include <boost/regex.hpp>

#include <mxutil/log.hpp>

using boost::posix_time::ptime;
using boost::posix_time::time_from_string;
using boost::regex;
using boost::regex_match;
using boost::smatch;

using std::string;

namespace mxtag
{

bool
    parse_iso8601_time(
        const string &v,
        ptime &t)
{
    static const regex e(
        "^("
            "[[:digit:]]{4}"
            "-[[:digit:]]{2}"
            "-[[:digit:]]{2}"
        ")T("
            "[[:digit:]]{2}"
            ":[[:digit:]]{2}"
            ":[[:digit:]]{2}"
            "(?:\\.[[:digit:]]{0,3})?"
        ")Z$"
    );

    smatch what;
    if (!regex_match(
            v,
            what,
            e))
    {
        MXLOG_WARN("parse error: " + v);
        return false;
    }

    t = time_from_string(what[1].str() + " " + what[2].str());

    return true;
}

}
