#include <mxtag/validate.hpp>

#include <boost/regex.hpp>

using boost::regex;

using std::string;

namespace mxtag
{

bool
    is_valid_equipment_name(
        const string &s)
{
    static const regex e(
        "^[A-Za-z0-9_-]{3,255}$"
    );

    return regex_match(s.begin(), s.end(), e);
}

bool
    is_valid_tag_name(
        const string &s)
{
    static const regex e(
        "^[A-Za-z0-9_-]{2,255}$"
    );

    return regex_match(s.begin(), s.end(), e);
}

bool
    is_valid_unit(
        const string &s)
{
    static const regex e(
        "^[A-Za-z0-9_-]{0,255}$"
    );

    return regex_match(s.begin(), s.end(), e);
}

}
