#include <boost/test/unit_test.hpp>

#include <mxtag/log/EnvelopedIStream.hpp>
#include <mxtag/log/EnvelopedOStream.hpp>

#include <sstream>

#include <boost/range.hpp>

using boost::size;

using std::stringstream;
using std::vector;

namespace
{

class TestFixture
{
};

}

namespace mxtag
{
namespace log
{

BOOST_FIXTURE_TEST_CASE(test_EnvelopedStream_IO_ShouldPass, TestFixture)
{
    // arrange
    const uint8_t V0[] = {0x01, 0x02, 0x03};
    const uint8_t V1[] = {0xFF, 0xFE, 0xFD};
    const uint8_t V2[] = {0x77, 0x88, 0x99};

    const vector<uint8_t> v0(&V0[0], &V0[0] + size(V0));
    const vector<uint8_t> v1(&V1[0], &V1[0] + size(V1));
    const vector<uint8_t> v2(&V2[0], &V2[0] + size(V2));

    // act
    stringstream ss;
    EnvelopedOStream eos(ss);
    eos << v0 << v1 << v2;

    EnvelopedIStream eis(ss);
    vector<uint8_t> r0;
    vector<uint8_t> r1;
    vector<uint8_t> r2;
    eis >> r0 >> r1 >> r2;

    // assert
    BOOST_CHECK(r0 == v0);
    BOOST_CHECK(r1 == v1);
    BOOST_CHECK(r2 == v2);
}

}
}
