#include <boost/test/unit_test.hpp>

#include <mxtag/tag_parse.hpp>

using boost::posix_time::ptime;
using boost::posix_time::time_from_string;

using std::string;

namespace
{

class TestFixture
{
};

}

namespace mxtag
{

BOOST_FIXTURE_TEST_CASE(test_parse_iso8601_time_ShouldPass, TestFixture)
{
    // arrange
    const string SUT = "2015-08-04T17:12:58.482Z";

    // act
    ptime at;
    const bool match = parse_iso8601_time(SUT, at);

    // assert
    BOOST_REQUIRE(match);
    BOOST_CHECK_EQUAL(time_from_string("2015-08-04 17:12:58.482"), at);
}

BOOST_FIXTURE_TEST_CASE(test_parse_iso8601_time_WithWrongFormat_ShouldReturnFalse, TestFixture)
{
    // arrange
    const string SUT = "2015-08-04 17:12:58.482";

    // act
    ptime at;
    const bool should_be_false = parse_iso8601_time(SUT, at);

    // assert
    BOOST_CHECK(!should_be_false);
}

}
