#include <fstream>
#include <iostream>
#include <string>
#include <vector>

#include <boost/lexical_cast.hpp>

#include <mxtag/log/EnvelopedOStream.hpp>

using boost::lexical_cast;

using mxtag::log::EnvelopedOStream;

using std::cerr;
using std::endl;
using std::ios_base;
using std::ofstream;
using std::string;
using std::vector;

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 4)
    {
        cerr << "usage: <path> <file-size> <buffer-size>" << endl;
        return 1;
    }

    const string file_path = argv[1];
    const size_t file_size = lexical_cast<size_t>(argv[2]);
    const size_t buffer_size = lexical_cast<size_t>(argv[3]);

    ofstream os(file_path.c_str(), ios_base::binary);
    EnvelopedOStream eos(os, buffer_size);

    vector<uint8_t> buf(30, 0x5A);

    for (size_t ax = 0; ax < file_size; ax += buf.size())
    {
        eos.write(buf);
    }

    return 0;
}
