#include <iostream>

#include <boost/lexical_cast.hpp>

#include <mxtag/mqtt/tag_parse.hpp>

using boost::lexical_cast;
using boost::posix_time::ptime;

using mxtag::mqtt::parse_payload;

using std::cerr;
using std::endl;
using std::string;

int
    main(
        int argc,
        const char *argv[])
{
    if (argc != 2)
    {
        cerr << "usage: <loop-count>" << endl;
        return 1;
    }

    const int loop_count = lexical_cast<int>(argv[1]);

    const string SUT =
        "{\"value\": 123.456, \"at\": \"2015-08-04T16:33:19.553Z\", \"unit\": \"pcs.\"}";

    ptime t;
    string v;
    string u;
    for(int ax = 0; ax < loop_count; ++ax)
    {
        const bool shall_be_true = parse_payload(SUT, t, v, u);
        BOOST_ASSERT(shall_be_true);
    }

    return 0;
}
