#ifndef _MXUTIL_PID_FILE_HPP_
#define _MXUTIL_PID_FILE_HPP_

#include <string>

#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxutil/error.hpp>

namespace mxutil
{

class PidFile
{
public:
    static boost::shared_ptr<PidFile>
        get(const std::string &path);  // throws mxutil::LockError

private:
    explicit PidFile(const std::string &path);  // throws mxutil::LockError

public:
    ~PidFile();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
