#ifndef _MXUTIL_SIGNAL_HPP_
#define _MXUTIL_SIGNAL_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxutil/error.hpp>

namespace mxutil
{

class Signal
    : private boost::noncopyable
{
public:
    static Signal &
        instance();

private:
    Signal();
    ~Signal();

public:
    void
        sigterm(void (*handler)(int));  // throws mxutil::SystemError

    void
        sigusr1(void (*handler)(int));  // throws mxutil::SystemError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
