#ifndef _MXUTIL_ERROR_HPP_
#define _MXUTIL_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxutil
{

struct ArgumentError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxutil::ArgumentError";
        return WHAT;
    }
};

struct LockError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxutil::LockError";
        return WHAT;
    }
};

struct ParseError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxutil::ParseError";
        return WHAT;
    }
};

struct SystemError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxutil::SystemError";
        return WHAT;
    }
};

}

#endif
