#ifndef _MXUTIL_LOG_LOG_HPP_
#define _MXUTIL_LOG_LOG_HPP_

#include <sstream>
#include <string>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxutil/log/Logger.hpp>

namespace mxutil
{
namespace log
{

class Log
    : private boost::noncopyable
{
public:
    static Log &
        get();

private:
    Log();

public:
    ~Log();

    void
        enable_line_of_file(bool = true);

    void
        set_logger(
            boost::shared_ptr<mxutil::log::Logger> logger);

    void
        log(
            mxutil::log::Logger::level_t,
            const char *file,
            int line,
            const std::string &msg);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;

private:
    static boost::shared_ptr<Log> instance;
};

}
}

#endif
