#ifndef _MXUTIL_LOG_LOGGER_HPP_
#define _MXUTIL_LOG_LOGGER_HPP_

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

namespace mxutil
{
namespace log
{

class Logger
    : private boost::noncopyable
{
public:
    typedef enum
    {
        DBUG,
        INFO,
        WARN,
        EROR
    } level_t;

public:
    Logger();
    virtual ~Logger();

    void
        enable_line_of_file(bool = true);

    void
        set_level(level_t);

    void
        log(
            level_t,
            const char *file,
            int line,
            const std::string &);

private:
    virtual void
        do_set_level(level_t){}

    virtual void
        do_log(
            level_t,
            const std::string &) = 0;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
