#ifndef _MXUTIL_LOG_OSTREAM_LOGGER_HPP_
#define _MXUTIL_LOG_OSTREAM_LOGGER_HPP_

#include <ostream>

#include <boost/scoped_ptr.hpp>

#include <mxutil/log/Logger.hpp>

namespace mxutil
{
namespace log
{

class OStreamLogger
    : public mxutil::log::Logger
{
public:
    explicit OStreamLogger(std::ostream &);
    virtual ~OStreamLogger();

    using mxutil::log::Logger::set_level;
    using mxutil::log::Logger::log;

private:
    virtual void
        do_log(
            level_t,
            const std::string &);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
