#ifndef _MXUTIL_LOG_SYSLOGLOGGER_HPP_
#define _MXUTIL_LOG_SYSLOGLOGGER_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxutil/log/Logger.hpp>

namespace mxutil
{
namespace log
{

class SyslogLogger
    : public mxutil::log::Logger
{
public:
    using mxutil::log::Logger::level_t;

public:
    explicit SyslogLogger(const std::string &name);
    virtual ~SyslogLogger();

    using mxutil::log::Logger::set_level;
    using mxutil::log::Logger::log;

private:
    virtual void
        do_log(
            level_t level,
            const std::string &str);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
