#ifndef _MXUTIL_SCHED_DAILY_SCHEDULER_HPP_
#define _MXUTIL_SCHED_DAILY_SCHEDULER_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxutil/sched/Scheduler.hpp>

namespace mxutil
{
namespace sched
{

class DailyScheduler
    : public mxutil::sched::Scheduler
{
public:
    using mxutil::sched::Scheduler::FireCallback;

public:
    DailyScheduler(
        const boost::posix_time::time_duration &period,
        const FireCallback &);
    virtual ~DailyScheduler();

    using mxutil::sched::Scheduler::check_and_fire;

private:
    virtual bool
        is_timeout(const boost::posix_time::ptime &now) const;

    virtual void
        reset_timeout(const boost::posix_time::ptime &now);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
