#ifndef _MXUTIL_SCHED_SCHEDULER_HPP_
#define _MXUTIL_SCHED_SCHEDULER_HPP_

#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/function.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

namespace mxutil
{
namespace sched
{

// Template Method Pattern
class Scheduler
    : private boost::noncopyable
{
public:
    typedef
        boost::function<
            void
                ()
        >
        FireCallback;

protected:
    explicit Scheduler(const FireCallback &);

public:
    virtual ~Scheduler();

    void
        check_and_fire();

private:
    virtual bool
        is_timeout(const boost::posix_time::ptime &now) const = 0;

    virtual void
        reset_timeout(const boost::posix_time::ptime &now) = 0;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
