#include <mxutil/Signal.hpp>

#include <signal.h>

namespace mxutil
{

Signal &
    Signal::instance()
{
    static Signal inst;
    return inst;
}

struct Signal::Impl
{
};

Signal::Signal()
{
}

Signal::~Signal()
{
}

void
    Signal::sigterm(void (*handler)(int))
{
    struct sigaction sact;
    sact.sa_handler = handler;
    sigemptyset(&sact.sa_mask);
    sact.sa_flags = 0;

    if (0 != sigaction(SIGTERM, &sact, NULL))
    {
        BOOST_THROW_EXCEPTION(SystemError());
    }
}

void
    Signal::sigusr1(void (*handler)(int))
{
    struct sigaction sact;
    sact.sa_handler = handler;
    sigemptyset(&sact.sa_mask);
    sact.sa_flags = 0;

    if (0 != sigaction(SIGUSR1, &sact, NULL))
    {
        BOOST_THROW_EXCEPTION(SystemError());
    }
}

}
