#include <mxutil/log/OStreamLogger.hpp>

#include <boost/static_assert.hpp>

using std::endl;
using std::ostream;
using std::string;

namespace mxutil
{
namespace log
{

struct OStreamLogger::Impl
{
    Impl(ostream &os_)
        : os(os_)
    {
    }

    ostream &   os;
};

OStreamLogger::OStreamLogger(ostream &os)
    : pimpl(new Impl(os))
{
}

OStreamLogger::~OStreamLogger()
{
}

void
    OStreamLogger::do_log(
        level_t lvl,
        const string &msg)
{
    BOOST_STATIC_ASSERT(
        DBUG == 0 &&
        INFO == 1 &&
        WARN == 2 &&
        EROR == 3);

    static const char *lvl_str[] = {
        "DBUG",
        "INFO",
        "WARN",
        "EROR"
    };

    pimpl->os << lvl_str[lvl] << ": " << msg << endl;
}

}
}
