#include <iostream>

#include <boost/shared_ptr.hpp>

#include <mxutil/log.hpp>
#include <mxutil/log/Logger.hpp>
#include <mxutil/log/StdoutLogger.hpp>
#include <mxutil/log/SyslogLogger.hpp>

using boost::shared_ptr;

using mxutil::log::Log;
using mxutil::log::Logger;
using mxutil::log::StdoutLogger;
using mxutil::log::SyslogLogger;

using std::cout;
using std::endl;
using std::string;

int
    main(
        int,
        char **)
{
    const string msg = "This is log message";

    cout << msg.c_str() << endl;

    shared_ptr<Logger> logger(new StdoutLogger());
    logger->enable_line_of_file();
    Log::get().set_logger(logger);
//    logger->set_level(mxutil::log::Logger::DBUG);

    MXLOG_DBUG(msg);
    MXLOG_EROR(msg);

    logger.reset(new SyslogLogger("test_logger"));
    Log::get().set_logger(logger);

    MXLOG_DBUG(msg);
    MXLOG_EROR(msg);

    return 0;
}
