#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/shared_ptr.hpp>

#include <mxutil/sched/DailyScheduler.hpp>

using boost::shared_ptr;
using boost::posix_time::microsec_clock;
using boost::posix_time::seconds;

using mxutil::sched::DailyScheduler;
using mxutil::sched::Scheduler;

using std::cout;
using std::endl;

namespace
{
void
    print_time();
}

int
    main()
{
    shared_ptr<Scheduler> sched(new DailyScheduler(
        seconds(15),
        &print_time
    ));

    for(int ax = 0; ax < 1000; ++ax)
    {
        sched->check_and_fire();
        usleep(100 * 1000);
    }
}

namespace
{

void
    print_time()
{
    cout << microsec_clock::local_time() << endl;
}

}
