#ifndef _MXLOGARCHIVER_APP_HPP_
#define _MXLOGARCHIVER_APP_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxutil/sched/Scheduler.hpp>

#include <mxtag/mqtt/TagSubscriber.hpp>

namespace mxlogarchiver
{

class App
    : private boost::noncopyable
{
public:
    App(
        boost::shared_ptr<mxtag::mqtt::TagSubscriber>,
        const std::vector<boost::shared_ptr<mxutil::sched::Scheduler> > &);
    ~App();

    void
        start();

    void
        loop();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
