#ifndef _MXLOGARCHIVER_ARCHIVE_DIRECTORY_HPP_
#define _MXLOGARCHIVER_ARCHIVE_DIRECTORY_HPP_

#include <string>

#include <boost/cstdint.hpp>
#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxlogarchiver/error.hpp>

namespace mxlogarchiver
{

class ArchiveDirectory
    : private boost::noncopyable
{
public:
    explicit ArchiveDirectory(const boost::filesystem::path &);
    ~ArchiveDirectory();

    void
        set_file_count_limit(unsigned int);  // throws mxlogarchiver::ArgumentError
    void
        set_directory_size_limit_byte(uint64_t); // throws mxlogarchiver::ArgumentError

    void
        add(
            const boost::filesystem::path &from,
            const std::string &name);   // name should be in format like '20150921-160405'

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
