#ifndef _MXLOGARCHIVER_ARCHIVE_REMOVE_WORKER_HPP_
#define _MXLOGARCHIVER_ARCHIVE_REMOVE_WORKER_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxlogarchiver/ArchiveDirectory.hpp>

namespace mxlogarchiver
{

class ArchiveRemoveWorker
    : private boost::noncopyable
{
public:
    ArchiveRemoveWorker();
    ~ArchiveRemoveWorker();

public:
    void
        add_path_and_directory(
            const boost::filesystem::path &,
            boost::shared_ptr<mxlogarchiver::ArchiveDirectory>);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
