#ifndef _MXLOGARCHIVER_BUILDER_HPP_
#define _MXLOGARCHIVER_BUILDER_HPP_

#include <string>

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxlogarchiver/App.hpp>
#include <mxlogarchiver/error.hpp>

namespace mxlogarchiver
{

class Builder
    : private boost::noncopyable
{
public:
    Builder();
    ~Builder();

    void
        set_configuration(
            const boost::filesystem::path &);

    void
        set_profile_directory(
            const boost::filesystem::path &);

    void
        set_mqtt_broker(
            const std::string &host,
            int service);   // throws mxlogarchiver::ArgumentError

    void
        clear_working_directory();

    boost::shared_ptr<mxlogarchiver::App>
        build() const;

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}

#endif
