#ifndef _MXLOGARCHIVER_LOG_ARCHIVER_HPP_
#define _MXLOGARCHIVER_LOG_ARCHIVER_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxlogarchiver/ArchiveDirectory.hpp>
#include <mxlogarchiver/ArchiveRemoveWorker.hpp>
#include <mxlogarchiver/LogStreamFactory.hpp>

#include <mxlogarchiver/error.hpp>

namespace mxlogarchiver
{

class LogArchiver
    : private boost::noncopyable
{
public:
    LogArchiver(
        boost::shared_ptr<mxlogarchiver::LogStreamFactory>,
        boost::shared_ptr<mxlogarchiver::ArchiveDirectory>,
        unsigned int log_threshold_byte,
        boost::shared_ptr<mxlogarchiver::ArchiveRemoveWorker>); // throws mxlogarchiver::SystemError
    ~LogArchiver();

    void
        write(const mxtag::Tag &);  // throws mxlogarchiver::SystemError

    void
        archive();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
