#ifndef _MXLOGARCHIVER_LOG_STREAM_HPP_
#define _MXLOGARCHIVER_LOG_STREAM_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>

#include <mxtag/Tag.hpp>

#include <mxlogarchiver/error.hpp>

namespace mxlogarchiver
{

class LogStream // interface
    : private boost::noncopyable
{
protected:
    LogStream();

public:
    virtual ~LogStream();

    const boost::filesystem::path &
        path() const;

    std::size_t
        bytes_written() const;
    void
        write(const mxtag::Tag &);  // throws mxlogarchiver::SystemError

private:
    virtual const boost::filesystem::path &
        do_path() const = 0;

    virtual std::size_t
        do_bytes_written() const = 0;

    virtual void
        do_write(const mxtag::Tag &) = 0;   // throws mxlogarchiver::SystemError
};

}

#endif
