#ifndef _MXLOGARCHIVER_LOG_STREAM_DECORATOR_HPP_
#define _MXLOGARCHIVER_LOG_STREAM_DECORATOR_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxlogarchiver/LogStream.hpp>

namespace mxlogarchiver
{

class LogStreamDecorator
    : public mxlogarchiver::LogStream
{
public:
    explicit LogStreamDecorator(boost::shared_ptr<mxlogarchiver::LogStream> inner);
    virtual ~LogStreamDecorator();

    using mxlogarchiver::LogStream::path;
    using mxlogarchiver::LogStream::bytes_written;
    using mxlogarchiver::LogStream::write;

private:
    virtual const boost::filesystem::path &
        do_path() const;

    virtual std::size_t
        do_bytes_written() const;

    virtual void
        do_write(const mxtag::Tag &);

protected:
    mxlogarchiver::LogStream &
        inner();

    const mxlogarchiver::LogStream &
        inner() const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
