#ifndef _MXLOGARCHIVER_LOG_STREAM_FACTORY_HPP_
#define _MXLOGARCHIVER_LOG_STREAM_FACTORY_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxlogarchiver/LogStream.hpp>

namespace mxlogarchiver
{

class LogStreamFactory
    : private boost::noncopyable
{
public:
    explicit LogStreamFactory(const boost::filesystem::path &directory);
    ~LogStreamFactory();

    const boost::filesystem::path &
        directory() const;

    boost::shared_ptr<mxlogarchiver::LogStream>
        create();

    void
        add_tag(
            const std::string &equipment,
            const std::string &tag,
            bool log_on_change);


private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
