#ifndef _MXLOGARCHIVER_LOG_STREAM_IMPL_HPP_
#define _MXLOGARCHIVER_LOG_STREAM_IMPL_HPP_

#include <map>
#include <set>
#include <string>

#include <boost/scoped_ptr.hpp>

#include <mxlogarchiver/LogStream.hpp>

namespace mxlogarchiver
{

class LogStreamImpl
    : public mxlogarchiver::LogStream
{
public:
    LogStreamImpl(
        const boost::filesystem::path &,
        const std::map<std::string, std::set<std::string> > &tag_list);
    virtual ~LogStreamImpl();

    using mxlogarchiver::LogStream::path;
    using mxlogarchiver::LogStream::bytes_written;
    using mxlogarchiver::LogStream::write;

private:
    virtual const boost::filesystem::path &
        do_path() const;

    virtual std::size_t
        do_bytes_written() const;

    virtual void
        do_write(const mxtag::Tag &);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
