#ifndef _MXLOGARCHIVER_TAG_FILTERING_DECORATOR_HPP_
#define _MXLOGARCHIVER_TAG_FILTERING_DECORATOR_HPP_

#include <map>
#include <set>
#include <string>

#include <mxlogarchiver/LogStreamDecorator.hpp>

namespace mxlogarchiver
{

class TagFilteringDecorator
    : public mxlogarchiver::LogStreamDecorator
{
public:
    TagFilteringDecorator(
        const std::map<std::string, std::set<std::string> > &allowed_tag_list,
        boost::shared_ptr<mxlogarchiver::LogStream> inner);
    virtual ~TagFilteringDecorator();

    using mxlogarchiver::LogStream::path;
    using mxlogarchiver::LogStream::bytes_written;
    using mxlogarchiver::LogStream::write;

private:
    virtual void
        do_write(const mxtag::Tag &);

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}

#endif
