#ifndef _MXLOGARCHIVER_ERROR_HPP_
#define _MXLOGARCHIVER_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxlogarchiver
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxlogarchiver::Error";
        return WHAT;
    }
};

struct ArgumentError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxlogarchiver::ArgumentError";
        return WHAT;
    }
};

struct ParseError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxlogarchiver::ParseError";
        return WHAT;
    }
};

struct SystemError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxlogarchiver::SystemError";
        return WHAT;
    }
};

}

#endif
