#include <mxlogarchiver/Configuration.hpp>

#include <libconfig.h++>

using libconfig::Config;
using libconfig::ParseException;
using libconfig::Setting;
using libconfig::SettingNotFoundException;

using std::string;

namespace mxlogarchiver
{

const Configuration
    Configuration::parse(const string &content)
{
    Config config;

    try
    {
        config.readString(content.c_str());


        const string working_directory = config.lookup("working-directory");

        return Configuration(working_directory);
    }
    catch(ParseException &e)
    {
        BOOST_THROW_EXCEPTION(ParseError());
    }
    catch(SettingNotFoundException &e)
    {
        BOOST_THROW_EXCEPTION(ParseError());
    }
}

}
