#ifndef _MXLOGCONVERTER_CSV_FORMATTER_HPP_
#define _MXLOGCONVERTER_CSV_FORMATTER_HPP_

#include <map>
#include <ostream>
#include <string>
#include <vector>

#include <boost/date_time/posix_time/posix_time.hpp>

#include <mxlogconverter/Extractor.hpp>
#include <mxlogconverter/Formatter.hpp>

namespace mxlogconverter
{

class CsvFormatter
    : public mxlogconverter::Formatter
{
public:
    CsvFormatter(
        std::ostream &,
        int window_size);
    virtual ~CsvFormatter();

private:
    virtual void
        print_header(std::ostream &);

    virtual void
        print_record(
            std::ostream &,
            const boost::posix_time::ptime &at,
            const std::map<std::string, std::vector<mxlogconverter::Formatter::Tag> > &);   // (equipment, vector<Tag>)

    virtual void
        print_footer(std::ostream &);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
