#ifndef _MXLOGCONVERTER_EXTRACTOR_HPP_
#define _MXLOGCONVERTER_EXTRACTOR_HPP_

#include <istream>
#include <map>
#include <set>
#include <string>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxtag/Tag.hpp>

namespace mxlogconverter
{

class Extractor
    : private boost::noncopyable
{
public:
    class Handler
        : private boost::noncopyable
    {
    protected:
        Handler(){}

    public:
        virtual ~Handler(){}

        virtual void
            on_equ_tag_list(const std::map<std::string, std::set<std::string> > &){}

        virtual void
            on_tag(const mxtag::Tag &){}

        virtual void
            on_eof(){}
    };

public:
    Extractor();
    ~Extractor();

    void
        parse(
            std::istream &,
            Handler &);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
