#ifndef _MXLOGCONVERTER_XML_FORMATTER_HPP_
#define _MXLOGCONVERTER_XML_FORMATTER_HPP_

#include <map>
#include <ostream>
#include <string>
#include <vector>

#include <boost/date_time/posix_time/posix_time.hpp>

#include <mxlogconverter/Formatter.hpp>

namespace mxlogconverter
{

class XmlFormatter
    : public mxlogconverter::Formatter
{
public:
    XmlFormatter(
        std::ostream &,
        int window_size);
    virtual ~XmlFormatter();

private:
    virtual void
        print_header(std::ostream &);

    virtual void
        print_record(
            std::ostream &,
            const boost::posix_time::ptime &,
            const std::map<std::string, std::vector<mxlogconverter::Formatter::Tag> > &); // (equipment, vector<Tag>)

    virtual void
        print_footer(std::ostream &);
};

}

#endif
