#include <mxlogconverter/RawPrinter.hpp>

#include <mxtag/log/JsonSerializer.hpp>

using mxtag::log::JsonSerializer;
using mxtag::Tag;

using std::endl;
using std::map;
using std::ostream;
using std::set;
using std::string;
using std::vector;

namespace mxlogconverter
{

struct RawPrinter::Impl
{
    Impl(ostream &os_)
        : os(os_)
    {
    }

    ostream &   os;

    JsonSerializer serializer;
};

RawPrinter::RawPrinter(ostream &os)
    : pimpl(new Impl(os))
{
}

RawPrinter::~RawPrinter()
{
}

void
    RawPrinter::on_equ_tag_list(const map<string, set<string> > &equ_tag_list)
{
    const vector<uint8_t> s = pimpl->serializer.from_tag_list(equ_tag_list);

    pimpl->os << string(s.begin(), s.end()) << '\n';
}

void
    RawPrinter::on_tag(const Tag &tag)
{
    const vector<uint8_t> s = pimpl->serializer.from_tag(tag);

    pimpl->os << string(s.begin(), s.end()) << '\n';
}

}
