#ifndef _MXLOGUPLOADER_APP_HPP_
#define _MXLOGUPLOADER_APP_HPP_

#include <boost/function.hpp>
#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <mxloguploader/Log.hpp>
#include <mxloguploader/LogConverter.hpp>
#include <mxloguploader/StatusUpdater.hpp>
#include <mxloguploader/Uploader.hpp>

namespace mxloguploader
{

class App
    : private boost::noncopyable
{
public:
    typedef
        boost::function<
            const std::string
                (const boost::filesystem::path &)
        >
        ConvertExternalFilenameFunc;

public:
    App(
        const boost::filesystem::path &log_directory,
        const boost::filesystem::path &working_directory,
        boost::shared_ptr<mxloguploader::StatusUpdater>,
        boost::shared_ptr<mxloguploader::LogConverter>,
        boost::shared_ptr<mxloguploader::Uploader>,
        const ConvertExternalFilenameFunc &external_filename,
        unsigned int file_count = 0);
    ~App();

    void
        run();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
