#ifndef _MXLOGUPLOADER_HTTP_POST_UPLOADER_HPP_
#define _MXLOGUPLOADER_HTTP_POST_UPLOADER_HPP_

#include <string>

#include <mxloguploader/Uploader.hpp>

namespace mxloguploader
{

class HttpPostUploader
    : public mxloguploader::Uploader
{
public:
    HttpPostUploader(
        const std::string &url,
        bool bypass_ssl,
        unsigned int retry_count,
        unsigned int retry_period_sec);
    virtual ~HttpPostUploader();

    void
        set_authentication(
            const std::string &username,
            const std::string &password);

    using mxloguploader::Uploader::upload;

private:
    virtual void
        do_upload(
            const std::string &filename,
            const boost::filesystem::path &); // throws mxloguploader::Error

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}

#endif
