#ifndef _MXLOGUPLOADER_LOG_HPP_
#define _MXLOGUPLOADER_LOG_HPP_

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>

#include <mxloguploader/LogConverter.hpp>

namespace mxloguploader
{

class Log
    : private boost::noncopyable
{
public:
    Log(const boost::filesystem::path &internal_log_path,
        boost::shared_ptr<mxloguploader::LogConverter>,
        const boost::filesystem::path &uploaded_symlink);
    ~Log();

    const boost::filesystem::path &
        internal_log_path() const;

    const boost::filesystem::path &
        get_external_log_path() const;  // throws mxloguploader::ConversionError

    void
        mark_uploaded();    // throws mxloguploader::SystemError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
