#ifndef _MXLOGUPLOADER_LOG_CONVERTER_HPP_
#define _MXLOGUPLOADER_LOG_CONVERTER_HPP_

#include <string>

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxloguploader/error.hpp>

namespace mxloguploader
{

class LogConverter
    : private boost::noncopyable
{
public:
    enum format_t
    {
        FORMAT_CSV,
        FORMAT_JSON,
        FORMAT_XML
    };

    enum compress_t
    {
        COMPRESS_NONE,
        COMPRESS_GZIP
    };

public:
    LogConverter(
        format_t,
        compress_t);
    ~LogConverter();

    void
        convert(
            const boost::filesystem::path &from,
            const boost::filesystem::path &to) const;     // throws mxloguploader::ConversionError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
