#ifndef _MXLOGUPLOADER_OPTION_HPP_
#define _MXLOGUPLAODER_OPTION_HPP_

#include <string>

#include <boost/logic/tribool.hpp>
#include <boost/shared_ptr.hpp>

namespace mxloguploader
{

struct Option
{
    boost::shared_ptr<std::string>  profile;
    boost::shared_ptr<std::string>  file;

    bool            upload;
    bool            upload_test;
    bool            clear;

    unsigned int    file_count;

    Option()
        : upload(false)
        , clear(false)
        , file_count(0)
    {
    }

    boost::logic::tribool
        parse_args(
            int argc,
            const char *argv[]);
};

}

#endif
