#ifndef _MXLOGUPLOADER_STATUS_PUBLISHER_HPP_
#define _MXLOGUPLOADER_STATUS_PUBLISHER_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxloguploader/Status.hpp>

namespace mxloguploader
{

class StatusPublisher
    : private boost::noncopyable
{
public:
    StatusPublisher(
        const std::string &profile,
        const std::string &host,
        int port);
    ~StatusPublisher();

    void
        publish(const mxloguploader::Status &);

    void
        clear();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
