#ifndef _MXLOGUPLOADER_STATUS_UPDATER_HPP_
#define _MXLOGUPLOADER_STATUS_UPDATER_HPP_

#include <string>

#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxloguploader/StatusPublisher.hpp>

namespace mxloguploader
{

class StatusUpdater
    : private boost::noncopyable
{
public:
    explicit StatusUpdater(
        const boost::filesystem::path &status_file,
        boost::shared_ptr<mxloguploader::StatusPublisher>);
    ~StatusUpdater();

    void
        update(
            const boost::filesystem::path &internal_log,
            bool success = true,
            const std::string &status = "success",
            const boost::posix_time::ptime &now = boost::posix_time::microsec_clock::universal_time());

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
