#ifndef _MXLOGUPLOADER_UPLOADER_HPP_
#define _MXLOGUPLOADER_UPLOADER_HPP_

#include <string>

#include <boost/filesystem.hpp>
#include <boost/function.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxloguploader/error.hpp>

namespace mxloguploader
{

// Template Method Pattern

class Uploader
    : private boost::noncopyable
{
protected:
    Uploader(
        unsigned int retry_count,
        unsigned int retry_period_sec);

public:
    virtual ~Uploader();

    void
        upload(
            const boost::filesystem::path &,
            const std::string *change_filename = 0);   // throws mxloguploader::Error

private:
    virtual void
        do_upload(
            const std::string &filename,
            const boost::filesystem::path &) = 0; // throws mxloguploader::Error

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
