#ifndef _MXLOGUPLOADER_ERROR_HPP_
#define _MXLOGUPLOADER_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxloguploader
{

struct Error
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxloguploader::Error";
        return WHAT;
    }
};

struct ConversionError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxloguploader::ConversionError";
        return WHAT;
    }
};

struct ParseError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxloguploader::ParseError";
        return WHAT;
    }
};

struct SystemError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxloguploader::SystemError";
        return WHAT;
    }
};

struct UploadError
    : virtual Error
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxloguploader::UploadError";
        return WHAT;
    }
};

}

#endif
