#ifndef _MXMODBUSGATEWAY_APP_HPP_
#define _MXMODBUSGATEWAY_APP_HPP_

#include <vector>

#include <boost/asio.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusgateway/Server.hpp>

namespace mxmodbusgateway
{

class App
    : private boost::noncopyable
{
public:
    App(
        boost::shared_ptr<boost::asio::io_service>,
        const std::vector<boost::shared_ptr<mxmodbusgateway::Server> > &);
    ~App();

    void
        start();
    void
        stop();

    void
        loop();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
