#ifndef _MXMODBUSGATEWAY_BUILDER_HPP_
#define _MXMODBUSGATEWAY_BUILDER_HPP_

#include <boost/asio.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>

#include <mxmodbusgateway/App.hpp>

namespace mxmodbusgateway
{

class Builder
    : private boost::noncopyable
{
public:
    Builder();
    ~Builder();

    void
        set_configuration(
            const boost::filesystem::path &); // throws mxmodbusgateway::ArgumentError

    boost::shared_ptr<mxmodbusgateway::App>
        build() const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
