#ifndef _MXMODBUSGATEWAY_COMMAND_HPP_
#define _MXMODBUSGATEWAY_COMMAND_HPP_

#include <vector>

#include <boost/noncopyable.hpp>
#include <boost/cstdint.hpp>

#include <mxutil/async.hpp>

#include <mxmodbusgateway/worker/ModbusWorker.hpp>

namespace mxmodbusgateway
{

class Command // interface
    : private boost::noncopyable
{
protected:
    Command();

public:
    virtual ~Command();

    virtual void
        async_execute(
            mxmodbusgateway::worker::ModbusWorker &,
            std::vector<uint8_t> &out,
            const mxutil::CompleteCallback &) = 0;
};

}

#endif
