#ifndef _MXMODBUSGATEWAY_COMMAND_FACTORY_HPP_
#define _MXMODBUSGATEWAY_COMMAND_FACTORY_HPP_

#include <vector>

#include <boost/asio.hpp>
#include <boost/cstdint.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusgateway/Command.hpp>
#include <mxmodbusgateway/error.hpp>

namespace mxmodbusgateway
{

class CommandFactory
    : private boost::noncopyable
{
public:
    CommandFactory();
    ~CommandFactory();

    void
        append_raw(const std::vector<uint8_t> &);

    boost::shared_ptr<mxmodbusgateway::Command>
        extract_command(boost::asio::io_service &);     // throws mxmodbusgateway::ParseError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
