#ifndef _MXMODBUSGATEWAY_ERRC_HPP_
#define _MXMODBUSGATEWAY_ERRC_HPP_

#include <boost/system/error_code.hpp>

#include <mxmodbus/exception.hpp>

namespace mxmodbusgateway
{
namespace errc
{

enum errc_t
{
    success = 0,
    unknown_error,
    parse_error,
    timeout_error,
    modbus_error,
    // reserve a arrange for modbus_exception
    modbus_exception_base = modbus_error,
    modbus_exception_first = modbus_exception_base + 1,
    modbus_exception_last = modbus_exception_base + 255
};

const boost::system::error_category &
    category();

mxmodbus::exception_t
    modbus_exception_from_error_code(const boost::system::error_code &);

}
}

#endif
