#ifndef _MXMODBUSGATEWAY_WORKER_WRITE_MULTIPLE_COMMAND_HPP_
#define _MXMODBUSGATEWAY_WORKER_WRITE_MULTIPLE_COMMAND_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxmodbus/types.hpp>

#include <mxmodbusgateway/worker/Command.hpp>

namespace mxmodbusgateway
{
namespace worker
{

template <
    typename VALUE,
    void (mxmodbus::ModbusClient::*WRITE_MULTIPLE_FUNC)(
        mxmodbus::device_t,
        mxmodbus::address_t,
        const VALUE &value
    )
>
class WriteMultipleCommand
    : public mxmodbusgateway::worker::Command
{
public:
    WriteMultipleCommand(
        mxmodbus::device_t device,
        mxmodbus::address_t address,
        VALUE value)
        : device_(device)
        , address_(address)
        , value_(value)
    {
    }

    virtual ~WriteMultipleCommand(){}

private:
    virtual void
        do_execute(mxmodbus::ModbusClient &mc)
    {
        (mc.*WRITE_MULTIPLE_FUNC)(this->device_, this->address_, this->value_);
    }

private:
    const mxmodbus::device_t    device_;
    const mxmodbus::address_t   address_;
    const VALUE                 value_;
};

}
}

#endif
