#include <mxmodbusgateway/worker/Command.hpp>

#include <mxutil/log.hpp>

namespace mxmodbusgateway
{
namespace worker
{

using mxmodbus::ModbusClient;

Command::Command()
{
}

Command::~Command()
{
}

void
    Command::execute(ModbusClient &mc)
{
    try
    {
        this->do_execute(mc);
    }
    catch(mxmodbus::Error &)
    {
        throw;
    }
    catch(boost::exception &e)
    {
        MXLOG_EROR(diagnostic_information(e));
        exit(1);
    }
    catch(std::exception &e)
    {
        MXLOG_EROR(e.what());
        exit(1);
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

}
}
