#ifndef _MXMODBUSIO_APP_HPP_
#define _MXMODBUSIO_APP_HPP_

#include <vector>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbus/ModbusClient.hpp>

#include <mxmodbusio/Command.hpp>
#include <mxmodbusio/CommandSource.hpp>
#include <mxmodbusio/error.hpp>

namespace mxmodbusio
{

class App
    : private boost::noncopyable
{
public:
    App(
        boost::shared_ptr<mxmodbus::ModbusClient>,
        mxmodbus::device_t,
        boost::shared_ptr<mxmodbusio::CommandSource>);
    ~App();

public:
    void
        run(); // throws mxmodbusio::SystemExit

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
