#ifndef _MXMODBUSIO_COMMAND_HPP_
#define _MXMODBUSIO_COMMAND_HPP_

#include <ostream>

#include <boost/noncopyable.hpp>

#include <mxmodbus/error.hpp>
#include <mxmodbus/ModbusClient.hpp>

namespace mxmodbusio
{

class Command // interface
    : private boost::noncopyable
{
protected:
    Command();

public:
    virtual ~Command();

    void
        execute(
            mxmodbus::ModbusClient &,
            mxmodbus::device_t,
            std::ostream &); // throws mxmodbus::ProtocolError, mxmodbus::Error

private:
    virtual void
        do_execute(
            mxmodbus::ModbusClient &,
            mxmodbus::device_t,
            std::ostream &) = 0;
};

}

#endif
