#ifndef _MXMODBUSIO_COMMAND_SOURCE_HPP_
#define _MXMODBUSIO_COMMAND_SOURCE_HPP_

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusio/Command.hpp>
#include <mxmodbusio/error.hpp>

namespace mxmodbusio
{

class CommandSource // interface
    : private boost::noncopyable
{
protected:
    CommandSource();

public:
    virtual ~CommandSource();

    boost::shared_ptr<mxmodbusio::Command>
        next();     // throws mxmodbusio::Error

private:
    virtual boost::shared_ptr<mxmodbusio::Command>
        do_next() = 0;
};

}

#endif
