#ifndef _MXMODBUSIO_OPTION_HPP_
#define _MXMODBUSIO_OPTION_HPP_

#include <string>
#include <vector>

#include <boost/cstdint.hpp>
#include <boost/logic/tribool.hpp>
#include <boost/shared_ptr.hpp>

namespace mxmodbusio
{

struct Option
{
    Option();

    std::string                 host;
    int                         port;
    int                         request_timeout_ms;
    uint8_t                     device_id;

    boost::shared_ptr<int>      read_address;
    int                         quantity;

    boost::shared_ptr<int>      write_address;
    std::vector<uint16_t>       data;
    bool                        single;

    boost::logic::tribool
        parse_args(
            int argc,
            const char *argv[]);
};

}

#endif
