#ifndef _MXMODBUSIO_IMPL_PARSE_COMMAND_HPP_
#define _MXMODBUSIO_IMPL_PARSE_COMMAND_HPP_

#include <string>
#include <vector>

#include <boost/cstdint.hpp>

#include <mxmodbus/types.hpp>

namespace mxmodbusio
{
namespace impl
{

bool
    parse_read_command(
        const std::string &line,
        int_least32_t &reference,
        std::size_t &quantity);

bool
    parse_write_command(
        const std::string &line,
        int_least32_t &reference,
        std::vector<uint16_t> &data);

bool
    parse_swrite_command(
        const std::string &line,
        int_least32_t &reference,
        uint16_t &data);

bool
    parse_data(
        const std::string &s,
        std::vector<uint16_t> &data);

}
}

#endif
