#include <mxmodbusio/Command.hpp>

#include <mxutil/log.hpp>

using mxmodbus::device_t;
using mxmodbus::ModbusClient;

using std::ostream;

namespace mxmodbusio
{

Command::Command()
{
}

Command::~Command()
{
}

void
    Command::execute(
        ModbusClient &mc,
        device_t device,
        ostream &os)
{
    try
    {
        this->do_execute(
            mc,
            device,
            os);
    }
    catch(mxmodbus::Error &)
    {
        throw;
    }
    catch(boost::exception &e)
    {
        MXLOG_EROR(diagnostic_information(e));
        exit(1);
    }
    catch(std::exception &e)
    {
        MXLOG_EROR(e.what());
        exit(1);
    }
    catch(...)
    {
        MXLOG_EROR("unexpected exception caught");
        exit(1);
    }
}

}
