#include <mxmodbusio/CommandList.hpp>

#include <boost/foreach.hpp>

using boost::shared_ptr;

using std::vector;

namespace mxmodbusio
{

struct CommandList::Impl
{
    Impl(
        const vector<shared_ptr<Command> > cmd_list_)
        : cmd_list(cmd_list_)
    {
    }

    vector<shared_ptr<Command> > cmd_list;
};

CommandList::CommandList(
    const vector<shared_ptr<Command> > &cmd_list)
    : pimpl(new Impl(cmd_list))
{
    BOOST_FOREACH(shared_ptr<Command> cmd, pimpl->cmd_list)
    {
        BOOST_VERIFY(cmd);
    }
}

CommandList::~CommandList()
{
}

shared_ptr<Command>
    CommandList::do_next()
{
    if (pimpl->cmd_list.empty())
        return shared_ptr<Command>();

    shared_ptr<Command> cmd = pimpl->cmd_list.front();
    pimpl->cmd_list.erase(pimpl->cmd_list.begin());

    return cmd;
}

}
