#include <mxmodbusio/impl/utility.hpp>

#include <iomanip>
#include <ios>
#include <iostream>

#include <boost/foreach.hpp>

using std::endl;
using std::hex;
using std::ostream;
using std::setfill;
using std::setw;
using std::vector;

namespace mxmodbusio
{
namespace impl
{

void
    print_data(
        ostream &os,
        const vector<bool> &data)
{
    bool is_first_data = true;
    BOOST_FOREACH(bool d, data)
    {
        if (!is_first_data)
            os << ':';

        os << (d ? 1 : 0);
        is_first_data = false;
    }

    os << endl;
}

void
    print_data(
        ostream &os,
        const vector<uint16_t> &data)
{
    bool is_first_data = true;
    BOOST_FOREACH(uint16_t d, data)
    {
        if (!is_first_data)
            os << ':';

        os << setw(4) << setfill('0') << hex << d;
        is_first_data = false;
    }

    os << endl;
}

}
}
