#ifndef _MXMODBUSCLIENT_APP_HPP_
#define _MXMODBUSCLIENT_APP_HPP_

#include <vector>

#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusclient/ReadingCollector.hpp>

#include <mxmodbusmaster/modbus/Master.hpp>

namespace mxmodbusclient
{

class App
    : private boost::noncopyable
{
public:
    App(
        boost::shared_ptr<mxmodbusmaster::modbus::Master>,
        boost::shared_ptr<mxmodbusclient::ReadingCollector>);
    ~App();

    void
        run();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
