#ifndef _MXMODBUSCLIENT_OPTION_HPP_
#define _MXMODBUSCLIENT_OPTION_HPP_

#include <string>

#include <boost/filesystem.hpp>
#include <boost/logic/tribool.hpp>

namespace mxmodbusclient
{

struct Option
{
    boost::filesystem::path     equipment_template_path;
    std::string                 modbus_host;
    int                         modbus_port;
    int                         modbus_request_timeout_ms;
    uint8_t                     device_id;
    bool                        dry_run;

    Option();

    boost::logic::tribool
        parse_args(
            int argc,
            const char *argv[]);
};

};

#endif
