#ifndef _MXMODBUSCLIENT_READING_COLLECTOR_HPP_
#define _MXMODBUSCLIENT_READING_COLLECTOR_HPP_

#include <ostream>
#include <string>
#include <vector>

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxmodbusclient/error.hpp>

#include <mxmodbusmaster/EquipmentTemplate.hpp>
#include <mxmodbusmaster/modbus/Equipment.hpp>
#include <mxmodbusmaster/reading/Reading.hpp>

namespace mxmodbusclient
{

class ReadingCollector
    : private boost::noncopyable
{
public:
    ReadingCollector(
        const std::string &equipment_id,
        const std::vector<mxmodbusmaster::EquipmentTemplate::Tag> &);
    ~ReadingCollector();

public:
    void
        collect_reading(
            const std::string &equipment_id,
            const mxmodbusmaster::reading::Reading &reading);

    void
        collect_status(
            const mxmodbusmaster::modbus::EquipmentStatus &status);

    void
        print_reading(std::ostream &os); // throws mxmodbusclient::SystemExit

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
