#ifndef _MXMODBUSMASTER_APP_HPP_
#define _MXMODBUSMASTER_APP_HPP_

#include <vector>

#include <boost/filesystem.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxutil/sched/Scheduler.hpp>

#include <mxmodbusmaster/modbus/Equipment.hpp>
#include <mxmodbusmaster/modbus/Worker.hpp>

namespace mxmodbusmaster
{

class App
    : private boost::noncopyable
{
public:
    App(
        const std::vector<boost::shared_ptr<mxmodbusmaster::modbus::Equipment> > &,
        const boost::filesystem::path &status_file,
        const std::vector<boost::shared_ptr<mxutil::sched::Scheduler> > &);
    ~App();

    void
        loop();

    void
        export_equipment_status();

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
