#ifndef _MXMODBUSMASTER_BUILDER_HPP_
#define _MXMODBUSMASTER_BUILDER_HPP_

#include <string>

#include <boost/filesystem.hpp>
#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/App.hpp>
#include <mxmodbusmaster/error.hpp>

namespace mxmodbusmaster
{

class Builder
    : private boost::noncopyable
{
public:
    Builder();
    ~Builder();

    void
        set_configuration(
            const boost::filesystem::path &);   // throws mxmodbusmaster::ArgumentError
    void
        add_equipment_template_directory(
            const boost::filesystem::path &);   // throws mxmodbusmaster::ArgumentError
    void
        set_mqtt_broker(
            const std::string &host,
            int service);   // throws mxmodbusmaster::ArgumentError

    boost::shared_ptr<mxmodbusmaster::App>
        build() const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}

#endif
