#ifndef _MXMODBUSMASTER_ERROR_HPP_
#define _MXMODBUSMASTER_ERROR_HPP_

#include <exception>

#include <boost/exception/all.hpp>

namespace mxmodbusmaster
{

struct ParseError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbusmaster::ParseError";
        return WHAT;
    }
};

struct NotFoundError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbusmaster::NotFoundError";
        return WHAT;
    }
};

struct ArgumentError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbusmaster::ArgumentError";
        return WHAT;
    }
};

struct LockError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbusmaster::LockError";
        return WHAT;
    }
};

struct RequestError
    : virtual boost::exception
    , virtual std::exception
{
    virtual const char *
        what() const throw()
    {
        static const char WHAT[] = "mxmodbusmaster::RequestError";
        return WHAT;
    }
};

typedef
    boost::error_info<struct tag_err_msg, std::string>
    EInfoMsg;

}

#endif
