#ifndef _MXMODBUSMASTER_MODBUS_COMMAND_HPP_
#define _MXMODBUSMASTER_MODBUS_COMMAND_HPP_

#include <boost/cstdint.hpp>
#include <boost/noncopyable.hpp>

#include <mxmodbus/ModbusClient.hpp>
#include <mxmodbusmaster/modbus/Reference.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

class Command // interface
    : private boost::noncopyable
{
public:
    typedef
        uint8_t
        device_t;

    typedef
        uint16_t
        address_t;

public:
    Command();
    virtual ~Command();

    virtual void
        run(device_t,
            mxmodbus::ModbusClient &,
            mxmodbusmaster::modbus::Reference &) const = 0;     // throws mxmodbusmaster::ModbusError
};

}
}

#endif
