#ifndef _MXMODBUSMASTER_MODBUS_COMPOSITE_READER_FACTORY_HPP_
#define _MXMODBUSMASTER_MODBUS_COMPOSITE_READER_FACTORY_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxmodbusmaster/modbus/ReaderFactory.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

// Utilize Composite pattern

class CompositeReaderFactory
    : public mxmodbusmaster::modbus::ReaderFactory
{
public:
    CompositeReaderFactory();
    virtual ~CompositeReaderFactory();

    virtual boost::shared_ptr<mxmodbusmaster::modbus::Reader>
        get(const std::string &name) const;

    void
        add_reader_factory(boost::shared_ptr<mxmodbusmaster::modbus::ReaderFactory>);

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
