#ifndef _MXMODBUSMASTER_MODBUS_READ_HOLDING_REGISTERS_COMMAND_HPP_
#define _MXMODBUSMASTER_MODBUS_READ_HODLING_REGISTERS_COMMAND_HPP_

#include <boost/scoped_ptr.hpp>

#include <mxmodbusmaster/modbus/Command.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

class ReadHoldingRegistersCommand
    : public mxmodbusmaster::modbus::Command
{
public:
    using mxmodbusmaster::modbus::Command::address_t;
    using mxmodbusmaster::modbus::Command::device_t;

public:
    ReadHoldingRegistersCommand(
        address_t,
        std::size_t quantity);
    virtual ~ReadHoldingRegistersCommand();

    virtual void
        run(device_t,
            mxmodbus::ModbusClient &,
            mxmodbusmaster::modbus::Reference &) const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
