#ifndef _MXMODBUSMASTER_MODBUS_READER_HPP_
#define _MXMODBUSMASTER_MODBUS_READER_HPP_

#include <vector>

#include <boost/noncopyable.hpp>

#include <mxmodbus/ModbusClient.hpp>

#include <mxmodbusmaster/reading/Reading.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

struct ReadStatus
{
    ReadStatus()
        : request_count()
        , request_success()
        , time_elapsed()
    {
    }

    unsigned int                        request_count;
    unsigned int                        request_success;
    boost::posix_time::time_duration    time_elapsed;
    std::vector<std::string>            error_tag_list;
};

class Reader // interface
    : private boost::noncopyable
{
public:
    typedef
        uint8_t
        device_t;

public:
    Reader();
    virtual ~Reader();

    virtual const std::vector<mxmodbusmaster::reading::Reading>
        read(
            device_t,
            mxmodbus::ModbusClient &,
            mxmodbusmaster::modbus::ReadStatus * = NULL) const = 0;
};

}
}

#endif
