#ifndef _MXMODBUSMASTER_MODBUS_READER_FACTORY_HPP_
#define _MXMODBUSMASTER_MODBUS_READER_FACTORY_HPP_

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/modbus/Reader.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

class ReaderFactory // interface
    : private boost::noncopyable
{
public:
    ReaderFactory();
    virtual ~ReaderFactory();

    virtual boost::shared_ptr<mxmodbusmaster::modbus::Reader>
        get(const std::string &name) const = 0;
};

}
}

#endif
