#ifndef _MXMODBUSMASTER_MODBUS_WORKER_HPP_
#define _MXMODBUSMASTER_MODBUS_WORKER_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/modbus/Master.hpp>
#include <mxmodbusmaster/reading/Reading.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

class Worker
    : private boost::noncopyable
{
public:
    typedef
        boost::function<
            void
                (
                    const std::string &equipment_id,
                    const mxmodbusmaster::reading::Reading &
                )
        >
        PublishReadingFunction;

    typedef
        boost::function<
            void
                (
                    const mxmodbusmaster::modbus::EquipmentStatus &
                )
        >
        PublishStatusFunction;

public:
    Worker(
        boost::shared_ptr<mxmodbusmaster::modbus::Master>,
        const PublishReadingFunction &,
        const PublishStatusFunction &);
    ~Worker();

    void
        whip();

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}
}

#endif
