#ifndef _MXMODBUSMASTER_MODBUS_TRIVIAL_DUMMY_MODBUS_CLIENT_HPP_
#define _MXMODBUSMASTER_MODBUS_TRIVIAL_DUMMY_MODBUS_CLIENT_HPP_

#include <mxmodbus/ModbusClient.hpp>

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

class DummyModbusClient
    : public mxmodbus::ModbusClient
{
public:
    DummyModbusClient();
    virtual ~DummyModbusClient();

private:
    virtual const std::vector<bool>
        do_read_coils(
            mxmodbus::device_t,
            mxmodbus::address_t,
            std::size_t quantity);

    virtual const std::vector<bool>
        do_read_discrete_inputs(
            mxmodbus::device_t,
            mxmodbus::address_t,
            std::size_t quantity);

    virtual const std::vector<uint16_t>
        do_read_holding_registers(
            mxmodbus::device_t,
            mxmodbus::address_t,
            std::size_t quantity);

    virtual const std::vector<uint16_t>
        do_read_input_registers(
            mxmodbus::device_t,
            mxmodbus::address_t,
            std::size_t quantity);

    virtual void
        do_write_single_coil(
            mxmodbus::device_t,
            mxmodbus::address_t,
            bool value);

    virtual void
        do_write_single_register(
            mxmodbus::device_t,
            mxmodbus::address_t,
            uint16_t value);

    virtual void
        do_write_multiple_coils(
            mxmodbus::device_t,
            mxmodbus::address_t,
            const std::vector<bool> &value);

    virtual void
        do_write_multiple_registers(
            mxmodbus::device_t,
            mxmodbus::address_t,
            const std::vector<uint16_t> &value);
};

}
}
}

#endif
