#ifndef _MXMODBUSMASTER_MODBUS_TRIVIAL_READER_HPP_
#define _MXMODBUSMASTER_MODBUS_TRIVIAL_READER_HPP_

#include <vector>

#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/modbus/Command.hpp>
#include <mxmodbusmaster/modbus/Reader.hpp>
#include <mxmodbusmaster/modbus/trivial/Tag.hpp>

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

class TrivialReader
    : public ::mxmodbusmaster::modbus::Reader
{
public:
    TrivialReader(
        const std::vector<boost::shared_ptr<mxmodbusmaster::modbus::Command> > &command_list,
        const std::vector<boost::shared_ptr<mxmodbusmaster::modbus::trivial::Tag> > &tag_list);
    virtual ~TrivialReader();

    virtual const std::vector<mxmodbusmaster::reading::Reading>
        read(
            device_t,
            mxmodbus::ModbusClient &,
            mxmodbusmaster::modbus::ReadStatus * = NULL) const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}
}

#endif
