#ifndef _MXMODBUSMASTER_MODBUS_TRIVIAL_TRIVIAL_READER_BUILDER_HPP_
#define _MXMODBUSMASTER_MODBUS_TRIVIAL_TRIVIAL_READER_BUILDER_HPP_

#include <boost/noncopyable.hpp>
#include <boost/scoped_ptr.hpp>

#include <mxmodbusmaster/EquipmentTemplate.hpp>
#include <mxmodbusmaster/error.hpp>
#include <mxmodbusmaster/modbus/trivial/TrivialReader.hpp>

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

class TrivialReaderBuilder
    : private boost::noncopyable
{
public:
    TrivialReaderBuilder();
    ~TrivialReaderBuilder();

    void
        set_equipment_template(const mxmodbusmaster::EquipmentTemplate &);

    boost::shared_ptr<mxmodbusmaster::modbus::trivial::TrivialReader>
        build() const;  // throws mxmodbusmaster::ArgumentError

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}
}

#endif
