#ifndef _MXMODBUSMASTER_MODBUS_TRIVIAL_TRIVIAL_READER_FACTORY_HPP_
#define _MXMODBUSMASTER_MODBUS_TRIVIAL_TRIVIAL_READER_FACTORY_HPP_

#include <string>

#include <boost/scoped_ptr.hpp>
#include <boost/filesystem.hpp>

#include <mxmodbusmaster/error.hpp>
#include <mxmodbusmaster/modbus/ReaderFactory.hpp>

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

class TrivialReaderFactory
    : public mxmodbusmaster::modbus::ReaderFactory
{
public:
    explicit TrivialReaderFactory(
        const boost::filesystem::path &config_dir); // throws mxmodbusmaster::ArgumentError
    virtual ~TrivialReaderFactory();

    virtual boost::shared_ptr<mxmodbusmaster::modbus::Reader>
        get(const std::string &name) const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}
}

#endif
