#ifndef _MXMODBUSMASTER_MODBUS_TRIVIAL_BYTE_ORDER_HPP_
#define _MXMODBUSMASTER_MODBUS_TRIVIAL_BYTE_ORDER_HPP_

#include <vector>

#include <boost/cstdint.hpp>

#include <mxmodbusmaster/error.hpp>

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

typedef enum
{
    BO_NC,      // no change
    BO_BA,
    BO_CDAB,
    BO_DCBA
} byte_order_t;

const std::vector<uint8_t>
    reorder(
        byte_order_t,
        const std::vector<uint8_t> &);  // throws mxmodbusmaster::ArgumentError

}
}
}

#endif
