#ifndef _MXMODBUSMASTER_READING_HPP_
#define _MXMODBUSMASTER_READING_HPP_

#include <string>

#include <boost/date_time/posix_time/posix_time_types.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/reading/Value.hpp>

namespace mxmodbusmaster
{
namespace reading
{

class Reading // value, no-cmp
{
public:
    Reading(
        const std::string &tag_id,
        const boost::posix_time::ptime &,
        const mxmodbusmaster::reading::Value &);
    Reading(
        const std::string &tag_id,
        const boost::posix_time::ptime &,
        const mxmodbusmaster::reading::Value &,
        const std::string &unit);
    //Reading(const Reading &);
    ~Reading();

    const std::string &
        tag_id() const;
    const boost::posix_time::ptime &
        timestamp() const;
    const mxmodbusmaster::reading::Value &
        value() const;
    const std::string *
        unit() const;

    //Reading &
    //    operator = (const Reading &);

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}
}

#endif
