#ifndef _MXMODBUSMASTER_READING_UINT_VALUE_HPP_
#define _MXMODBUSMASTER_READING_UINT_VALUE_HPP_

#include <boost/cstdint.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>

#include <mxmodbusmaster/reading/ValueBase.hpp>

namespace mxmodbusmaster
{
namespace reading
{

class UIntValue
    : public mxmodbusmaster::reading::ValueBase
{
public:
    explicit UIntValue(uint64_t);
    virtual ~UIntValue();

    virtual boost::shared_ptr<ValueBase>
        multiply(double) const;
    virtual boost::shared_ptr<ValueBase>
        add(double) const;
    virtual const std::string
        to_json_value() const;
    virtual const mxtag::Value
        to_mxtag_value() const;

private:
    struct Impl;
    boost::scoped_ptr<Impl> pimpl;
};

}
}

#endif
