#ifndef _MXMODBUSMASTER_READING_VALUE_HPP_
#define _MXMODBUSMASTER_READING_VALUE_HPP_

#include <string>

#include <boost/cstdint.hpp>
#include <boost/shared_ptr.hpp>

#include <mxtag/Value.hpp>

#include <mxmodbusmaster/modbus/trivial/tag_type.hpp>
#include <mxmodbusmaster/reading/ValueBase.hpp>

namespace mxmodbusmaster
{
namespace reading
{

class Value // value, no-cmp
{
public:
    static const Value
        get(uint64_t);
    static const Value
        get(int64_t);
    static const Value
        get(double);
    static const Value
        get(const std::string &);

private:
    explicit Value(boost::shared_ptr<mxmodbusmaster::reading::ValueBase>);

public:
    ~Value();

    const Value
        multiply(double) const;
    const Value
        add(double) const;

    const std::string
        to_json_value() const;

    const mxtag::Value
        to_mxtag_value() const;

private:
    boost::shared_ptr<mxmodbusmaster::reading::ValueBase>   internal_;
};

}
}

#endif
