#ifndef _MXMODBUSMASTER_READING_VALUE_BASE_HPP_
#define _MXMODBUSMASTER_READING_VALUE_BASE_HPP_

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <mxtag/Value.hpp>

namespace mxmodbusmaster
{
namespace reading
{

class ValueBase
    : private boost::noncopyable
{
public:
    ValueBase();
    virtual ~ValueBase();

    virtual boost::shared_ptr<ValueBase>
        multiply(double) const = 0;
    virtual boost::shared_ptr<ValueBase>
        add(double) const = 0;
    virtual const std::string
        to_json_value() const = 0;
    virtual const mxtag::Value
        to_mxtag_value() const = 0;
};

}
}

#endif
