#include <mxmodbusmaster/modbus/CompositeReaderFactory.hpp>

#include <boost/foreach.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

using boost::shared_ptr;

using std::string;
using std::vector;

struct CompositeReaderFactory::Impl
{
    Impl()
    {
    }

    vector<shared_ptr<ReaderFactory> > factory_list;
};

CompositeReaderFactory::CompositeReaderFactory()
    : pimpl(new Impl())
{
}

CompositeReaderFactory::~CompositeReaderFactory()
{
}

shared_ptr<Reader>
    CompositeReaderFactory::get(const string &name) const
{
    BOOST_FOREACH(shared_ptr<ReaderFactory> factory, pimpl->factory_list)
    {
        const shared_ptr<Reader> r = factory->get(name);
        if (r)
            return r;
    }

    return shared_ptr<Reader>();
}

void
    CompositeReaderFactory::add_reader_factory(shared_ptr<ReaderFactory> factory)
{
    BOOST_ASSERT(factory);

    pimpl->factory_list.push_back(factory);
}

}
}
