#include <mxmodbusmaster/modbus/ReadHoldingRegistersCommand.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

using mxmodbus::ModbusClient;

using std::vector;

struct ReadHoldingRegistersCommand::Impl
{
    Impl(
        address_t addr_,
        size_t quantity_)
        : addr(addr_)
        , quantity(quantity_)
    {
    }

    const address_t addr;
    const size_t    quantity;
};

ReadHoldingRegistersCommand::ReadHoldingRegistersCommand(
    address_t addr,
    size_t quantity)
    : pimpl(new Impl(addr, quantity))
{
}

ReadHoldingRegistersCommand::~ReadHoldingRegistersCommand()
{
}

void
    ReadHoldingRegistersCommand::run(
        device_t device,
        ModbusClient &modbus,
        Reference &ref) const
{
    const vector<uint16_t> buf = modbus.read_holding_registers(device, pimpl->addr, pimpl->quantity);
    ref.set(Reference::HOLDING_REGISTER_BASE + pimpl->addr, buf);
}

}
}
