#include <mxmodbusmaster/modbus/ReadInputRegistersCommand.hpp>

namespace mxmodbusmaster
{
namespace modbus
{

using mxmodbus::ModbusClient;

using std::vector;

struct ReadInputRegistersCommand::Impl
{
    Impl(
        address_t addr_,
        size_t quantity_)
        : addr(addr_)
        , quantity(quantity_)
    {
    }

    const address_t addr;
    const size_t    quantity;
};

ReadInputRegistersCommand::ReadInputRegistersCommand(
    address_t addr,
    size_t quantity)
    : pimpl(new Impl(addr, quantity))
{
}

ReadInputRegistersCommand::~ReadInputRegistersCommand()
{
}

void
    ReadInputRegistersCommand::run(
        device_t device,
        ModbusClient &modbus,
        Reference &ref) const
{
    const vector<uint16_t> buf = modbus.read_input_registers(device, pimpl->addr, pimpl->quantity);

    ref.set(Reference::INPUT_REGISTER_BASE + pimpl->addr, buf);
}

}
}
