#include <mxmodbusmaster/modbus/trivial/DummyModbusClient.hpp>

using mxmodbus::device_t;
using mxmodbus::address_t;

using std::vector;

namespace mxmodbusmaster
{
namespace modbus
{
namespace trivial
{

DummyModbusClient::DummyModbusClient()
    : ModbusClient()
{
}

DummyModbusClient::~DummyModbusClient()
{
}

const vector<bool>
    DummyModbusClient::do_read_coils(
        device_t,
        address_t,
        size_t quantity)
{
    return vector<bool>(quantity, false);
}

const vector<bool>
    DummyModbusClient::do_read_discrete_inputs(
        device_t,
        address_t,
        size_t quantity)
{
    return vector<bool>(quantity, false);
}

const vector<uint16_t>
    DummyModbusClient::do_read_holding_registers(
        device_t,
        address_t,
        size_t quantity)
{
    return vector<uint16_t>(quantity, 0);
}

const vector<uint16_t>
    DummyModbusClient::do_read_input_registers(
        device_t,
        address_t,
        size_t quantity)
{
    return vector<uint16_t>(quantity, 0);
}

void
    DummyModbusClient::do_write_single_coil(
        device_t,
        address_t,
        bool)
{
}

void
    DummyModbusClient::do_write_single_register(
        device_t,
        address_t,
        uint16_t)
{
}

void
    DummyModbusClient::do_write_multiple_coils(
        device_t,
        address_t,
        const vector<bool> &)
{
}

void
    DummyModbusClient::do_write_multiple_registers(
        device_t,
        address_t,
        const vector<uint16_t> &)
{
}

}
}
}
