#include <mxmodbusmaster/reading/FloatValue.hpp>

#include <boost/foreach.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/make_shared.hpp>

namespace mxmodbusmaster
{
namespace reading
{

using boost::lexical_cast;
using boost::make_shared;
using boost::shared_ptr;

using std::string;

struct FloatValue::Impl
{
    Impl(double v_)
        : v(v_)
    {
    }

    const double    v;
};

FloatValue::FloatValue(double v)
    : pimpl(new Impl(v))
{
}

FloatValue::~FloatValue()
{
}

shared_ptr<ValueBase>
    FloatValue::multiply(double m) const
{
    return make_shared<FloatValue>(pimpl->v * m);
}

shared_ptr<ValueBase>
    FloatValue::add(double a) const
{
    return make_shared<FloatValue>(pimpl->v + a);
}

const string
    FloatValue::to_json_value() const
{
    return lexical_cast<string>(pimpl->v);
}

const mxtag::Value
    FloatValue::to_mxtag_value() const
{
    return pimpl->v;
}

}
}
