#include <mxmodbusmaster/reading/StringValue.hpp>

#include <boost/foreach.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/make_shared.hpp>

#include <mxutil/log.hpp>

namespace mxmodbusmaster
{
namespace reading
{

using boost::make_shared;
using boost::shared_ptr;

using std::string;

struct StringValue::Impl
{
    Impl(const string &str_)
        : str(str_)
    {
    }

    const string    str;
};

StringValue::StringValue(const string &str)
    : pimpl(new Impl(str))
{
}

StringValue::~StringValue()
{
}

shared_ptr<ValueBase>
    StringValue::multiply(double) const
{
    MXLOG_WARN("useless operation");

    return shared_ptr<ValueBase>(new StringValue(pimpl->str));
}

shared_ptr<ValueBase>
    StringValue::add(double) const
{
    MXLOG_WARN("useless operation");

    return shared_ptr<ValueBase>(new StringValue(pimpl->str));
}

const string
    StringValue::to_json_value() const
{
    return '\"' + pimpl->str + '\"';
}

const mxtag::Value
    StringValue::to_mxtag_value() const
{
    return pimpl->str;
}

}
}
