#include <boost/test/unit_test.hpp>

#include <mxmodbusmaster/reading/FloatValue.hpp>

#include <boost/lexical_cast.hpp>

namespace mxmodbusmaster
{
namespace reading
{

using boost::lexical_cast;
using boost::shared_ptr;

using std::string;

namespace
{

class TestFixture
{
};

}

BOOST_FIXTURE_TEST_CASE(test_FloatValue_multiply_ShouldPass, TestFixture)
{
    // arrange
    const FloatValue fv(1.5);

    // act
    const shared_ptr<ValueBase> result = fv.multiply(3.0);

    // assert
    BOOST_CHECK_CLOSE(4.5, lexical_cast<double>(result->to_json_value()), 0.0001);
}

BOOST_FIXTURE_TEST_CASE(test_FloatValue_add_ShouldPass, TestFixture)
{
    // arrange
    const FloatValue fv(1.5);

    // act
    const shared_ptr<ValueBase> result = fv.add(3.0);

    // assert
    BOOST_CHECK_CLOSE(4.5, lexical_cast<double>(result->to_json_value()), 0.0001);
}

BOOST_FIXTURE_TEST_CASE(test_FloatValue_to_json_value_ShouldPass, TestFixture)
{
    // arrange
    const FloatValue fv(1.5);

    // act
    const string s = fv.to_json_value();

    // assert
    BOOST_CHECK_CLOSE(1.5, lexical_cast<double>(s), 0.0001);
}

}
}
