#include <boost/test/unit_test.hpp>

#include <mxmodbusmaster/reading/StringValue.hpp>

namespace mxmodbusmaster
{
namespace reading
{

using boost::shared_ptr;

namespace
{

class TestFixture
{
};

}

BOOST_FIXTURE_TEST_CASE(test_StringValue_multiply_ShouldPass, TestFixture)
{
    // arrange
    const StringValue sv("3.14159265");

    // act
    const shared_ptr<ValueBase> result = sv.multiply(1.5);

    // assert
    BOOST_CHECK_EQUAL("\"3.14159265\"", result->to_json_value());
}

BOOST_FIXTURE_TEST_CASE(test_StringValue_add_ShouldPass, TestFixture)
{
    // arrange
    const StringValue sv("3.14159265");

    // act
    const shared_ptr<ValueBase> result = sv.add(1.5);

    // assert
    BOOST_CHECK_EQUAL("\"3.14159265\"", result->to_json_value());
}

}
}
