#include <boost/test/unit_test.hpp>

#include <mxmodbusmaster/reading/UIntValue.hpp>

#include <boost/lexical_cast.hpp>

namespace mxmodbusmaster
{
namespace reading
{

using boost::lexical_cast;
using boost::shared_ptr;

using std::string;

namespace
{

class TestFixture
{
};

}

BOOST_FIXTURE_TEST_CASE(test_UIntValue_to_json_value_ShouldPass, TestFixture)
{
    // arrange
    const UIntValue uv(12345);

    // act
    const string s = uv.to_json_value();

    // assert
    BOOST_CHECK_EQUAL("12345", s);
}

BOOST_FIXTURE_TEST_CASE(test_UIntValue_multiply_ShouldPass, TestFixture)
{
    // arrange
    const UIntValue uv(3);

    // act
    const shared_ptr<ValueBase> result = uv.multiply(1.5);

    // assert
    BOOST_CHECK_CLOSE(4.5, lexical_cast<double>(result->to_json_value()), 0.0001);
}

BOOST_FIXTURE_TEST_CASE(test_UIntValue_add_ShouldPass, TestFixture)
{
    // arrange
    const UIntValue uv(3);

    // act
    const shared_ptr<ValueBase> result = uv.add(1.5);

    // assert
    BOOST_CHECK_CLOSE(4.5, lexical_cast<double>(result->to_json_value()), 0.0001);
}

}
}
