#ifndef _MXSERIALFRAMER_OPTION_HPP_
#define _MXSERIALFRAMER_OPTION_HPP_

#include <string>

#include <boost/asio.hpp>
#include <boost/logic/tribool.hpp>
#include <boost/shared_ptr.hpp>

namespace mxserialframer
{

struct Option
{
    std::string     device;

    struct Config
    {
        boost::asio::serial_port_base::baud_rate        baud;
        boost::asio::serial_port_base::character_size   char_size;
        boost::asio::serial_port_base::parity           parity;
        boost::asio::serial_port_base::stop_bits        stop_bits;
    };

    Config                  config;
    boost::shared_ptr<int>  noinput_timeout_ms;
    boost::shared_ptr<int>  overflow_size;
    bool                    verbose;

    Option();

    boost::logic::tribool
        parse_args(
            int argc,
            const char *argv[]);
};

}

#endif
