#ifndef _MXTAGCOLLECTOR_APP_HPP_
#define _MXTAGCOLLECTOR_APP_HPP_

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

namespace mxtagcollector
{

class App
    : private boost::noncopyable
{
public:
    App(
        const std::string &broker_host,
        int broker_port,
        const std::string &dbpath,
        int sqlite3_busy_retry_timeout_ms,
        int sqlite3_busy_wait_ms,
        int sqlite3_commit_period_ms);
    ~App();

    void
        start();
    void
        loop();

private:
    struct Impl;
    boost::shared_ptr<Impl> pimpl;
};

}

#endif
