#ifndef _MXTAGCOLLECTOR_CONFIGURATION_HPP_
#define _MXTAGCOLLECTOR_CONFIGURATION_HPP_

#include <string>

#include <mxutil/error.hpp>

namespace mxtagcollector
{

struct Configuration
{
    static const Configuration
        parse(const std::string &); // throws mxutil::ParseError

    unsigned int    sqlite3_busy_retry_timeout_ms;
    unsigned int    sqlite3_busy_wait_ms;
    unsigned int    sqlite3_commit_period_ms;

    Configuration(
        unsigned int sqlite3_busy_retry_timeout_ms_,
        unsigned int sqlite3_busy_wait_ms_,
        unsigned int sqlite3_commit_period_ms_)
        : sqlite3_busy_retry_timeout_ms(sqlite3_busy_retry_timeout_ms_)
        , sqlite3_busy_wait_ms(sqlite3_busy_wait_ms_)
        , sqlite3_commit_period_ms(sqlite3_commit_period_ms_)
    {
    }
};

}

#endif
