#include <mxtagcollector/ReadingInserter.hpp>

#include <mxhtag/Database.hpp>

using boost::shared_ptr;

using mxhtag::Database;
using mxhtag::DiskFullError;

using mxtag::Tag;

using std::vector;

namespace
{

const int DELETION_FACTOR = 3;

}

namespace mxtagcollector
{

struct ReadingInserter::Impl
{
    Impl()
    {
    }

    vector<Tag>         reading_list;
};

ReadingInserter::ReadingInserter()
    : pimpl(new Impl())
{
}

ReadingInserter::~ReadingInserter()
{
}

void
    ReadingInserter::insert(
        const Tag &reading)
{
    pimpl->reading_list.push_back(reading);
}

void
    ReadingInserter::commit(
        Database &db)
{
    const vector<Tag> reading_list(
        pimpl->reading_list);

    try
    {
        db.insert_reading_list(reading_list);

        pimpl->reading_list.clear();
    }
    catch(DiskFullError &e)
    {
        db.delete_oldest_readings(0.2);

        this->commit(db);
    }
}

}
