#include <boost/test/unit_test.hpp>

#include <mxtagcollector/Configuration.hpp>

namespace mxtagcollector
{

using std::string;

namespace
{

class TestFixture
{
};

}

BOOST_FIXTURE_TEST_CASE(test_Configuration_parse_ShouldPass, TestFixture)
{
    // arrange
    const string SUT =
        "sqlite3-busy-retry-timeout-ms = 10000\n"
        "sqlite3-busy-wait-ms = 10\n"
        "sqlite3-commit-period-ms = 1000\n";

    // act
    const Configuration config = Configuration::parse(SUT);

    // assert
    BOOST_CHECK_EQUAL(10000, config.sqlite3_busy_retry_timeout_ms);
    BOOST_CHECK_EQUAL(10, config.sqlite3_busy_wait_ms);
    BOOST_CHECK_EQUAL(1000, config.sqlite3_commit_period_ms);
}

}
