#ifndef _MXTAGIMPORT_OPTION_HPP_
#define _MXTAGIMPORT_OPTION_HPP_

#include <string>

#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/logic/tribool.hpp>
#include <boost/shared_ptr.hpp>

#include <mxidafpp/Value.hpp>

namespace mxtagimport
{

struct Option
{
    Option();

    std::string mqtt_broker_host;
    int         mqtt_broker_port;

    std::string                         equipment;
    std::string                         tag;
    boost::shared_ptr<mxidafpp::Value>  value;
    boost::posix_time::ptime            at;
    boost::shared_ptr<std::string>      unit;

    boost::logic::tribool
        parse_args(
            int argc,
            const char *argv[]);
};

}

#endif
