#include <ptag/publish_reading.hpp>

#include <sstream>
#include <vector>

#include <rapidjson/document.h>
#include <rapidjson/stringbuffer.h>
#include <rapidjson/writer.h>

#include <mxutil/log.hpp>

#include <mxtag/mqtt/ProtobufSerializer.hpp>

using boost::posix_time::ptime;

using mxmqtt::Message;
using mxmqtt::Worker;

using mxtag::mqtt::ProtobufSerializer;
using mxtag::Tag;
using mxtag::Value;

using std::pair;
using std::string;
using std::stringstream;
using std::vector;

namespace ptag
{

void
    publish_reading(
        Worker &publisher,
        const string &equipment_id,
        const string &tag_id,
        const ptime &now)
{
    const Tag t(
        equipment_id,
        tag_id,
        now,
        Value(3.14159265),
        "TEST");

    ProtobufSerializer serializer;
    const pair<string, vector<uint8_t> > topic_payload = serializer.from_tag(t);

    publisher.publish(Message(
        topic_payload.first,
        topic_payload.second,
        2,
        false));
}

}
