# Sanji OpenAPI Development Guide

## Conventions
- YAML (Extension .yaml)
- Use single quote only if necessary
- HTTP PUT method: **all** properties of object should be required
- `index.yaml` should be placed as below:

```
sanji-bundle-*
  schema/
    index.yaml     <--- bundle's OpenAPI document
  bundle.json
  index.py

```

## Development
### Writting
Go to [Swagger Editor](http://editor.swagger.io)

### Test / Mock
Go to [sanji-openapi-mockserver](https://github.com/Sanji-IO/sanji-openapi-mockserver)

## Export
- Go to [Swagger UI](http://petstore.swagger.io/)
> At first, you should use **Mock Server** to get a resolved version of OpenAPI document in JSON format. And upload to a static web hosting service (ex: https://gist.github.com).

## Examples
### Relay
index.yaml file could be found at `./examples/schema/index.yaml`

## References
- http://swagger.io/specification (API Specification)
- http://tools.ietf.org/html/draft-pbryan-zyp-json-ref-03 (JSON Reference)
- http://tools.ietf.org/html/rfc6901 (JSON Pointer)

