/*
 * Simple HTTPS POST
 *
 */ 
#include <stdio.h>
#include <curl/curl.h>
 
int main(void)
{
  CURL *curl;
  CURLcode res;
  struct curl_slist *headers = NULL;

  char *json_str = "{ \
      \"enable\": true, \
      \"service\": \"abc\", \
      \"portStart\": 4423, \
      \"portEnd\": 4423, \
      \"destIp\": \"192.168.5.123\", \
      \"protocol\": \"tcp\" \
    }";

 
  curl_global_init(CURL_GLOBAL_DEFAULT);
 
  curl = curl_easy_init();
  if(curl) {
    headers = curl_slist_append(headers, "Content-Type: application/json");
    curl_easy_setopt(curl, CURLOPT_URL, "https://localhost/api/v1/network/portmapping");
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers); 

    /* Specify the POST data */ 
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, json_str);
 
    /* Skip the verification of the server's certificate. */
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0L);
 
    /* Skip to verify the certificate's name against host. */
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L);
 
    /* Perform the request, res will get the return code */ 
    res = curl_easy_perform(curl);
    /* Check for errors */ 
    if(res != CURLE_OK)
      fprintf(stderr, "curl_easy_perform() failed: %s\n",
              curl_easy_strerror(res));
 
    /* always cleanup */ 
    curl_easy_cleanup(curl);
  }
 
  curl_global_cleanup();
 
  return 0;
}
