# RESTful API Tutorials

## Overview

Each ThingsPro Gateway, such as UC-8112-LX-CG, is provided with a *RESTful API* that gives you access to the *gateway*. This API is for developers who want to interact with and integrate their software with ThingsPro. Excluding web account operations, you can use this *RESTful API* for all other gateway operations such as bootstrap, ethernet and iptables.

This document gives you an overview of the ThingsPro *RESTful API*. For full details on using the API such as the resources available, the HTTPS methods supported, and the content of the requests and responses, refer to the ThingsPro RESTful API Reference.


### Constraints on ThingsPro v1.2

1. The ThingsPro *RESTful API* can only be accessed locally; remote access of the API is not allowed.
2. We do not recommend simultaneous use of the *RESTful API* and the ThingsPro web interface.


## Introduction

The ThingsPro API provides access to a number of resources that can be accessed via HTTPS requests. The response format is JSON. Because REST is based on web technologies, you do not need external libraries to use RESTful APIs. You can start interacting with the API using your web browser.

This document describes the usage of the ThingsPro *RESTful API*.

## URI Structure

The format of REST URI in ThingsPro is:

```
https://localhost/api/v1/<resource>
```

The final part of the URI is the name of the resource, which determines the response that you will receive from the API. Some resources may require additional path parameters to identify a specific resource. For example, the URI for the first Ethernet Interface would look like:

```
https://localhost/api/v1/network/ethernets/1
```
