import logging
import re
import socket

_logger = logging.getLogger("sanji.openvpn.managment")


class Management(object):

    def __init__(self, host, port):
        self.host = host
        self.port = port

    def command(self, command):
        data = ''
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            s.connect((self.host, self.port))
        except socket.error:
            return False

        s.send(command)
        _logger.debug('Sent command: {}'.format(command))

        while True:
            socket_data = s.recv(1024)
            _logger.debug('Receive data: {}'.format(repr(socket_data)))
            socket_data = re.sub('>INFO(.)*\r\n', '', socket_data)

            data += socket_data
            if command == 'load-stats\n' and data != '':
                break
            elif data.endswith('END\r\n'):
                break

        s.send('quit\n')
        s.close()

        return re.sub('END\r\n', '', data)
