import os
import sys
import unittest

from mock import patch

try:
    sys.path.append(os.path.dirname(os.path.realpath(__file__)) + "/../../")
    from openvpn.management import Management
except ImportError as e:
    print "Please check the python PATH for import test module. (%s)" \
        % __file__
    exit(1)


class TestManagementClass(unittest.TestCase):

    STATE_RESP = (
        ">INFO:OpenVPN Management Interface Version 1 -- "
        "type 'help' for more info\r\n"
        "1455518584,CONNECTED,SUCCESS,10.9.8.6,192.168.31.114\r\n"
        "END\r\n"
    )

    def setUp(self):
        self.management = Management('localhost', 7505)
        pass

    def tearDown(self):
        pass

    @patch("socket.socket")
    def test_command_with_state_ShouldReturnState(self, socket_mock):
        def this_send(command):
            print repr(command)
        # arrange
        socket = socket_mock.return_value
        socket.recv.return_value = self.STATE_RESP

        # act
        rtn = self.management.command('state\n')

        # assert
        self.assertEqual(
            '1455518584,CONNECTED,SUCCESS,10.9.8.6,192.168.31.114\r\n',
            rtn
        )


if __name__ == "__main__":
    unittest.main()
