#!/usr/bin/env python
# -*- coding: UTF-8 -*-
import os
import sys
import unittest
import simplejson as json
from mock import patch
from mock import mock_open


try:
    sys.path.append(os.path.dirname(os.path.realpath(__file__)) + "/../../")
    from modbus import fetch_status
except ImportError as e:
    print "Please check the python PATH for import test module. (%s)" \
        % __file__
    print (e)
    exit(1)


class TestIndexClass(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    @patch("modbus.json")
    @patch("modbus.sh")
    @patch("modbus.os.path.exists")
    def test_get_all_equipments(self, exists, sh, json):
        """Get all of templates"""
        exists.return_value = True
        sh.pidof.return_value = "1234"
        json.load.return_value = {}
        m = mock_open()
        with patch("__builtin__.open", m, create=True):
            result = fetch_status("/temp/test")
            self.assertEqual(result, {})

        sh.rm.assert_called_once_with("-rf", "/temp/test", _timeout=5)
        sh.pidof.assert_called_once_with("mxmodbusmaster")
        sh.kill.assert_called_once_with("-USR1", 1234)

if __name__ == "__main__":
    unittest.main()
