# Cloud Gateway

## System Overview

![CG Architecture Overview](images/cloud-gateway-overview.png "CG Architecture")

### Data Processing Framework
(not in current scope)

* Activated by:
    * Periodically
    * Tag updated
    * Equipment updated
* Customizable point for Programmability.

### HistoryTags
(not in current scope)

* Readings stored here can be accessed by *Data Processing Framework*.
    * Query history Readings.
* Update time and Reading time.
* Configurable log depth(number of Readings to Keep for each Tag).

### LogArchiver

* Store Tag Readings into *LogFiles*.
* *LogFiles* are in internal format.

### LogConverter

* Convert *LogFiles* to another file format, like *csv* or *json*.

### LogUploader

* Upload Logs to remote Server.
* Convert *LogFiles* with *LogConverter*.
* Files are **not** deleted after being uploaded.
* Activated by cron.

### ModbusClient

* Read Tags from Equipments through Modbus-TCP.
* Provide on-demand read.

### ModbusGateway

* Conversion between Modbus-RTU and Modbus-TCP.
* Allow multiple Modbus-TCP Master connections at the same time.
* Serve multiple serial-ports.

### ModbusMaster

* Read Tags from Equipments through Modbus-TCP.
* Publish Tag Readings to *MqttBroker*.
* Provide scheduled read.

### TagCollector
(not in current scope)

* Store Readings subscribed from *MqttBroker* to *HistoryTags*.
* Delete out-of-date Readings from *HistoryTags*.
