# Initial Sequence

## Factory Default

### Network Management
Static Ethernet address.

```json
[
    {
        "id": 1,
        "name": "eth0",
        "ip": "192.168.3.127",
        "netmask": "255.255.255.0",
        "subnet": "192.168.3.0",
        "gateway": "192.168.3.254",
        "enable": 1,
        "enableDhcp": 0
    },
    {
        "id": 2,
        "name": "eth1",
        "ip": "192.168.4.127",
        "netmask": "255.255.255.0",
        "subnet": "192.168.4.0",
        "gateway": "192.168.4.254",
        "enable": 1,
        "enableDhcp": 0
    }
]
```

### Modbus Gateway

```
# /etc/mxmodbusgateway/configuration
ports = (
  {
    tcp = {
      host = "127.0.0.1";
      service = "502";
    };
    rtu = {
      path = "/dev/ttyS0";
      serial-config = "9600-8-n-1";
      interframe-delay-ms = 100;
      interchar-timeout-ms = 100;
      request-timeout-ms = 500;
    };
  },
  {
    tcp = {
      host = "0.0.0.0";
      service = "1502";
    };
    rtu = {
      path = "/dev/ttyS1";
      serial-config = "9600-8-n-1";
      interframe-delay-ms = 100;
      interchar-timeout-ms = 100;
      request-timeout-ms = 500;
    };
  }
);
```

### Modbus Master

```
# /etc/mxmodbusmaster/configuration
ports = (
  {
    host               = "127.0.0.1";
    service            = "502";
    polling-period-sec = 60;

    device-list = ();
  },
  {
    host               = "127.0.0.1";
    service            = "1502";
    polling-period-sec = 60;

    device-list = ();
  }
);
```

Templates for `ioLogik E1000/R1000`.

## Runtime

As long as MqttBroker supports **Pre-configured Subscription List**,
there will be no initialization dependency between related software modules.

All **daemons** are started during system initialization.

*ModbusMaster* start to read tags from Devices after it is connected to *MqttBroker*.
