# Network Utility Wrapper

* Wraps related utilities to adapt to *NetworkManagement* interface.
* Support on-demand connection.
* Triggered by Schedule.

## MQTT Client

```
Client ID:
    nuw-<PID>
Clean Session:
    true

Will:
    Topic:
        /system/network/connection/ondemand/nuw-<PID>
    QoS:
        1
    Retain:
        true
    Payload:
        (null)
```

### Publish

```
Topic:
    /system/network/connection/ondemand/nuw-<PID>
QoS:
    1
Retain:
    true
```

### Subscribe

```
Topic:
    /system/network/connection/status
QoS:
    1
```

## Sequence Diagram

![Network Utility Wrapper Sequence Diagram](images/cloud-gateway-network-utility-wrapper-sequence.png)

## Command Line Interface
```
NAME
    mx-nuw - MoXa Network Utility Wrapper

SYNOPSIS
    mx-nuw [OPTIONS] -- [COMMAND]

    mx-nuw [-h|--help]

DESCRIPTION
    Run COMMAND when System is on-line.

    --on-demand
        If --on-demand is given, mx-nuw issues an On-demand Connect request to
        Network Manager on start-up and disables On-demand Connect on exit.

    --connect-timeout-sec CONNECT_TIMEOUT_SEC
        Time to wait before System is on-line.
        Default 60.

    --command-timeout-sec COMMAND_TIMEOUT_SEC
        Time to wait before force terminating COMMAND.
        Default 600.

    -h, --help
        Print help and exit.

EXIT STATUS
    0
        Success.
    1
        Unknown error.
    2
        Input error.
    3
        Connect timeout.
    4
        Command exit with error, including timeout.
```
