# Serial Framer

A relay interface to redirect data from stdin to serial-port and from
serial-port to stdout.
Buffers data read from serial port until some configured conditions are met.

## Man Page
```
NAME
    mxserialframer

SYNOPSIS
    mxserialframer --device=PATH --config=CONFIG [framing conditions]

DESCRIPTION
    Given no framing condition makes mxserialframer flush buffer content
    everytime some data is read.

    --device=PATH
        Serial port path.

    --config=CONFIG
        Serial port configuraiton.

        Example:
        $ mxserialframer --device=/dev/ttyS0 --config=9600-8-n-1

    --noinput-timeout-ms=TIMEOUT_MS
        Flush buffer to stdout when nothing has been read from serial port for
        TIMEOUT_MS.

    --overflow-size=SIZE
        Flush when buffer contains SIZE or more bytes of data.

    --verbose
        Print log messages to stderr.

TERMINATION
    Closing stdin causes mxserialframer to terminate gracefully.

    mxserialframer would try to flush its internal buffer before termination.

EXIT STATUS
    0
        Success
    1
        Unknown error
    2
        Illegal argument
    3
        IO error
```
