# Tag Forwarder

* Push *URGENT* tag values to Cloud Server.

## Configuration

Sample:

```
# /etc/mx-tag-forward/configuration
ondemand-connection-enabled = true

server = {
    host = "mxcloud.moxa.com"
    service = "1883"
    authentication = {
        tls-psk = "0123456789ABCDEF"
    }
}

equipment-list = (
    {
        name = "My ioLogik-E2242"
        tags = ["di0", "ai0"]
    },
    {
        name = "My ioLogik-E2242 Alarm"
        tags = ["overheat"]
    }
)
```

## MQTT Client

```
Client ID:
    tag-forwarder
Clean Session:
    false
```

### Subscribe

```
Topic:
    /equs/EQUIPMENT/tags/TAG
QoS:
    2
```

## Cloud Server MQTT Client

```
Client ID:
    tag-forwarder-XXXXXXXX
Clean Session:
    true
```

### Publish

```
Topic:
    /cgs/CG/equs/EQUIPMENT/tags/TAG
QoS:
    2
```

## Behavior

### Forward Tags Activity Diagram

![Forward Tags Activity Diagram](images/cloud-gateway-tag-forwarder-activity.png)
