# Use Cases

* All scenarios should start from *_Admin_ login to the web page*.

## System Management
Some basic settings such as *system update* or *reboot* are described.

### Scenarios

#### Reboot the CG
1. _Admin_ clicks `Settings` button and selects `System` item
2. _Admin_ clicks `Reboot` button and select `Yes` for the double confirm
   dialog
3. _Admin_ is logged out with message like *The system is rebooting ...*

#### Export Configuration
1. _Admin_ clicks `Settings` button and selects `System` item
2. _Admin_ clicks `Export Configuration` button and the file dialog pop-out
   for selecting target location for exported configuration file
3. _Admin_ clicks `OK` after choosing the target location

#### Import Configuration
1. _Admin_ clicks `Settings` button and selects `System` item
2. _Admin_ clicks `Import Configuration` button and select `Choose File` to
   find the configuration file from file dialog
3. After selecting the configuration file, _Admin_ click `Open` button
4. _Admin_ check the configuration file name from text box and click `Upload`
   to import the configuration
5. _Admin_ is logged out with message like *The system is applying the
   configurations ...*

#### Update the System via USB storage stick
1. _Admin_ plug a _USB storage stick_ with latest firmware into the device
2. _Admin_ clicks `Settings` button and selects `System` item
3. _Admin_ clicks `Reboot` button and select `Yes` for the double confirm
   dialog
4. _Admin_ is logged out with message like *The system is rebooting ...*
5. _Admin_ logins to the web to check version after 2 minutes when LED is not
   blinks

##### Updater Updates the System
1. _Updater_ checks if a firmware file exist in USB at booting
2. _Updater_ updates the system by firmware file

#### Update the System via SSH
1. _Admin_ uploads firmware file to device via `scp`
2. _Admin_ triggers _updater_ with firmware path to update the system


### Use Cases

#### Reboot

![Reboot](images/cloud-gateway-sysmgr-reboot-usecase.png)

#### Import/Export

![Import/Export](images/cloud-gateway-sysmgr-import-export-usecase.png)

#### Upgrade

![Upgrade](images/cloud-gateway-sysmgr-upgrade-usecase.png)


## Network Management
_Network Manager_ provides Ethernet and Cellular to connect to Internet. The
local web can only be accessed from LAN (`eth1`).

### Scenarios

#### Update Ethernet with Static IP
1. _Admin_ login to the web page of target device with default IP address
2. _Admin_ clicks `Settings` button and select `Ethernet` item
3. _Admin_ `Edit` the settings of `eth0` with *Static IP* (such as *mode*,
   *IP*, *netmask*, *gateway*, and *DNS servers*)
4. _Admin_ clicks `Save` to apply the settings and back to information page
   * *mode*, *IP*, or *netmask* was modified for `eth1`
     * web notice user to use new IP address to login after _Admin_ was loged out
     * web show failed message
   * `eth0` was updated; or *gateway* or *DNS* was modified for `eth1`
     * web shows successful message
     * web show failed message

_Admin_ expects default route and DNS servers was modified when `eth0` was
updated.

#### Update Ethernet with DHCP
Wireframe: [https://marvelapp.com/73a8fi](https://marvelapp.com/73a8fi)

1. _Admin_ login to the web page of target device with default IP address
2. _Admin_ clicks `Settings` button and select `Ethernet` item
3. _Admin_ `Edit` the settings of `eth0` with *DHCP*
4. _Admin_ clicks `Save` to apply the settings and back to information page
   * modified for `eth0`
     * web shows successful message
     * web show failed message
   * modified for `eth1`
     * web notice user to use new IP address to login after _Admin_ was loged out
     * web show failed message

#### Enable Cellular
1. _Admin_ login to the web page of target device with default IP address, IP
   address edit in previous time or retrieved by DHCP server
2. _Admin_ clicks `Settings` button and select `Cellular` item
3. _Admin_ check `Enable` box and input some required information for dialing
4. _Admin_ clicks `Save` to apply the settings and back to information page
   * web shows successful message
   * web show failed message

_Admin_ expects the device could connect to Internet by cellular and IP
address will show on the `Cellular` page after a successful setting; also the
default route and DNS servers should be modified.

#### Disable Cellular
1. _Admin_ login to the web page of target device with default IP address, IP
   address edit in previous time or retrieved by DHCP server
2. _Admin_ clicks `Settings` button and select `Cellular` item
3. _Admin_ uncheck `Enable` box
4. _Admin_ clicks `Save` to apply the settings and back to information page
   * web shows successful message
   * web show failed message

### Use Cases

#### Update Ethernet

![Update Ethernet](images/cloud-gateway-netmgr-ethernet-usecase.png)

#### Update Cellular

![Update Cellular](images/cloud-gateway-netmgr-cellular-usecase.png)

## Modbus Framework
### Use Cases

![Modbus Framework Usecase](images/cloud-gateway-modbus-framework-usecase.png)

## Data Logging Framework
### Use Cases

![Data Logging Framework Usecase](images/cloud-gateway-data-logging-framework-usecase.png)

## Port Forward
Wireframe: [https://marvelapp.com/954i8g](https://marvelapp.com/954i8g)

## Relay
Wireframe: [https://marvelapp.com/af8d9d](https://marvelapp.com/af8d9d)

## Switch Application Mode
Wireframe: [https://marvelapp.com/739244](https://marvelapp.com/739244)

