# Use Cases

## SYS Topics for Client(s)
The broker provide detail information for connected client(s).

* http://dev.eclipse.org/mhonarc/lists/mosquitto-dev/msg00751.html

### Scenario
1. _User_ would like to know detail information for connected client(s)
2. _User_ start a MQTT _client_ and subscribes to system topic for client(s) information


### Use Case
(fixme)


## Pre-defined Topic
The broker provide the option for pre-defined client ID and topic to keep data before client connected.


* maybe create a fake client with pre-defined client ID and topic and disconnect immediately

### Scenario

1. _User_ defines a client id with `test` and topic `test` in a _broker_ config file
2. _User_ start, restart the _broker_ or just trigger the _broker_ to reload the config
3. A _DA client_ (data acquisition) connected to _broker_ and publishes data to `test` topic
4. _DB client_ (database) with id `test` connected to _broker_ and subscribes to `test` topic
5. _DB client_ receive the data sent by _DA client_ from _Broker_

### Use Case
(fixme)


## Drop Client(s)
The broker should be able to drop illegal client(s) (manually drop may be provided).

### Scenario: Drop Illegal Client
1. _cg-123_ connected to _broker_ with pre-defined identity and psk
2. _User_ remove the identity and psk for _cg-123_
3. _User_ trigger _broker_ to reload the config
4. _broker_ drop _cg-123_ from the client list

### Scenario: Drop Client(s) Manually
Should provide different permission or any client could drop other client(s).

1. _User_ start a _client_ with operator permission to connect to _broker_
2. The _client_ publishes the drop client request with _[client-id]_
3. _Broker_ drop _[client-id]_ from the client list

### Use Case
(fixme)


## Message Processing Plugin (Future)
The broker may provide the message plugin that pre-processes the published message and may publish with another topic (default to same topic).

The idea is from sanji-controller, which maintains a list of registered bundles and the session control. Basically, the message flow looks like following.
```
1. bundle a => broker
2. broker => controller
3. controller => broker
4. broker => bundle b
```

With _message processing plugin_, the message traffic will be decreased.
```
1. bundle a => broker
2. broker (processing with controller plugin) => bundle b
```

Note:
* the entry point of message processing plugin is the topic
* the topic for message processing plugin should be unique


### Scenario: Configure a Message Processing Plugin

1. _User_ define the topic `/controller` for the _controller_ plugin into _broker_'s `config` file
   * take `/controller` for example
   * maybe this step is not required, the topic should be able to configured in the plugin
2. _User_ places the _Controller_ plugin into `plugin` directory for _broker_
3. _User_ start, restart, or reload the _broker_ to load the _controller_ plugin

### Scenario: Message Process

1. _Broker_ receives a message with topic `/controller`
2. _Broker_ process the message with _controller_ plugin
3. _Broker_ publish the message after processing

### Use Case
(fixme)


