# Introduction

## Glossary

_<font color="gray">
&lt;Define all the terms necessary to properly interpret the SRS, including acronyms and abbreviations. You may wish to build a separate glossary that spans multiple projects or the entire organization, and just include terms specific to a single project in each SRS.&gt;
</font>_


## Purpose
_<font color="gray">
&lt;Identify the product whose software requirements are specified in this document, including the revision or release number. Describe the scope of the product that is covered by this SRS, particularly if this SRS describes only part of the system or a single subsystem.&gt;
</font>_

This SRS describes the software requirements and specifications of MXcloud. It explains the functional features of MXcloud, along with interface details, design constraints and related considerations such as performance characteristics.

## Intended Audience and Reading Suggestions

_<font color="gray">
&lt;Describe the different types of reader that the document is intended for, such as developers, project managers, marketing staff, users, testers, and documentation writers. Describe what the rest of this SRS contains and how it is organized. Suggest a sequence for reading the document, beginning with the overview sections and proceeding through the sections that are most pertinent to each reader type.&gt;
</font>_

1. BDM who joins the requirement discussion with end customers.
2. PM  who plan and define the end product specification.
3. Software engineers who will join the development of all  or part of the system.
4. Testers who will join the test of all  or part of the system.

## Project Scope

_<font color="gray">
&lt;Provide a short description of the software being specified and its purpose, including relevant benefits, objectives, and goals. Relate the software to corporate goals or business strategies. If a separate vision and scope document is available, refer to it rather than duplicating its contents here. An SRS that specifies the next release of an evolving product should contain its own scope statement as a subset of the long-term strategic product vision.&gt;
</font>_

The software system to be produced includes the firmware for the CG (cloud gateway).Therefore, the scope will cover the functions list within CG include the following main categories:
1. Configurable MODBUS Framework
2. Data Logging
3. Basic Device Management
    1. Ethernet Configuration
    2. Cellular Configuration
    3. System Time Configuration
    4. Logging Subsystem Configuration
4. Cellular Router
    1. Ethernet/Serial to Cellular or Cellular to Ethernet/Serial
    2. Port Forwarding

## References

_<font color="gray">
&lt;List any other documents or Web addresses to which this SRS refers. These may include user interface style guides, contracts, standards, system requirements specifications, use case documents, or a vision and scope document. Provide enough information so that the reader could access a copy of each reference, including title, author, version number, date, and source or location.&gt;
</font>_

MODBUS APPLICATION PROTOCOL SPECIFICATION V1.1b

