# Quality Attributes

_<font color="gray">
&lt;This section specifies nonfunctional requirements other than constraints, which are recorded in section 2.4, and external interface requirements, which appear in section 3. These quality requirements should be specific, quantitative, and verifiable. Indicate the relative priorities of various attributes, such as ease of use over ease of learning, or security over performance. A rich specification notation such as Planguage clarifies the needed levels of each quality much better than can simple descriptive statement.&gt;
</font>_

## Usability

_<font color="gray">
&lt;Usability requirements deal with ease of learning, ease of use, error avoidance and recovery, efficiency of interactions, and accessibility. The usability requirements specified here will help the user interface designer create the optimum user experience.&gt;
</font>_

## Performance

_<font color="gray">
&lt;State specific performance requirements for various system operations. If different functional requirements or features have different performance requirements, it’s appropriate to specify those performance goals right with the corresponding functional requirements, rather than collecting them in this section.&gt;
</font>_

PQ-1 Should support at least 5 MODBUS equipments.

PQ-2 Should support at least 20 tags per equipment.

PQ-3 Should support at least 5 log-profiles.

PQ-4 Should support at least 32 tags per log-profile.

## Safety

_<font color="gray">
&lt;Specify requirements that are concerned with possible loss, damage, or harm that could result from use of the product. Define any safeguards or actions that must be taken, as well as potentially dangerous actions that must be prevented. Identify any safety certifications, policies, or regulations to which the product must conform.&gt;
</font>_


## Security Requirements
_<font color="gray">
&lt;Specify any requirements regarding security or privacy issues that restrict access to or use of the product. These could refer to physical, data, or software security. Security requirements often originate in business rules, so identify any security or privacy policies or regulations to which the product must conform. If these are documented in a business rules repository, just refer to them.&gt;
</font>_

## Availability

_<font color="gray">
&lt;Availability is a measure of the planned up time during which the system’s services are available for use and fully operational. Formally, availability equals the ratio of up time to the sum of up time and down time.&gt;
</font>_

## Interoperability

_<font color="gray">
&lt;Interoperability indicates how readily the system can exchange data and services with other software systems and how easily it can integrate with external hardware devices. To assess interoperability, you need to know which other applications the users will employ in conjunction with your product and what data they expect to exchange.&gt;
</font>_

## Modifiability

_<font color="gray">
&lt;Modifiability addresses how easily the software designs and code can be understood, changed, and extended.&gt;
</font>_

## Testability

_<font color="gray">
&lt;Testability refers to how well software components or the integrated product can be evaluated to demonstrate whether the system functions as expected. Designing for testability is critical if the product has complex algorithms and logic, or if it contains subtle functionality interrelationships. Testability is also important if the product will be modified often, because it will undergo frequent regression testing to determine whether the changes damaged any existing functionality.&gt;
</font>_

## [Others]

_<font color="gray">
&lt;Create a separate section in the SRS for each additional product quality attribute to describe characteristics that will be important either to customers or to developers and maintainers. Possibilities include efficiency, installability, integrity, portability, reliability, reusability, robustness, and scalability.&gt;
</font>_

