(function() {
  'use strict';

  angular.module('webapp')
    .controller('TemplateGeneratorTagAddController', TemplateGeneratorAddTagController);

  function TemplateGeneratorAddTagController(
    $log,
    $scope,
    $filter,
    _,
    notificationService
  ) {

    var vm = this;
    var sanjiWindowMgr = $scope.sanjiWindowMgr;
    var tagData = {};

    vm.newTag = {
      quantity: 1,
      function: 'read-coils',
      type: 'UINT16',
      enableAutoScaling: false,
      autoScalingMode: 'intercept'
    };
    vm.invalidValues = [];
    vm.submit = submit;
    vm.changeType = changeType;

    $scope.vm = vm;

    activate();

    function activate() {
      var unQuantityWatcher = $scope.$watch('vm.newTag.quantity', function(newVal, oldVal) {
        if (!newVal && newVal === oldVal) {
          return;
        }

        var i = 0;
        vm.invalidValues.splice(0, vm.invalidValues.length);
        while(i < newVal) {
          vm.invalidValues.push({value: 0});
          i++;
        }
      });

      $scope.$on('$destroy', function() {
        unQuantityWatcher();
      });
    }

    function submit(tag) {
      var data = angular.copy(tag);

      if (0 < vm.invalidValues.length) {
        data.invalidValue = _.pluck(vm.invalidValues, 'value');
      }

      if (!_.isEmpty(tagData)) {
        angular.extend(tagData, data);
      }
      else {
        angular.extend(tagData, data);
        sanjiWindowMgr.tempTagList.push(tagData);
      }
      notificationService.success(
        $filter('translate')('ADD_TAG_DATA_SUCCESS'),
        'bottom_right'
      );

      sanjiWindowMgr.goBack();
    }

    function changeType(type) {
      if ('boolean' === type) {
        vm.newTag.quantity = 1;
      }
    }

  }
})();
