'use strict';

(function() {

  angular.module('webapp')
    .controller('App', App);

  function App(
    $controller,
    $scope,
    $window,
    $log,
    fullscreenService,
    userProvider,
    _
  ) {

    $scope.tokenUser = {};

    if (userProvider.hasProfile()) {
      $scope.tokenUser = userProvider.getTokenUser();
    }

    $scope.$on('profile::change', function() {
      $scope.tokenUser = userProvider.getTokenUser();
    });

    $scope.isFullscreen = false;

    var fullscreenMgr = {
      toggleFullscreen: function() {
        $scope.isFullscreen = ! $scope.isFullscreen;
        fullscreenService.toggleFullscreen();
      }
    };

    $scope.AppMgr = {
      fullscreenMgr: fullscreenMgr
    };

    $scope.logout = function() {
      userProvider.logout();
      $window.location.href = '/login';
    };
  }
})();
