/*globals alert*/
'use strict';

(function() {

  angular.module('webapp')
  .controller('CloudGatewaysSettings', CloudGatewaysSettings);

  function CloudGatewaysSettings($scope, deviceInfo, ngDialog, SystemService) {
    var vm = this;
    vm.status = deviceInfo;
    vm.submit = submit;
    vm.openEditHostNameDialog = openEditHostNameDialog;

    $scope.vm = vm;

    function openEditHostNameDialog() {
      ngDialog.open({
        template: 'hostname-form.html',
        scope: $scope
      });
    }

    function submit(hostname) {
      SystemService.update({
        hostname: hostname
      })
      .then(function(data) {
        vm.status.hostname = data.hostname;
        ngDialog.close();
      });
    }
  }
})();
