'use strict';

(function() {

  angular.module('webapp')
    .controller('CloudGateways', CloudGateways);

  function CloudGateways(
    $log,
    $scope,
    $filter,
    columnSetting,
    settingsFactory,
    _,
    deviceInfo,
    mode,
    ngDialog,
    SystemService
  ) {

    var vm = this;
    var key = 'page:cloud-gateway:info';
    var pageComputerInfo = columnSetting(key);
    var settings = angular.copy(pageComputerInfo.getOneColumnSettings());

    // Retreive cpu, memory and disk
    vm.systemcharts = _.remove(settings, function(item) {
      switch(item.id) {
        case 'cpu':
        case 'memory':
        case 'disk':
        case 'management-map':
          return true;
        default:
          return false;
      }
    });
    vm.status = deviceInfo;
    vm.windows = 'cellular-router' === mode.enableMode ? _.filter(settings, getRelay) : _.filter(settings, getModbus);
    vm.submit = submit;
    vm.openEditHostNameDialog = openEditHostNameDialog;

    $scope.vm = vm;

    function getRelay(item) {
      return 'relay' === item.id;
    }

    function getModbus(item) {
      return 'relay' !== item.id;
    }

    function openEditHostNameDialog() {
      ngDialog.open({
        template: 'hostname-form.html',
        scope: $scope
      });
    }

    function submit(hostname) {
      SystemService.update({
        hostname: hostname
      })
      .then(function(data) {
        vm.status.hostname = data.hostname;
        ngDialog.close();
      });
    }
  }
})();
