'use strict';

(function() {

  angular.module('webapp')
    .config(config);

  function config($stateProvider, routeConfigFuncProvider) {

    $stateProvider.state('loginSuccess.computerInfo', {
      url: '/cloudGateway',
      views: {
        'main@loginSuccess': {
          templateUrl: '/app/cloudgateways/cloudgateways.html',
          resolve: {
            deviceInfo: routeConfigFuncProvider.getDeviceInfo,
            mode: routeConfigFuncProvider.getModeInfo
          },
          controller: 'CloudGateways',
          controllerAs: 'vm'
        }
      }
    })
    .state('loginSuccess.computerInfo.computerSettings', {
      abstract: true,
      url: '/settings',
      views: {
        'main@loginSuccess': {
          templateUrl: '/app/cloudgateways/cloudgateways-settings.html',
          resolve: {
            deviceInfo: routeConfigFuncProvider.getDeviceInfo
          },
          controller: 'CloudGatewaysSettings',
          controllerAs: 'vm'
        }
      },
      data: {
        proxy: 'loginSuccess.computerInfo.computerSettings.detail'
      }
    })
    .state('loginSuccess.computerInfo.computerSettings.detail', {
      url: '/:name?i18n',
      templateUrl: '/app/cloudgateways/cloudgateways-settingslist-detail.html',
      controller: 'CloudGatewaysSettingsListDetail',
      resolve: {
        name: function($stateParams) {
          return ($stateParams.i18n) ? $stateParams.i18n : $stateParams.name;
        }
      },
      data: {
        displayName: '{{name}}'
      }
    });
  }

})();
