'use strict';

angular.module('webapp')
.directive('langSelect', function(
  userProvider,
  $translate
) {

  return {
    templateUrl: '/template/lang-select.html',
    restrict: 'EA',
    scope: {},
    controller: function($scope) {

      var storageLang = userProvider.getLanguage(),
          browserLang = navigator.language || navigator.userLanguage;

      $scope.language = storageLang ? storageLang : browserLang;

      $scope.switchLanguage = function() {
        userProvider.setLanguage($scope.language);
        $translate.use($scope.language);
      };
    }
  };

});
