;(function() {
  'use strict';

  angular.module('webapp')
    .directive('mxCloudConfig', mxCloudConfig)
    .config(function($provide) {
      $provide.decorator('mxCloudConfigDirective', function($delegate, $injector) {
        var directive = $delegate[0];
        directive.compile = function() {
          return function(scope, element, attrs) {
            var config = scope.$eval(
              attrs.mxCloudConfig || { env: 'development', mqttBridge: false, isMock: true }
            );
            // Overwite cloud config
            $provide.constant('CLOUD_CONFIG', config);
            if (config.isMock) {
              var API_BASE = $injector.get('API_BASE');
              API_BASE.ami = '//private-a01bb-sanjiami.apiary-mock.com';
              API_BASE.generic = '//private-d8e84-sanjigeneric.apiary-mock.com';
            }
          };
        };
        return $delegate;
      });
    });

  function mxCloudConfig() {
    return {
      restrict: 'A'
    };
  }

}());
