'use strict';

angular.module('webapp')
.directive('mxFlashClick', function () {
  return {
    restrict: 'A',
    link: function(scope, element) {

      var jqCheckboxFlash, parent;

      if (0 === element.prev('.checkbox-flash').length) {
        element.before('<span class="checkbox-flash"></span>');
      }

      jqCheckboxFlash = element.prev('.checkbox-flash');
      parent = element.parent();

      element.click(function(e) {

        jqCheckboxFlash.removeClass('animate');

        var x = e.pageX - parent.offset().left - jqCheckboxFlash.width() / 2,
            y = e.pageY - parent.offset().top - jqCheckboxFlash.height() / 2;

        // prevent effect on label click
        if (x <= 0) {
          jqCheckboxFlash.css({top: y + 'px', left: x + 'px'}).addClass('animate');
        }
      });
    }
  };
});
