'use strict';

angular.module('webapp')
.directive('mxRippleClick', function () {
  return {
    restrict: 'A',
    link: function(scope, element) {

      var parent, ink, inkInner, d, x, y;
      element.click(function(e){

        parent = element.parent();

        if (0 === parent.find('.ink-inner').length) {
          parent.prepend('<span class="ink-inner"></span>');
        }
        // create .ink element if it doesn't exist
        if (0 === parent.find('.ink').length) {
          parent.prepend('<span class="ink"></span>');
        }

        ink = parent.find('.ink');
        inkInner = parent.find('.ink-inner');

        // incase of quick double clicks stop the previous animation
        ink.removeClass('animate');
        inkInner.removeClass('animate');

        //set size of .ink
        if (! ink.height() && ! ink.width()) {
          // use parent's width or height whichever is larger for the
          // diameter to make a circle which can cover the entire element.
          d = Math.max(parent.outerWidth(), parent.outerHeight());
          ink.css({height: d, width: d});
        }

        if (! inkInner.height() && ! inkInner.width()) {
          d = Math.max(parent.outerWidth(), parent.outerHeight());
          inkInner.css({height: d, width: d});
        }

        // get click coordinates
        // logic = click coordinates relative to page - parent's position
        // relative to page - half of self height/width to make it controllable from the center;
        x = e.pageX - parent.offset().left - ink.width() / 2;
        y = e.pageY - parent.offset().top - ink.height() / 2;

        //set the position and add class .animate
        ink.css({top: y + 'px', left: x + 'px'}).addClass('animate');
        inkInner.css({top: y + 'px', left: x + 'px'}).addClass('animate');
      });
    }
  };
});
