;(function() {
  'use strict';

  angular.module('webapp')
    .directive('navbar', navbar);

  function navbar(
    $state,
    userProvider,
    ngDialog
  ) {

    return {
      templateUrl: '/template/mx/navbar.html',
      restrict: 'EA',
      controllerAs: 'Navbar',
      controller: Navbar,
      replace: true
    };

    function Navbar($scope) {
      var vm = this;

      vm.openTemplate = openTemplate;
      vm.profileImage = userProvider.getProfileImage();

      init();

      function init() {
        $scope.$on('user::profile::image::change', function() {
          vm.profileImage = userProvider.getProfileImage();
        });
      }

      function openTemplate(path) {
        ngDialog.open({
          template: path,
          scope: $scope
        });
      }

    }
  }

})();
