'use strict';

angular.module('webapp')
.directive('tabWhenFulfill', function () {
  return {
    restrict: 'A',
    link: function(scope, element) {

      var shiftKeyHolding = false;

      element.on('keydown', function(e) {

        if (16 === e.keyCode) {
          shiftKeyHolding = true;
        }

        // tab key
        if ((9 === e.keyCode) && !element.hasClass('ng-valid') && !shiftKeyHolding) {
          e.preventDefault();
        }
      });

      element.on('keyup', function(e) {

        // shift key
        if (16 === e.keyCode) {
          shiftKeyHolding = false;
        }
      });
    }
  };
});
