'use strict';

angular.module('webapp')
.filter('timezone', function () {

  return function(input) {

    var str = '';

    switch (input) {
      case '-12:00,0':
        str = '(-12:00) International Date Line West';
        break;
      case '-11:00,0':
        str = '(-11:00) Midway Island, Samoa';
        break;
      case '-10:00,0':
        str = '(-10:00) Hawaii';
        break;
      case '-09:00,1':
        str = '(-09:00) Alaska';
        break;
      case '-08:00,1':
        str = '(-08:00) Pacific Time (US &amp; Canada)';
        break;
      case '-07:00,0':
        str = '(-07:00) Arizona';
        break;
      case '-07:00,1':
        str = '(-07:00) Mountain Time (US &amp; Canada)';
        break;
      case '-06:00,0':
        str = '(-06:00) Central America, Saskatchewan';
        break;
      case '-06:00,1':
        str = '(-06:00) Central Time (US &amp; Canada), Guadalajara, Mexico city';
        break;
      case '-05:00,0':
        str = '(-05:00) Indiana, Bogota, Lima, Quito, Rio Branco';
        break;
      case '-05:00,1':
        str = '(-05:00) Eastern time (US &amp; Canada)';
        break;
      case '-04:00,1':
        str = '(-04:00) Atlantic time (Canada), Manaus, Santiago';
        break;
      case '-04:00,0':
        str = '(-04:00) Caracas, La Paz';
        break;
      case '-03:30,1':
        str = '(-03:30) Newfoundland';
        break;
      case '-03:00,1':
        str = '(-03:00) Greenland, Brasilia, Montevideo';
        break;
      case '-02:00,1':
        str = '(-02:00) Mid-Atlantic';
        break;
      case '-01:00,1':
        str = '(-01:00) Azores';
        break;
      case '-01:00,0':
        str = '(-01:00) Cape Verde Is.';
        break;
      case '-00:00,0':
        str = '(00:00) Casablanca, Monrovia, Reykjavik';
        break;
      case '-00:00,1':
        str = '(00:00) GMT: Dublin, Edinburgh, Lisbon, London';
        break;
      case '+01:00,1':
        str = '(+01:00) Amsterdam, Berlin, Rome, Vienna, Prague, Brussels';
        break;
      case '+01:00,0':
        str = '(+01:00) West Central Africa';
        break;
      case '+02:00,1':
        str = '(+02:00) Amman, Athens, Istanbul, Beirut, Cairo, Jerusalem';
        break;
      case '+02:00,0':
        str = '(+02:00) Harare, Pretoria';
        break;
      case '+03:00,1':
        str = '(+03:00) Baghdad, Moscow, St. Petersburg, Volgograd';
        break;
      case '+03:00,0':
        str = '(+03:00) Kuwait, Riyadh, Nairobi, Tbilis';
        break;
      case '+03:30,0':
        str = '(+03:30) Tehran';
        break;
      case '+04:00,0':
        str = '(+04:00) Abu Dhadi, Musca';
        break;
      case '+04:00,1':
        str = '(+04:00) Baku, Yerevan';
        break;
      case '+04:30,0':
        str = '(+04:30) Kabul';
        break;
      case '+05:00,1':
        str = '(+05:00) Ekaterinburg';
        break;
      case '+05:00,0':
        str = '(+05:00) Islamabad, Karachi, Tashkent';
        break;
      case '+05:30,0':
        str = '(+05:30) Chennai, Kolkata, Mumbai, New Delhi, Sri Jayawardenepura';
        break;
      case '+05:45,0':
        str = '(+05:45) Kathmandu';
        break;
      case '+06:00,0':
        str = '(+06:00) Astana, Dhaka';
        break;
      case '+06:00,1':
        str = '(+06:00) Almaty, Nonosibirsk';
        break;
      case '+06:30,0':
        str = '(+06:30) Yangon (Rangoon)';
        break;
      case '+07:00,1':
        str = '(+07:00) Krasnoyarsk';
        break;
      case '+07:00,0':
        str = '(+07:00) Bangkok, Hanoi, Jakarta';
        break;
      case '+08:00,0':
        str = '(+08:00) Beijing, Hong Kong, Singapore, Taipei';
        break;
      case '+08:00,1':
        str = '(+08:00) Irkutsk, Ulaan Bataar, Perth';
        break;
      case '+09:00,1':
        str = '(+09:00) Yakutsk';
        break;
      case '+09:00,0':
        str = '(+09:00) Seoul, Osaka, Sapporo, Tokyo';
        break;
      case '+09:30,0':
        str = '(+09:30) Darwin';
        break;
      case '+09:30,1':
        str = '(+09:30) Adelaide';
        break;
      case '+10:00,0':
        str = '(+10:00) Brisbane, Guam, Port Moresby';
        break;
      case '+10:00,1':
        str = '(+10:00) Canberra, Melbourne, Sydney, Hobart, Vladivostok';
        break;
      case '+11:00,0':
        str = '(+11:00) Magadan, Solomon Is., New Caledonia';
        break;
      case '+12:00,1':
        str = '(+12:00) Auckland, Wellington';
        break;
      case '+12:00,0':
        str = '(+12:00) Fiji, Kamchatka, Marshall Is.';
        break;
      case '+13:00,0':
        str = '(+13:00) Nuku\'alofa';
        break;
      default:
        break;
    }
    return str;
  };

});
