(function() {
  'use strict';

  angular.module('webapp')
    .controller('Dns', Dns);

  function Dns($scope, DnsService) {
    var vm = this; // vm means ViewModle
    var sanjiWindowMgr = $scope.sanjiWindowMgr;

    vm.info = null;
    vm.edit = null;
    vm.submit = submit;
    vm.activate = activate;
    vm.reload = reload;

    activate();

    // Member function implement
    function activate() {
      DnsService.read()
        .then(function (model) {
          vm.info = model;
          vm.edit = angular.copy(model);
          sanjiWindowMgr.goToInfoState();
        })
        .catch(function () {
          sanjiWindowMgr.goToProblemState();
        });
    }

    function reload() {
      sanjiWindowMgr.goToLoadingState();
      activate();
    }

    function submit(data) {
      sanjiWindowMgr.goToProcessingState();
      DnsService.update(data)
        .then(function () {
          activate();
        })
        .catch(function () {
          sanjiWindowMgr.goToProblemState();
        });
    }
  }
})();
