;(function () {
  'use strict';

  angular.module('webapp')
    .factory('DhcpServerService', DhcpServerService);

  function DhcpServerService(
    $http,
    $q,
    $filter,
    API_BASE,
    _,
    notificationService
  ) {
    // Members definition
    var bundleModel = {};
    var IdRoute = '';

    bundleModel.read = getModel;
    bundleModel.update = updateModel;
    bundleModel.resetRoute = resetRoute;

    return bundleModel;

    // Member function implement
    function resetRoute(route) {
      IdRoute = route;
    }

    function getModel(id) {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/network/dhcpd/' + id)
      $http.get(API_BASE.generic + IdRoute + '/network/dhcpd/' + id)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function updateModel(data) {
      var deferred = $q.defer();
      putModel(data).then(function (data) {
        notificationService.success(
          $filter('translate')('DHCPSERVER_HAS_BEEN_UPDATED_SUCCESSFULLY'),
          'bottom_right'
        );
        deferred.resolve(data);
      })
      .catch(function () {
        notificationService.error(
          $filter('translate')('DHCPSERVER_HAS_BEEN_UPDATED_FAIL'),
          'bottom_right'
        );
        deferred.reject();
      });
      return deferred.promise;
    }

    function putModel(data) {
      var deferred = $q.defer();
      // $http.put('http://localhost:8000/network/dhcpd/' + data.id, data)
      $http.put(API_BASE.generic + IdRoute + '/network/dhcpd/' + data.id, data)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }
  }
}());
