;(function () {
  'use strict';

  angular.module('webapp')
    .factory('SerialService', SerialService);

  function SerialService(
    $http,
    $q,
    $filter,
    $state,
    API_BASE,
    _,
    notificationService
  ) {
    // Members definition
    var bundleModel = {};
    var IdRoute = '';

    bundleModel.readCollection = getCollection;
    bundleModel.read = getModel;
    bundleModel.update = updateModel;

    return bundleModel;

    // Member function implement
    function getCollection() {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/system/serial')
      $http.get(API_BASE.generic + IdRoute + '/system/serial')
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function getModel(id) {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/system/serial/' + id)
      $http.get(API_BASE.generic + IdRoute + '/system/serial/' + id)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function updateModel(id, data) {
      var deferred = $q.defer();
      putModel(id, data).then(function (data) {
        notificationService.success(
          $filter('translate')('SERIAL_UPDATED_SUCCESS'),
          'bottom_right'
        );
        deferred.resolve(data);
      })
      .catch(function () {
        notificationService.error(
          $filter('translate')('SERIAL_UPDATED_FAIL'),
          'bottom_right'
        );
        deferred.reject();
      });
      return deferred.promise;
    }

    function putModel(id, data) {
      var deferred = $q.defer();
      // $http.put('http://localhost:8000/system/serial/' + id, data)
      $http.put(API_BASE.generic + IdRoute + '/system/serial/' + id, data)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }
  }
}());
