;(function () {
  'use strict';

  angular.module('webapp')
    .factory('SystemRebootService', SystemRebootService);

  function SystemRebootService(
    $http,
    $log,
    $q,
    $filter,
    API_BASE,
    _,
    notificationService,
    ngDialog
  ) {
    // Members definition
    var bundleModel = {};
    var IdRoute = '';

    bundleModel.read = getModel;
    bundleModel.update = updateModel;
    bundleModel.blockUI = blockUI;
    bundleModel.closeBlockUI = closeBlockUI;
    bundleModel.resetRoute = resetRoute;

    return bundleModel;

    // Member function implement
    function resetRoute(route) {
      IdRoute = route;
    }

    function getModel() {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/system/reboot')
      $http.get(API_BASE.generic + IdRoute + '/system/reboot')
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function updateModel(data) {
      var deferred = $q.defer();
      putModel(data).then(function (data) {
        deferred.resolve(data);
      });
      return deferred.promise;
    }

    function putModel() {
      var deferred = $q.defer();
      // $http.post('http://localhost:8000/system/reboot')
      $http.post(API_BASE.generic + IdRoute + '/system/reboot')
        .then(function () {
          deferred.resolve();
        })
        .catch(function (res) {
          notificationService.error(
            $filter('translate')('REBOOT_FAIL'),
            'bottom_right'
          );
          deferred.reject(res.data);
        });
      return deferred.promise;
    }

    function blockUI() {
      ngDialog.open({
        templateUrl: 'rebooting.html',
        closeByDocument: false,
        closeByEscape: false,
        showClose: false
      });
    }

    function closeBlockUI() {
      ngDialog.closeAll();
    }

  }
}());
