(function() {
  'use strict';

  angular.module('webapp')
    .controller('AccountEdit', AccountEdit);

  function AccountEdit($scope, appService, userProvider) {

    $scope.current = {};
    $scope.current.user = angular.copy($scope.tokenUser);

    $scope.submit = function() {

      appService.updateUser($scope.current.user)
        .then(function(ret) {

          var user = ret.user;

          userProvider.set('email', user.email);
          userProvider.set('meta', user.meta);

          $scope.tokenUser = userProvider.getTokenUser();
          $scope.closeThisDialog();
        })
        .catch(function(ret) {
          throw new Error(ret);
        });
    };
  }
})();
