'use strict';

angular.module('webapp')
.controller('Login', function(
  $scope,
  userProvider,
  appService,
  $state,
  $filter,
  DEFAULT_STATE,
  notificationService,
  wizardService
) {

  $scope.user = {
    email: '',
    password: ''
  };

  var rememberMeData = userProvider.getRememberMeData();

  if (angular.isObject(rememberMeData)) {
    $scope.user.email = rememberMeData.email;
    $scope.user.rememberMe = true;
  }

  $scope.submit = function() {

    userProvider.login($scope.user)
      .then(function() {
        if ($scope.user.rememberMe) {
          userProvider.setRememberMeData({email: $scope.user.email});
        } else {
          userProvider.setRememberMeData(null);
        }

        wizardService.read()
          .then(function(data) {
            if ('none' === data.enableMode) {
              $state.transitionTo('wizard');
            }
            else {
              $scope.$emit('notification::reload');
              $state.transitionTo(DEFAULT_STATE);
            }
          });
      }, function(ret) {
        notificationService.notifyWithDefaults({
          title: ret.data.message,
          history: false,
          addclass: 'stack-bar-top',
          width: '30%',
          type: 'error'
        });
      });
  };
});
