;(function () {
  'use strict';

  angular.module('webapp')
    .factory('RelayService', RelayService);

  function RelayService(
    $http,
    $q,
    $filter,
    $state,
    API_BASE,
    _,
    notificationService
  ) {
    // Members definition
    var bundleModel = {};

    bundleModel.readCollection = getCollection;
    bundleModel.update = updateModel;

    return bundleModel;

    // Member function implement
    function getCollection() {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/relay')
      $http.get(API_BASE.generic + '/relay')
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function updateModel(data) {
      var deferred = $q.defer();
      putModel(data).then(function (data) {
        notificationService.success(
          $filter('translate')('RELAY_UPDATED_SUCCESS'),
          'bottom_right'
        );
        deferred.resolve(data);
      })
      .catch(function () {
        notificationService.error(
          $filter('translate')('RELAY_UPDATED_FAIL'),
          'bottom_right'
        );
        deferred.reject();
      });
      return deferred.promise;
    }

    function putModel(data) {
      var deferred = $q.defer();
      // $http.put('http://localhost:8000/relay/' + data.id, data)
      $http.put(API_BASE.generic + '/relay/' + data.id, data)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }
  }
}());
