(function() {
  'use strict';

  angular.module('webapp')
    .service('cacheFactory', cacheFactory);

  function cacheFactory($cacheFactory) {

    return function(name) {

      var cache = $cacheFactory.get(name);

      if (! cache) {
        cache = $cacheFactory(name);
      }

      var factory = {
        get: get,
        put: put,
        remove: remove
      };
      return factory;

      function get(key) {
        return cache.get(key);
      }

      function put(key, value) {
        return cache.put(key, value);
      }

      function remove(key) {
        return cache.remove(key);
      }

    };
  }

})();
