;(function () {
  'use strict';

  angular.module('webapp')
    .factory('NetworkService', NetworkService);

  function NetworkService($http, $q, API_BASE, _) {
    // Members definition
    var bundleModel = {};

    bundleModel.readCollection = getCollection;

    return bundleModel;

    // Member function implement
    function getCollection() {
      var deferred = $q.defer();
      $http.get(API_BASE.generic + '/network/interfaces')
        .then(function (res) {
          var tmp = _.map(res.data, function(item) {
            return {
              label: item,
              value: item
            };
          });
          deferred.resolve(tmp);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }
  }
}());
