
'use strict';

angular.module('webapp')
.service('objectService', function(
  _,
  $q,
  computerService,
  equipmentService
) {

  var self = this;

  self.getObjects = function(type, params) {

    var deferred = $q.defer();
    var fetch = angular.noop;

    switch (type) {
      case 1:    // CG
        fetch = computerService.getComputers;
        break;
      case 2:    // Equipment
        fetch = equipmentService.getEquipments;
        break;
    }

    fetch(params)
      .then(function(collection) {
        // ret.objects = ret.equipments || ret.computers;
        // _.each(ret.objects, function(row) {
          // row.objectId = row.computerId || row.equipmentId;
        // });
        deferred.resolve(collection);
      });

    return deferred.promise;
  };

  /**
   * objectIdExists check Object ID exists
   *
   * @param objectId
   * @param ids
   * @return {undefined}
   */
  self.objectIdExists = function(objectId, ids) {
    return !! _.find(ids, function(id) {
      return objectId === id;
    });
  };

});
