'use strict';

(function() {
  angular.module('webapp')
    .provider('userProvider', function () {

    var self = this;

    self.$get = function($rootScope, $resource, $q, $state, $http, localStorageService, $log, _, API_BASE) {

      var activeProfile = localStorageService.get('activeProfile'),
          tokenUser = {},
          obj;

      obj = {
        activeProfile: activeProfile,
        currentProject: null,
        setLanguage: function(data) {
          return localStorageService.set('language', data);
        },
        getLanguage: function() {
          return localStorageService.get('language');
        },
        setRememberMeData: function(data) {
          return localStorageService.set('rememberMeData', data);
        },
        getRememberMeData: function() {
          return localStorageService.get('rememberMeData');
        },
        hasProfile: function() {
          return angular.isObject(obj.activeProfile);
        },
        getTokenUser: function() {

          tokenUser.id = obj.get('userId');
          tokenUser.email = obj.get('email');
          tokenUser.meta = obj.getMetaData();

          return tokenUser;
        },
        login: function(user) {

          var Login = $resource(API_BASE.other + '/login');

          // var login = new Login({email: user.email, password: user.password});
          // login.$save();
          return Login.save({email: user.email, password: user.password})
            .$promise.then(function(ret) {
              obj.activeProfile = ret;

              localStorageService.set('activeProfile', ret);
              $http.defaults.headers.common['X-Mx-AccessToken'] = ret.accessToken;

              $rootScope.$broadcast('profile::change');
            });

          // var deferred = $q.defer();

          // Restangular.all('login').post({
            // email: user.email,
            // password: user.password
          // }).then(function(ret) {

            // obj.activeProfile = ret;

            // localStorageService.set('activeProfile', ret);
            // $http.defaults.headers.common['X-Mx-AccessToken'] = ret.accessToken;

            // $rootScope.$broadcast('profile::change');

            // deferred.resolve(ret);
          // },
          // function(ret) {
            // deferred.reject(ret);
          // });

          // return deferred.promise;
        },
        logout: function() {
          localStorageService.set('activeProfile', null);
          $http.defaults.headers.common['X-Mx-AccessToken'] = null;
          obj.activeProfile = null;
          obj.currentProject = null;
        },
        getMetaData: function() {
          obj.activeProfile.meta.image = obj.getProfileImage();

          return obj.activeProfile.meta;
        },
        getProfileImage: function() {
          var defaultProfileImage, profileImage;
          defaultProfileImage = '/assets/images/raw/avatar.png';
          profileImage = obj.activeProfile.meta.image;
          return _.isEmpty(profileImage) ? defaultProfileImage : profileImage;
        },
        getChannelCharts: function() {
          return (obj.activeProfile) ? obj.activeProfile.meta.channelChart : {};
        },
        set: function(key, value) {
          obj.activeProfile[key] = value;
          localStorageService.set('activeProfile', obj.activeProfile);
          return obj;
        },
        get: function(key) {
          return obj.activeProfile[key];
        }
      };
      return obj;
    };
  });
})();
