'use strict';

angular.module('webapp')
.service('validateService', function() {

  var self = this;

  self.checkPassword = function(value) {

    var minlength, maxlength, lengthValid, hasLetter, hasNumber;

    minlength = 6;
    maxlength = 100;

    lengthValid = (value && (value.length >= minlength && value.length <= maxlength));

    if (! lengthValid) {
      return {
        error: true,
        lengthInvalid: true,
        message: 'Password should be at least ' + minlength + ' characters long'
      };
    }

    hasLetter = (value && /[a-zA-Z]/.test(value));

    if (! hasLetter) {
      return {
        error: true,
        hasLetterInvalid: true,
        message: 'Password should have at least one letter'
      };
    }

    hasNumber = (value && /\d/.test(value));

    if (! hasNumber) {
      return {
        error: true,
        hasNumberInvalid: true,
        message: 'Password should have at least one number'
      };
    }

    return {
      error: false,
      message: ''
    };
  };

});
