(function() {
  'use strict';

  angular.module('webapp')
    .controller('Wizard', Wizard);

  function Wizard(moment, ngDialog, $state, wizardService, DEFAULT_STATE) {
    var vm = this;

    vm.chooseMode = chooseMode;

    function chooseMode(name) {
      openLoadingDialog();
      wizardService.update({enableMode: name})
        .then(function() {
          ngDialog.close();
          $state.go(DEFAULT_STATE);
        });
    }

    function openLoadingDialog() {
      ngDialog.open({
        templateUrl: 'wizard-loading.html',
        closeByDocument: false,
        closeByEscape: false,
        showClose: false
      });
    }
  }

})();
