(function() {
  'use strict';

  angular.module('webapp')
    .config(config);

  function config($stateProvider) {

    $stateProvider.state('wizard', {
      url: '/wizard',
      templateUrl: '/app/wizard/wizard.html',
      controller: 'Wizard',
      controllerAs: 'vm',
      resolve: {
        mode: function(wizardService, $state, $q, DEFAULT_STATE) {
          var deferred = $q.defer();
          wizardService.read()
            .then(function(data) {
              if ('none' !== data.enableMode) {
                $state.go(DEFAULT_STATE);
                deferred.reject();
              }
              else {
                deferred.resolve(data);
              }
            });
          return deferred.promise;
        }
      }
    });
  }

})();
