;(function () {
  'use strict';

  angular.module('webapp')
    .factory('wizardService', WizardService);

  function WizardService(
    $http,
    $q,
    API_BASE,
    localStorageService,
    _
  ) {
    // Members definition
    var bundleModel = {};
    var mode = localStorageService.get('mode');

    bundleModel.read = getModel;
    bundleModel.update = putModel;

    return bundleModel;

    // Member function implement
    function getModel() {
      var deferred = $q.defer();
      // $http.get('http://localhost:8000/system/mode')
      $http.get(API_BASE.generic + '/system/mode')
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function putModel(data) {
      var deferred = $q.defer();
      // $http.put('http://localhost:8000/system/mode', data)
      $http.put(API_BASE.generic + '/system/mode', data)
        .then(function (res) {
          deferred.resolve(res.data);
        })
        .catch(function () {
          deferred.reject();
        });
      return deferred.promise;
    }

    function setMode(name) {
      mode = name;
      localStorageService.set('mode', name);
    }

    function getMode() {
      return mode;
    }
  }
}());
