'use strict';

var gulp = require('gulp');
var browserSync = require('browser-sync');
var nodemon = require('gulp-nodemon');
var openBrowser = require('gulp-open');

function browserSyncInit(baseDir, files, browser) {

  browser = browser === undefined ? 'default' : browser;

  browserSync({
    files: files,
    // proxy: 'localhost:5000',
    browser: browser,
    ghostMode: false
  }, function() {

    gulp.src('client/index.html')
      .pipe(openBrowser('', {
        url: 'http://localhost:5000',
        app: 'google chrome'})
      );

  });
}

gulp.task('nodemon', function(cb) {

  var called = false;

  return nodemon({
    script: 'server/app.js',
    watch: ['server'],
    execMap: {
      js: "node --debug"
    },
  }).on('start', function() {
    if (! called) {
      cb();
      called = true;
    }
  });
});

gulp.task('serve', ['nodemon', 'watch'], function () {
  browserSyncInit([
    'client',
    '.tmp'
  ], [
    'client/*.html',
    'client/*/**.html',
    '.tmp/styles/**/*.css',
    'client/app/**/*.js',
    'client/assets/images/**/*'
  ]);
});

gulp.task('serve:dist', ['build'], function () {
  browserSyncInit('dist');
});

gulp.task('serve:e2e', function () {
  browserSyncInit(['client', '.tmp'], null, []);
});

gulp.task('serve:e2e-dist', ['watch'], function () {
  browserSyncInit('dist', null, []);
});
