#!/bin/bash

if [ -z "$1" ]; then
  echo 'Specify build enviroment' >&2;
  exit 1;
fi

if [ -z "$2" ]; then
  echo 'Specify container prefix name' >&2;
  exit 1;
fi

if [ -z "$3" ]; then
  echo 'Specify project path' >&2;
  exit 1;
fi

if [ -d "/tmp/$2-mxcloud-python-bundles" ]; then
  echo "/tmp/$2-mxcloud-python-bundles directory exists."
else
  git clone https://github.com/Sanji-IO/mxcloud-python-bundles.git "/tmp/$2-mxcloud-python-bundles"
fi

docker run --name "$2-mysql"\
  -e MYSQL_ROOT_PASSWORD=root\
  -e MYSQL_USER=moxa\
  -e MYSQL_PASSWORD=moxa\
  -e MYSQL_DATABASE=mxcloud\
  -d mysql

if [ "test" != "$1" ]; then
  docker run --name "$2-mosquitto" -p :1883 -d sanji/docker-mosquitto
  docker run -p :5000\
    --link "$2-mosquitto:broker"\
    --link "$2-mysql:mysql"\
    --name "$2-app"\
    -v "$3:/root/project"\
    -v "/tmp/$2-mxcloud-python-bundles/bundles:/root/bundles"\
    -d sanji/docker-staging-web
else
  if [  -z "$4" ]; then
    docker run -p :5000\
      --link "$2-mysql:mysql"\
      --name "$2-app"\
      -v "$3:/root/project"\
      -v "/tmp/$2-mxcloud-python-bundles/bundles:/root/bundles"\
      -e "ISMOCK=true"\
      -e "MQTT_BRIDGE_MODE=false"\
      -d sanji/docker-staging-web
  else
    docker run -p :5000\
      --link "$2-mysql:mysql"\
      --name "$2-app"\
      -v "$3:/root/project"\
      -v "/tmp/$2-mxcloud-python-bundles/bundles:/root/bundles"\
      -e "BROKER_PORT_1883_TCP_ADDR=$4"\
      -d sanji/docker-staging-web
  fi
fi
