'use strict';

var express = require('express');
var controller = require('./user.controller');
var router = express.Router();

router.get(
  '/',
  controller.findTokenData,
  controller.findTokenUser,
  controller.listUsers
);

router.get(
  '/:userId',
  controller.findTokenData,
  controller.findTokenUser,
  controller.findUser,
  controller.getUser
);

router.put(
  '/:userId',
  controller.findTokenData,
  controller.findTokenUser,
  controller.findUser,
  controller.checkUpdateUser,
  controller.updateUser
);

router.put(
  '/:userId/meta',
  controller.findTokenData,
  controller.findTokenUser,
  controller.findUser,
  controller.checkUpdateUser,
  controller.updateMetaData
);

module.exports = router;
