
var log = require('sanji-logger')('webapp'),
    path = require('path'),
    Promise = require('bluebird'),
    preInsert = require(__dirname + '/preInsert'),
    db = require(__dirname + '/../../models'),
    User = db.User,
    UserEav = db.UserEav,
    UserLog = db.UserLog;

module.exports = function(options) {

  options.force = options.force || false;
  options.preInsert = options.preInsert || false;

  User.hasOne(UserEav);
  User.hasMany(UserLog);

  return db.sequelize.sync({force: options.force})
    .then(function() {
      log.info('sync table success');
      if (options.preInsert) {
        return preInsert();
      }

      return Promise.resolve();
    });
};
