var config = require(__dirname + '/../config/config');
var fs = require('fs');
var Sequelize = require('sequelize');
var _ = require('lodash');
var db = {};
var log = require('sanji-logger')('webapp');
var modelPath = __dirname;
var path = require('path');

/***************************  Database Configs ******************************/

var dbname = 'webapp';
var user = 'moxa';
var password = 'moxa';

var host = config.dbIp;
var port = config.dbPort;

var logging = false;

if (('development' === process.env.NODE_ENV || 'debug' === process.env.NODE_ENV)
    && process.env.PRINT_SQL) {
  logging = function(str) {
    log.info(str);
  };
}

var sequelize = new Sequelize(dbname, user, password, {
  dialect: 'sqlite',
  host: host,
  storage: path.join(modelPath, '/../webapp.db'),
  logging: logging
});

/****************************************************************************/

fs.readdirSync(modelPath)
  .filter(function(file) {
    var suffix = '.js';
    return (-1 !== file.indexOf(suffix, file.length - suffix.length)) && ('index.js' !== file);
  })
  .forEach(function(file) {
    var model = sequelize.import(path.join(modelPath, file));
    db[model.name] = model;
  });

module.exports = _.extend({
  sequelize: sequelize,
  Sequelize: Sequelize
}, db);
