'use strict';

var _ = require('lodash'),
    log = require('sanji-logger')('webapp'),
    ip = require('ip'),
    moment = require('moment'),
    UserLog;

module.exports = function(sequelize, DataTypes) {

  UserLog = sequelize.define('UserLog', {
    UserId: {type: DataTypes.INTEGER},
    action: {type:  DataTypes.TEXT},
    ip: {
      type: DataTypes.BIGINT,
      unsigned: true,
      defaultValue: 0,
      set: function(value) {
        if (_.isString(value)) {
          value = ip.toLong(value);
        }
        return this.setDataValue('ip', value);
      },
      get: function() {
        return ip.fromLong(this.getDataValue('ip'));
      }
    }
  });

  return UserLog;
};
